#!/usr/bin/python
# -*- coding: Utf-8 -*-

'''
-----------------------------------------------------------------------
GPL v3
-----------------------------------------------------------------------
EKD can be used to make post production operations for video files and images.
Copyright (C) 2008 Lama Angelo (the historical developer of the 
program) with the contribution of Romain (alteo_gange) and Jean-Rémy 
Bancel to this 2008 version of EKD.

EKD is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free 
Software Foundation; either version 3 of the License, or (at your 
option) any later version.

EKD is distributed in the hope that it will be useful, but WITHOUT 
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License 
for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, see http://www.gnu.org/licenses
or write to the Free Software Foundation,Inc., 51 Franklin Street,
Fifth Floor, Boston, MA 02110-1301  USA

To contact the developpers of EKD, go here: 
http://ekd.tuxfamily.org/forum/forumdisplay.php?fid=8
-----------------------------------------------------------------------
'''

import os

def verifAppliManquante():
	"""# -------------------------------------
	# Dépendances ...
	# Vérification de la présence des logs
	# indispensables au lancement d'EKD
	# -------------------------------------"""
	
	print ""
	
	commandesBash = ['mplayer', 'mencoder', 'composite', 'ffmpeg', 'ffmpeg2theora', 'lame']
	manquantes = []
	
	all = ['pyqt4', 'python imaging library', 'numpy', 'mplayer', 'mencoder',\
		'imagemagick', 'ffmpeg', 'ffmpeg2theora', 'lame']
	
	for commande in commandesBash:
		resultat = os.popen("which " + commande).readline()
		if not resultat:
			if commande == 'composite': manquantes.append('imagemagick')
			else: manquantes.append(commande)
	
	try: from PyQt4 import QtGui, QtCore
	except ImportError, e:
		manquantes.append('python-qt4')
		print "ImportError:", e
	
	try: from numpy import lib
	except ImportError, e:
		manquantes.append('python-numpy')
		print "ImportError:", e
	
	try: from PIL import Image
	except ImportError, e:
		manquantes.append('python-imaging')
		print "ImportError:", e
	
	a='\n'+'='*40+'\n'
	
	if manquantes:
		print a+"Les applications suivantes n'ont pas été détectées:\n%s\
		\nEKD ne sera pas pleinement fonctionnel (s'il démarre...)\n\
		\nYou must install the packages:\n%s"%(', '.join(manquantes), ', '.join(manquantes))+a
		return 0, ', '.join(manquantes)
	
	else:
		print a+"Toutes les dépendances sont satisfaites\n\nAll packages are installed"+a
		return 1, ', '.join(all)

verif = verifAppliManquante()

import sys, ConfigParser, locale, platform, webbrowser
from PyQt4.QtCore import *
from PyQt4.QtGui import *

import gettext


os.chdir(os.path.dirname(os.path.abspath(sys.argv[0])))

# Version de ekd
__version__ = "1.4-5"


class Label(QLabel):
	"Liens cliquables pour debian etch"
	def __init__(self, txt, url):
		QLabel.__init__(self)
		self.setText("<font color='blue'><center>%s</center></font>" %txt)
		self.url = url
		self.setCursor(Qt.PointingHandCursor)
		
	def mousePressEvent(self, event):
		webbrowser.open(self.url)


class Aide_Info(QDialog):
	# -------------------------------------------------------------
	# Classe pour Chargement de la boîte de dialogue pour afficher
	# l'aide en ligne (affichée dans le browser web par défaut du
	# système), les infos de développement et la licence
	# -------------------------------------------------------------
	
	## La largeur de la fenêtre est définie de façon à pouvoir afficher les caractères suivants sur une ligne
	#WSTRING = "EKD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public"
	
	def __init__(self, parent=None):
		QDialog.__init__(self, parent)
		
		self.setAttribute(Qt.WA_DeleteOnClose)
		
		self.setMinimumSize(QSize(700, 650))
		#self.minimumSizeHint()
		# Titre de la fenetre
		self.setWindowTitle(_(u'Infos'))
		
		vbox_aide=QVBoxLayout()
		
		self.tabwidget=QTabWidget()
		
		#=== 1er onglet ===#
		self.fram_2=QFrame()
		vboxFram_2=QVBoxLayout(self.fram_2)
		
		v_box_fram_2=QVBoxLayout()
		txt = ""
		txt += _(u"<p><u><b>Version</b></u>")
		txt += "<p><b>Ekd</b> v %s" %__version__
		txt_ = _(u"Cette application peut être utilisée pour des opérations de post-production pour vidéo et lots d'images")
		txt += "<p>" + txt_
		txt_ = _(u"Mars 2009")
		txt += "<p>" + txt_
		txt += """<p>Python %s - Qt %s - PyQt %s - %s""" % (
			platform.python_version(),
			QT_VERSION_STR, PYQT_VERSION_STR, platform.system())
		txt += _(u"<p><u><b>Développement</b></u>")
		txt += _(u"<p>* Lama Angelo: développeur historique du logiciel")
		txt += _(u"<p>* Romain (alteo_gange): intégration de l'interface graphique")
		txt += _(u"<p>* Jean-Rémy Bancel: travaux de développement divers")
		txt += _(u"<p><u><b>Traduction anglaise</b></u>")
		txt += _(u"<p>* Bellegarde Sophie, Bellegarde Laurent et Macdonald Kristian")
		txt += _(u"<p><u><b>Traduction espagnole</b></u>")
		txt += _(u"<p>* Jesús MUÑOZ")
		txt += _(u"<p><u><b>Graphisme</b></u>")
		txt += _(u"<p>* Labarussias Thomas: conception des icônes et du logo officiel")
		txt += _(u"<p><u><b>Avec la participation de ...</b></u>")
		txt += _(u"<p>* Bellegarde Laurent et Lusson Julien: tests divers et conseils")
		
		label = QLabel(txt)
		if PYQT_VERSION_STR >= "4.1.0":
			label.setTextInteractionFlags(Qt.TextSelectableByMouse|Qt.TextSelectableByKeyboard)
		v_box_fram_2.addWidget(label)
		v_box_fram_2.setAlignment(Qt.AlignHCenter)
		
		vboxFram_2.addLayout(v_box_fram_2)
		vboxFram_2.addSpacing(10)
		vboxFram_2.addStretch()
		
		#=== 2ème onglet ===#
		if PYQT_VERSION_STR >= "4.1.0":
			textBrowser = QTextBrowser()

			textBrowser.setHtml(
				"<h3><center>" + _(u"Documentation et didacticiels") + "</center></h3>"

				"<br>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/Linux\">" +
					_(u"Documentation générale") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/TraitementVideoPresentationLinux\">" +
					_(u"Le traitement vidéo par l’exemple") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/TraitementImagePresentationLinux\">" +
					_(u"Le traitement des images par l’exemple") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/VideoFiltresLinux\">" +
					_(u"Les filtres vidéo") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/VideoMontageVideoLinux\">" +
					_(u"Le montage vidéo") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/VideoTitrageDansVideo\">" +
					_(u"Titrage dans une vidéo") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/ImagesPlancheContactLinux\">" +
					_(u"Planche-contact pour les images") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/ImagesInformationLinux\">" +
					_(u"Informations pour les images/photos") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/AjoutElementsLinux\">" +
					_(u"Ajout d’éléments (texte/images)") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/ImageCompositeLinux\">" +
					_(u"Faire du compositing avec EKD") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/TransitionsLinux\">" +
					_(u"Transitions pour les images") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/MasqueAlpha3DLinux\">" +
					_(u"Masque alpha/3D (chroma key) pour les images") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/FiltresImageLinux\">" +
					_(u"Les différents filtres image pour EKD") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/LectureImageLinux\">" +
					_(u"Visionner des images sous EKD") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/Documents/LectureVideoLinux\">" +
					_(u"Lecture de vidéos dans EKD") +"</a></p>"
				"<p align=\"center\"><a href=\"http://ekd.tuxfamily.org/index.php/INSTekd/Linux\">" +
					_(u"Installation des sources d’EKD sous Linux") +"</a></p>"
				)
		
			textBrowser.setOpenExternalLinks(True)
		
		else:
			# On fait au plus simple sous debian etch
			textBrowser = QWidget()
			vboxLiens = QVBoxLayout(textBrowser)
			lab = Label(_(u"Documentation générale"),"http://ekd.tuxfamily.org/index.php/Documents/Linux")
			vboxLiens.addWidget(lab, 0, Qt.AlignTop)
		
		#=== 3ème onglet ===#
		self.fram_3=QFrame()
		vboxFram_3=QVBoxLayout(self.fram_3)
		
		v_box_fram_3=QVBoxLayout()
		
		label_texte=QLabel(_(u"<b><center>EKD est placé sous licence libre <font color=red>GNU GPL version 3</font>: Vous pouvez l’utiliser, le copier, le modifier (l’équipe de développement souhaiterait tout de même avoir accès au code modifié) et le diffuser librement.</center></b>"))
		label_texte.setWordWrap(1)

		vboxFram_3.addWidget(label_texte)
		
		# Ajout de l'image logo GPL v3 au milieu de la fenêtre
		objImg = QImage("Icones/gplv3-127x51.png") # objet-image
		label = QLabel()
		label.setPixmap(QPixmap.fromImage(objImg)) # on inclut l'image dans le QLabel
		label.setAlignment(Qt.AlignCenter) # centrage de l'image
		
		texte_1=_(u"<h2><b>Termes de l'utilisation d'EKD par la GPL version 3</b></h2>")
		
		fh = QFile('menu_et_toolbar/copyright_ekd_gplv3_mise_en_forme.txt')
		fh.open(QIODevice.ReadOnly)
		stream = QTextStream(fh)
		stream.setCodec("UTF-8")
		texte_2 = unicode(stream.readLine())
		fh.close()
		
		texte_3="<h2><b>GNU General Public License Version 3, 29 June 2007</b></h2>"
		
		fh = QFile('menu_et_toolbar/gplv3_mise_en_forme.txt')
		fh.open(QIODevice.ReadOnly)
		stream = QTextStream(fh)
		stream.setCodec("UTF-8")
		texte_4 = unicode(stream.readLine())
		fh.close()
		
		zoneTexte = QTextEdit(texte_1+texte_2+texte_3+texte_4)
		zoneTexte.setReadOnly(True)
		zoneTexte.setMinimumHeight(458)
		
		vboxFram_3.addLayout(v_box_fram_3)
		vboxFram_3.addWidget(label)
		vboxFram_3.addWidget(zoneTexte)
		vboxFram_3.addStretch()
		
		self.index_1=self.tabwidget.addTab(self.fram_2, _(u'Développement et graphisme'))
		self.index_2=self.tabwidget.addTab(textBrowser, _(u'Documentation'))
		self.index_3=self.tabwidget.addTab(self.fram_3, _(u'Licence'))
		
		################ Rajouté le 19/03/09 ########################################
		boutonFermer = QPushButton(_(u"Revenir"))
		boutonFermer.setIcon(QIcon("Icones/revenir.png"))
		self.connect(boutonFermer, SIGNAL('clicked()'), SLOT('close()'))
		#############################################################################
		
		vbox_aide.addWidget(self.tabwidget)
		################ Rajouté le 19/03/09 ########################################
		vbox_aide.addWidget(boutonFermer)
		#############################################################################
		self.setLayout(vbox_aide)
	
	
	#def minimumSizeHint(self):
		#"Taille minimale pour la fenêtre"
		##self.sizeHint(QSize(700, 500))
		
		#font = QFont(self.font())
		#fm = QFontMetricsF(font)
		#largeur = fm.width(Aide_Info.WSTRING)
		#return QSize(largeur, largeur*4)

class DialogQuitter(QDialog):
	"Boite de dialogue de fermeture de ekd"
	def __init__(self, parent=None):
		QDialog.__init__(self, parent)
		
		self.setWindowTitle(_(u'Message'))
		
		vbox = QVBoxLayout(self)
		questionLabel = QLabel(_(u"Voulez-vous sauver les nouveaux paramètres de configuration?"))
		self.sauverConfCase = QCheckBox(_(u"Ne plus poser la question à chaque fois"))
		if PYQT_VERSION_STR >= "4.1.0":
			buttonBox = QDialogButtonBox(QDialogButtonBox.Yes|QDialogButtonBox.No)
			boutonOui = buttonBox.button(QDialogButtonBox.Yes)
			boutonNon = buttonBox.button(QDialogButtonBox.No)
		else:
			buttonBox = QWidget()
			vboxButtonBox = QHBoxLayout(buttonBox)
			vboxButtonBox.addStretch()
			boutonOui = QPushButton(_(u'&Oui'))
			boutonNon = QPushButton(_(u'&Non'))
			vboxButtonBox.addWidget(boutonOui)
			vboxButtonBox.addWidget(boutonNon)
		messagebox_info = QPixmap("Icones/messagebox_info.png")
		icone = QLabel()
		icone.setPixmap(messagebox_info)
		hboxButton = QHBoxLayout()
		hboxButton.addStretch()
		hboxButton.addWidget(buttonBox)
		vboxText = QVBoxLayout()
		vboxText.addWidget(questionLabel)
		vboxText.addWidget(self.sauverConfCase)
		hboxIconText = QHBoxLayout()
		hboxIconText.addWidget(icone)
		hboxIconText.addStretch(0)
		hboxIconText.addLayout(vboxText)
		vbox.addLayout(hboxIconText)
		vbox.addStretch(0)
		vbox.addLayout(hboxButton)
		boutonOui.setFocus()
		self.connect(boutonOui,SIGNAL("clicked()"),self.accept)
		self.connect(boutonNon,SIGNAL("clicked()"),self.reject)


class Gui_EKD(QMainWindow):
	# -----------------------------------------
	# Classe principale . Base de l'interface .
	# -----------------------------------------
	def __init__(self, dicoModel):
		QMainWindow.__init__(self)
		
		# -----------------------------------------------------
		# Parametres Generaux de la fenetre Principale (début)
		# -----------------------------------------------------
		
		# Titre de la fenetre
		self.setWindowTitle('EnKoDeur-Mixeur')
		
		# Icone de EKD
		self.setWindowIcon(QIcon('Icones/logo_ekd.png'))
		
		# Dimension mini de la fenêtre
		self.setMinimumSize(QSize(1024, 740))
		
		#=== chargement et lecture du fichier de configuration (plutôt méthode linux) ===#
		home = unicode(QDir.homePath())
		pathConfig = home+'/.config/ekd/' # appelé depuis une fonction
		if not QDir(pathConfig).exists():
			QDir(home).mkdir('.config/ekd')
			self.fichierConf = home + '/.config/ekd/' + 'ekd.ini'
		else: self.fichierConf = pathConfig + 'ekd.ini'
		self.config = ConfigParser.ConfigParser()
		self.config.read(self.fichierConf) # lecture du fichier
		
		# si le fichier de configuration n'existe pas, on le crée
		self.creationFichierConf()
		
		# si le fichier de configuration est incomplet on ajoute des paramètres
		self.completerFichierConf()
		
		# nouvelle lecture du fichier pour prendre en compte les éventuelles modifications
		self.config.read(self.fichierConf)
		
		# ---------------------------------------------------------
		# Menu principal - Barre d'outils
		# ---------------------------------------------------------
		
		#=== Actions générales ===#
		quitterAction = self.createAction(_(u'&Quitter'), slot=self.close,
			icon='Icones/icone_quit_128.png',tip=_(u"Fermer l'application"),signal="triggered()")
		
		self.barreOutilsAction = self.createAction(_(u"&Barre d'outils"), slot=self.barreOutils,
			tip=_(u"Afficher/Masquer la barre d'outils"), checkable=True, signal="triggered()")
		
		if PYQT_VERSION_STR >= "4.1.0": raccourcis = QKeySequence.HelpContents
		else: raccourcis = "F1"
		aboutAction = self.createAction(_(u"&A propos d'EKD"), slot=self.info_aide,
			shortcut=raccourcis, icon='Icones/icone_info_128.png',
			tip=_(u"Afficher les contributeurs, les liens vers documentation et la licence de EKD"), signal="triggered()")
		
		mplayerAction = self.createAction(_(u"&Lecteur vidéo"), slot=self.mplayerAction,
			icon='Icones/icone_visionner_128.png',tip=_(u"Lancer un lecteur vidéo"), signal="triggered()")
		
		self.dialogSauvAction = self.createAction(_(u"B&oite de dialogue de sauvegarde"), checkable=True, slot=self.dialogSauv, signal="triggered()", tip=_(u"Afficher la boite de dialogue de sauvegarde des paramètres de configuration à la fermeture de EKD"))
		
		self.splitAction = self.createAction(_(u"&Conserver les positions relatives des menus verticaux et des cadres (split)"), checkable=True, slot=self.splitPosition, signal="triggered()", tip=_(u"Risqué! Cette action prendra effet au prochain démarrage de EKD. Les positions seront enregistrées à la fermeture si vous le décidez."))
		
		self.purgeConfigAction = self.createAction(_(u"&Réinitialiser les paramètres de configuration"), checkable=True, slot=self.purgeConfig, signal="triggered()", tip=_(u"Purge des fichiers de configurations. Cette action prendra effet au prochain démarrage de EKD"))
		
		# Sortie vidéo de mplayer
		groupVideoOutput = QActionGroup(self)
		defautvoAction = self.createAction(_(u"&défaut"), checkable=True,
			slot=lambda a, b='':self.videoOutput(a, b),
			tip=_(u"Sortie vidéo définie dans les fichiers de configuration de mplayer"),
			signal="toggled(bool)")
		groupVideoOutput.addAction(defautvoAction)
		xmgaAction = self.createAction("x&mga", checkable=True,
			slot=lambda a, b='xmga':self.videoOutput(a, b),
			tip=_(u"Matrox G200/G4x0/G550 overlay in X11 window (using /dev/mga_vid)"),
			signal="toggled(bool)")
		groupVideoOutput.addAction(xmgaAction)
		xvAction = self.createAction("&xv", checkable=True,
			slot=lambda a, b='xv':self.videoOutput(a, b), tip=_(u" X11/Xv"), signal="toggled(bool)")
		groupVideoOutput.addAction(xvAction)
		x11Action = self.createAction("x&11", checkable=True,
			slot=lambda a, b='x11':self.videoOutput(a, b), tip=_(u"X11 (XImage/Shm)"),
			signal="toggled(bool)")
		groupVideoOutput.addAction(x11Action)
		glAction = self.createAction("&gl", checkable=True,
			slot=lambda a, b='gl':self.videoOutput(a, b), tip=_(u"X11 (OpenGL)"),
			signal="toggled(bool)")
		groupVideoOutput.addAction(glAction)
		gl2Action = self.createAction("gl&2", checkable=True,
			slot=lambda a, b='gl2':self.videoOutput(a, b),
			tip=_(u"X11 (OpenGl) - multiple textures version"), signal="toggled(bool)")
		groupVideoOutput.addAction(gl2Action)
		dxr3Action = self.createAction("dx&r3", checkable=True,
			slot=lambda a, b='dxr3':self.videoOutput(a, b), tip=_(u"DXR3/H+ video out"),
			signal="toggled(bool)")
		groupVideoOutput.addAction(dxr3Action)
		xvidixAction = self.createAction("xv&idix", checkable=True,
			slot=lambda a, b='xvidix':self.videoOutput(a, b), tip=_(u"X11 (VIDIX)"),
			signal="toggled(bool)")
		groupVideoOutput.addAction(xvidixAction)
		xvmcAction = self.createAction("xvm&c", checkable=True,
			slot=lambda a, b='xvmc':self.videoOutput(a, b), tip=_(u"XVideo Motion Conpensation"),
			signal="toggled(bool)")
		groupVideoOutput.addAction(xvmcAction)
		
		settings = QSettings()
		vo = settings.value("vo", QVariant('')).toString()
		if vo == '':
			defautvoAction.setChecked(True)
		elif vo == 'xmga':
			xmgaAction.setChecked(True)
		elif vo == 'xv':
			xvAction.setChecked(True)
		elif vo == 'x11':
			x11Action.setChecked(True)
		elif vo == 'gl':
			glAction.setChecked(True)
		elif vo == 'gl2':
			gl2Action.setChecked(True)
		elif vo == 'dxr3':
			gl2Action.setChecked(True)
		elif vo == 'xvidix':
			gl2Action.setChecked(True)
		elif vo == 'xvmc':
			gl2Action.setChecked(True)

		#configurerAction = self.createAction(_(u'&Configurer EKD'), slot=self.configInterface,
			#icon='Icones/icone_config_128.png', tip=_(u'Configurer EKD'), signal="triggered()")
		
		#=== Menus ===#
		# Menu Quitter ==========================================
		menu=self.menuBar().addMenu(_(u'&Quitter'))
		menu.addAction(quitterAction)
		
		# Menu Outils =================================
		menu=self.menuBar().addMenu(_(u'O&utils'))
		menu_enfant=menu.addAction(mplayerAction)
		
		# Menu Configuration ==========================================
		self.menuConfig=self.menuBar().addMenu(_(u'&Configuration'))
		self.connect(self.menuConfig,SIGNAL("aboutToShow()"),self.fctMenuConfig)
		self.menuConfig.addAction(self.barreOutilsAction)
		self.menuConfig.addAction(self.dialogSauvAction)
		self.menuConfig.addAction(self.splitAction)
		self.menuConfig.addAction(self.purgeConfigAction)
		#self.menuConfig.addAction(configurerAction)
		
		menuMplayer = self.menuConfig.addMenu(_(u"&Sortie vidéo de mplayer"))
		self.addActions(menuMplayer, (defautvoAction, xmgaAction, xvAction, x11Action, 
				glAction, gl2Action, dxr3Action, xvidixAction, xvmcAction))
		
		# Menu Aide ==========================================
		menu=self.menuBar().addMenu(_(u'&Infos'))
		menu_enfant=menu.addAction(aboutAction)
		
		#=== Barre d'outils ===#
		self.toolBar = self.addToolBar(_(u"&Barre d'outils"))
		self.toolBar.setObjectName("BarreOutils") # obligatoire pour le déplacement
		#self.toolBar.setIconSize(QSize(30,30))
		self.toolBar.setIconSize(QSize(16,16))
		self.toolBar.hide()
		
		self.toolBar.addAction(quitterAction)
		self.toolBar.addSeparator()
		#self.toolBar.addAction(configurerAction)
		#self.toolBar.addSeparator()
		self.toolBar.addAction(mplayerAction)
		self.toolBar.addSeparator()
		self.toolBar.addAction(aboutAction)
		self.toolBar.addSeparator()
		
		# Dictionnaire pour ne pas avoir à changer la fonction connectée à chaque 
		# modif du nom d'un item . Une valeur (et non pas une clé) de notre
		# dictionnaire est unique. Elle est différente du texte de l'item pour 
		# éviter les pièges et pour pouvoir donner des noms identiques à certains 
		# items au besoin .
		self.itemDict = {}
		
		
		# ---------------------------------------------------------
		# Onglets
		# ---------------------------------------------------------
		tabWidget=QTabWidget()
		#tabWidget.setTabPosition(QTabWidget.West)
		
		largeurEcran = QDesktopWidget().screenGeometry().height()
		# Sous Qt4.0 pas moyen de paramètrer la taille des icônes pour les en-têtes d'onglet.
		# Elles sont beaucoup trop petite -> on préfère le texte seul (on préfère aussi le texte
		# pour les petites écrans)
		if largeurEcran < 800 or PYQT_VERSION_STR < "4.1.0": petitEcran = 1
		else:
			petitEcran = 0
			# Changé car sur kde 4 les icônes s'affichent en tout petit
			#tabWidget.setIconSize(QSize(36,36))
			tabWidget.setIconSize(QSize(22, 22))
		
		self.connect(tabWidget,SIGNAL('currentChanged(int)'),self.changeOnglet)
		
		# onglet Animation ============================
		# DICO - clé: référence du split; valeur: paramètres de configuration
		self.dicoSplit = {}
		self.animSplitter = QSplitter(Qt.Horizontal)
		self.dicoSplit[self.animSplitter] = "AnimSplitter"
		
		# Liste de hbox
		# Rq: les self de cette partie (sauf pour le dictionnaire) sont nécessaires
		# à l'activation les liens hypertextes du cadre d'accueil "Montage Vidéo"
		self.treeWidgetAnimation=QTreeWidget()
		
		self.animSplitter.addWidget(self.treeWidgetAnimation)
		
		self.treeWidgetAnimation.headerItem().setText(0, _(u"Vidéo"))
		
		itemTree=QTreeWidgetItem(self.treeWidgetAnimation)
		itemTree.setText(0,_(u"Encodage"))
		self.itemDict[itemTree]="1_0_0_ANIM_sjffu16"
		itemTree.setIcon(0,QIcon("Icones/db_update.png"))
		
		itemTree_Encodage_General=QTreeWidgetItem(itemTree)
		itemTree_Encodage_General.setText(0,_(u"Général"))
		self.itemDict[itemTree_Encodage_General]="1_1_0_ANIM_gfg5fdztt"
		itemTree_Encodage_General.setIcon(0,QIcon("Icones/database.png"))
		
		itemTree_Encodage_Web=QTreeWidgetItem(itemTree)
		itemTree_Encodage_Web.setText(0,_(u"Pour le web"))
		self.itemDict[itemTree_Encodage_Web]="1_2_0_ANIM_df2gwd45sf"
		itemTree_Encodage_Web.setIcon(0,QIcon("Icones/database.png"))
		
		itemTree_Encodage_HD=QTreeWidgetItem(itemTree)
		itemTree_Encodage_HD.setText(0,_(u"Haute Définition"))
		self.itemDict[itemTree_Encodage_HD]="1_3_0_ANIM_d58v7ddflk"
		itemTree_Encodage_HD.setIcon(0,QIcon("Icones/database.png"))
		
		itemTree=QTreeWidgetItem(self.treeWidgetAnimation)
		itemTree.setText(0,_(u"Filtres"))
		self.itemDict[itemTree]="2_0_0_ANIM_vpong87"
		itemTree.setIcon(0,QIcon("Icones/database.png"))
		
		itemTree=QTreeWidgetItem(self.treeWidgetAnimation)
		itemTree.setText(0,_(u"Montage vidéo"))
		self.itemDict[itemTree]="3_0_0_ANIM_ds55df5"
		itemTree.setIcon(0,QIcon("Icones/db_update.png"))
		
		self.itemTree_SVideo=QTreeWidgetItem(itemTree)
		self.itemTree_SVideo.setText(0,_(u"Vidéo seulement"))
		self.itemDict[self.itemTree_SVideo]="3_1_0_ANIM_uub115t"
		self.itemTree_SVideo.setIcon(0,QIcon("Icones/database.png"))
		
		self.itemTree_SVideoAudio=QTreeWidgetItem(itemTree)
		self.itemTree_SVideoAudio.setText(0,_(u"Vidéo + audio"))
		self.itemDict[self.itemTree_SVideoAudio]="3_2_0_ANIM_r4gflaz"
		self.itemTree_SVideoAudio.setIcon(0,QIcon("Icones/database.png"))
		
		self.itemTree_SDecouperVideo=QTreeWidgetItem(itemTree)
		self.itemTree_SDecouperVideo.setText(0,_(u"Découpage d'une vidéo"))
		self.itemDict[self.itemTree_SDecouperVideo]="3_3_0_ANIM_a25486q"
		self.itemTree_SDecouperVideo.setIcon(0,QIcon("Icones/database.png"))
		
		if PYQT_VERSION_STR < "4.1.0":
			self.treeWidgetAnimation.setItemExpanded(itemTree, True)
		
		itemTree=QTreeWidgetItem(self.treeWidgetAnimation)
		itemTree.setText(0,_(u"Séparation audio-vidéo"))
		self.itemDict[itemTree]="4_0_0_ANIM_f45dd4s"
		itemTree.setIcon(0,QIcon("Icones/database.png"))
		
		itemTree=QTreeWidgetItem(self.treeWidgetAnimation)
		itemTree.setText(0,_(u"Conversion d'images en vidéo"))
		self.itemDict[itemTree]="5_0_0_ANIM_l5gf541"
		itemTree.setIcon(0,QIcon("Icones/database.png"))
		
		itemTree=QTreeWidgetItem(self.treeWidgetAnimation)
		itemTree.setText(0,_(u"Conversion d'une vidéo en images"))
		self.itemDict[itemTree]="6_0_0_ANIM_hlmnn2v"
		itemTree.setIcon(0,QIcon("Icones/database.png"))
		
		itemTree=QTreeWidgetItem(self.treeWidgetAnimation)
		itemTree.setText(0,_(u"Nombre d'images par seconde"))
		self.itemDict[itemTree]="7_0_0_ANIM_azec514"
		itemTree.setIcon(0,QIcon("Icones/database.png"))
		
		itemTree=QTreeWidgetItem(self.treeWidgetAnimation)
		itemTree.setText(0,_(u"Convertir une vidéo en 16/9 ou 4/3"))
		self.itemDict[itemTree]="8_0_0_ANIM_s16stt5"
		itemTree.setIcon(0,QIcon("Icones/database.png"))
		
		# On déroule toutes les entrées de l'arbre
		if PYQT_VERSION_STR >= "4.1.0": self.treeWidgetAnimation.expandAll()
		
		# connecteur de la liste
		self.connect(self.treeWidgetAnimation,SIGNAL("itemClicked(QTreeWidgetItem *,int)"),self.liste_animation)
		
		# ajout de la liste et des widgets associés dans hbox
		self.stacked_onglet_animation=QStackedWidget()
		
		# widget principal de la page d'accueil contenant le logo ekd
		widget_img_accueil = self.widgetOngletAccueil("Icones/logo_ekd.png")
		# Drapeau pour savoir éventuellement afficher l'image d'accueil propre à l'onglet
		self.clicInitialAnim = 1
		# widget principal de la page d'accueil animation
		imageAccueilAnim = self.widgetOngletAccueil("Icones/icone_video_256.png")
		
		# page d'accueil de ekd
		self.stacked_page_accueil=self.stacked_onglet_animation.addWidget(widget_img_accueil)
		# page d'accueil de animation
		self.imageAccueilAnim=self.stacked_onglet_animation.addWidget(imageAccueilAnim)
		# Animation >> Encodage
		self.stacked_animation_encodage=self.stacked_onglet_animation.addWidget(Animation_Encodage(self))
		# Animation >> Encodage >> Général
		self.stacked_animation_encodage_general=self.stacked_onglet_animation.addWidget(Animation_Encodage_General(self))
		# Animation >> Encodage >> Pour le web
		self.stacked_animation_encodage_web=self.stacked_onglet_animation.addWidget(AnimationEncodageWeb(self))
		# Animation >> Encodage >> Haute Définition
		self.stacked_animation_encodage_hd=self.stacked_onglet_animation.addWidget(AnimationEncodageHD(self))
		# Animation >> filtres vidéos
		self.stacked_animation_filtresVideos=self.stacked_onglet_animation.addWidget(Animation_FiltresVideos(self))
		# Animation >> montage vidéo 
		self.stacked_animation_MontagVideo=self.stacked_onglet_animation.addWidget(Animation_MontagVideo(self))
		# Animation >> montage vidéo >> video seulement
		self.stacked_animation_MontagVideoVidSeul=self.stacked_onglet_animation.addWidget(Animation_MontagVideoVidSeul(self))
		# Animation >> montage vidéo >> video + audio
		self.stacked_animation_MontagVideoVidPlusAudio=self.stacked_onglet_animation.addWidget(Animation_MontagVideoVidPlusAudio(self))
		# Animation >> montage vidéo >> decouper une video
		self.stacked_animation_MontagVideoDecoupUneVideo=self.stacked_onglet_animation.addWidget(Animation_MontagVideoDecoupUneVideo(self)) 
		# Animation >> separer video et audio
		self.stacked_animation_SeparVideoEtAudio=self.stacked_onglet_animation.addWidget(Animation_SeparVideoEtAudio(self))
		# Animation >> convertir des images en animation
		self.stacked_animation_ConvertirImgEnAnim=self.stacked_onglet_animation.addWidget(Animation_ConvertirImgEnAnim(self))
		# Animation >> convertir une animation en images
		self.stacked_animation_ConvertirUneAnimEnImg=self.stacked_onglet_animation.addWidget(Animation_ConvertirUneAnimEnImg(self))
		# Animation >> reglages divers
		self.stacked_animation_ReglagesDivers=self.stacked_onglet_animation.addWidget(Animation_ReglagesDivers(self))
		# Animation >> conversion une vidéo en 16/9 ou 4/3
		self.stacked_animation_ConvertirAnimEn_16_9_Ou_4_3=self.stacked_onglet_animation.addWidget(Animation_ConvertirAnimEn_16_9_Ou_4_3(self))
		
		self.animSplitter.addWidget(self.stacked_onglet_animation)
		
		# ajout du widget contenant la boite dans l'onglet Animation
		i = tabWidget.addTab(self.animSplitter, '')
		txt = _(u"Vidéo")
		tabWidget.setTabToolTip(i, txt)
		if not petitEcran:
			tabWidget.setTabIcon(i, QIcon("Icones/icone_video_128.png"))
		else: tabWidget.setTabText(i, txt)
		
		# onglet Image ================================
		self.imageSplitter = QSplitter(Qt.Horizontal)
		self.dicoSplit[self.imageSplitter] = "ImageSplitter"
		
		# liste de hbox
		self.treeWidgetDiversImage=QTreeWidget()
		self.imageSplitter.addWidget(self.treeWidgetDiversImage)
		
		self.treeWidgetDiversImage.headerItem().setText(0,_(u"Image"))
		
		itemTree=QTreeWidgetItem(self.treeWidgetDiversImage)
		itemTree.setText(0,_(u"Divers"))
		self.itemDict[itemTree]="1_0_0_IMAGE_apdjf54"
		itemTree.setIcon(0,QIcon("Icones/db_update.png"))
		
		self.itemTree_PlContact=QTreeWidgetItem(itemTree)
		self.itemTree_PlContact.setText(0,_(u"Planche-contact"))
		self.itemDict[self.itemTree_PlContact]="1_1_0_IMAGE_wxwx93f"
		self.itemTree_PlContact.setIcon(0,QIcon("Icones/database.png"))
		
		self.itemTree_Information=QTreeWidgetItem(itemTree)
		self.itemTree_Information.setText(0,_(u"Information"))
		self.itemDict[self.itemTree_Information]="1_2_0_IMAGE_k1246k1"
		self.itemTree_Information.setIcon(0,QIcon("Icones/database.png"))
		
		self.itemTree_ChangFormat=QTreeWidgetItem(itemTree)
		self.itemTree_ChangFormat.setText(0,_(u"Changement de format"))
		self.itemDict[self.itemTree_ChangFormat]="1_3_0_IMAGE_mm01gf6"
		self.itemTree_ChangFormat.setIcon(0,QIcon("Icones/database.png"))
	
		self.itemTree_Redimens=QTreeWidgetItem(itemTree)
		self.itemTree_Redimens.setText(0,_(u"Redimension"))
		self.itemDict[self.itemTree_Redimens]="1_4_0_IMAGE_oixw41g"
		self.itemTree_Redimens.setIcon(0,QIcon("Icones/database.png"))
		
		if PYQT_VERSION_STR >= "4.1.0":
			self.itemTree_TxtSurImg=QTreeWidgetItem(itemTree)
			self.itemTree_TxtSurImg.setText(0,_(u"Ajout d'éléments"))
			self.itemDict[self.itemTree_TxtSurImg]="1_5_0_IMAGE_h45u68e"
			self.itemTree_TxtSurImg.setIcon(0,QIcon("Icones/database.png"))
		
		self.itemTree_ImgComposit=QTreeWidgetItem(itemTree)
		self.itemTree_ImgComposit.setText(0,_(u"Image composite"))
		self.itemDict[self.itemTree_ImgComposit]="1_6_0_IMAGE_ii7d1rr"
		self.itemTree_ImgComposit.setIcon(0,QIcon("Icones/database.png"))
		
		self.itemTree_RenomImg=QTreeWidgetItem(itemTree)
		self.itemTree_RenomImg.setText(0,_(u"Renommage d'images"))
		self.itemDict[self.itemTree_RenomImg]="1_7_0_IMAGE_try2abt"
		self.itemTree_RenomImg.setIcon(0,QIcon("Icones/database.png"))
		
		self.itemTree_PourLeWeb=QTreeWidgetItem(itemTree)
		self.itemTree_PourLeWeb.setText(0,_(u"Pour le web"))
		self.itemDict[self.itemTree_PourLeWeb]="1_8_0_IMAGE_x884v03"
		self.itemTree_PourLeWeb.setIcon(0,QIcon("Icones/database.png"))
		
		self.itemTree_MultiplicImg=QTreeWidgetItem(itemTree)
		self.itemTree_MultiplicImg.setText(0,_(u"Multiplication d'image"))
		self.itemDict[self.itemTree_MultiplicImg]="1_9_0_IMAGE_f45ros7"
		self.itemTree_MultiplicImg.setIcon(0,QIcon("Icones/database.png"))
		
		if PYQT_VERSION_STR < "4.1.0":
			self.treeWidgetDiversImage.setItemExpanded(itemTree, True)
		
		itemTree=QTreeWidgetItem(self.treeWidgetDiversImage)
		itemTree.setText(0,_(u"Transitions"))
		self.itemDict[itemTree]="2_0_0_IMAGE_pdske43"
		itemTree.setIcon(0,QIcon("Icones/db_update.png"))
		
		self.itemTree_FonduEnchaine=QTreeWidgetItem(itemTree)
		self.itemTree_FonduEnchaine.setText(0,_(u"Fondu enchaîné"))
		self.itemDict[self.itemTree_FonduEnchaine]="2_1_0_IMAGE_cz4g58f"
		self.itemTree_FonduEnchaine.setIcon(0,QIcon("Icones/database.png"))
		
		self.itemTree_Spirale=QTreeWidgetItem(itemTree)
		self.itemTree_Spirale.setText(0,_(u"Spirale"))
		self.itemDict[self.itemTree_Spirale]="2_2_0_IMAGE_n86ret5"
		self.itemTree_Spirale.setIcon(0,QIcon("Icones/database.png"))
		
		if PYQT_VERSION_STR < "4.1.0":
			self.treeWidgetDiversImage.setItemExpanded(itemTree, True)
		
		itemTree=QTreeWidgetItem(self.treeWidgetDiversImage)
		itemTree.setText(0,_(u"Masque alpha/3D"))
		self.itemDict[itemTree]="3_0_0_IMAGE_a4a6rey"
		itemTree.setIcon(0,QIcon("Icones/db_update.png"))
		
		itemTree=QTreeWidgetItem(self.treeWidgetDiversImage)
		itemTree.setText(0,_(u"Filtres"))
		self.itemDict[itemTree]="4_0_0_IMAGE_brt45e4"
		itemTree.setIcon(0,QIcon("Icones/db_update.png"))
		
		# On déroule toutes les entrées de l'arbre
		if PYQT_VERSION_STR >= "4.1.0": self.treeWidgetDiversImage.expandAll()
		
		# connecteur de la liste
		self.connect(self.treeWidgetDiversImage,SIGNAL("itemClicked(QTreeWidgetItem *,int)"),self.liste_image)
		
		# widget principal de la page d'accueil
		widget_img_accueil = self.widgetOngletAccueil("Icones/icone_images_256.png")
		
		# ajout de la liste et des widgets associés dans hbox
		self.stacked_onglet_image=QStackedWidget(self)
		# page d'accueil
		self.stacked_onglet_image.addWidget(widget_img_accueil)
		# Image >> Divers
		self.stacked_image_divers=self.stacked_onglet_image.addWidget(Image_Divers(self))
		# Image >> Divers >> Planche-contact
		self.stacked_image_divers_PlContact=self.stacked_onglet_image.addWidget(Image_Divers_PlContact(self))
		# Image >> Divers >> Information
		self.stacked_image_divers_Information=self.stacked_onglet_image.addWidget(Image_Divers_Info(self))
		# Image >> Divers >> Changer format
		self.stacked_image_divers_ChangFormat=self.stacked_onglet_image.addWidget(Image_Divers_ChangFormat(self))
		# Image >> Divers >> Redimensionner
		self.stacked_image_divers_Redimens=self.stacked_onglet_image.addWidget(Image_Divers_Redimensionner(self))
		# Image >> Divers >> Texte sur images
		if PYQT_VERSION_STR >= "4.1.0":
			self.stacked_image_divers_TxtSurImg=self.stacked_onglet_image.addWidget(Image_Divers_TxtSurImg(self))
		# Image >> Divers >> Compositing
		self.stacked_image_divers_Compositing=self.stacked_onglet_image.addWidget(Image_Divers_Compositing(self))
		# Image >> Divers >> Renommer images
		self.stacked_image_divers_RenomImg=self.stacked_onglet_image.addWidget(Image_Divers_RenomImg(self))
		# Image >> Divers >> Pour le web
		self.stacked_image_divers_PourLeWeb=self.stacked_onglet_image.addWidget(Image_Divers_PourLeWeb(self))
		# Image >> Divers >> Multiplication d'images
		self.stacked_image_divers_MultiplicImg=self.stacked_onglet_image.addWidget(Image_Divers_MultiplicImg(self))
		# Image >> Transitions
		self.stacked_image_transitions=self.stacked_onglet_image.addWidget(Image_Transitions(self))
		# Image >> Transitions >> Fondu enchaîné
		self.stacked_image_transitions_fondEnch=self.stacked_onglet_image.addWidget(Image_Transitions_FondEnch(self))
		# Image >> Transitions >> Spirale
		self.stacked_image_transitions_Spirale=self.stacked_onglet_image.addWidget(Image_Transitions_Spirale(self))
		# Image >> Masque alpha/3D
		self.stacked_image_masque_alpha_3d=self.stacked_onglet_image.addWidget(Image_MasqueAlpha3D(self))
		# Image >> Filtres image
		self.stacked_image_filtres_image=self.stacked_onglet_image.addWidget(Image_FiltresImage(self))
		
		self.imageSplitter.addWidget(self.stacked_onglet_image)
		
		# ajout du widget contenant la boite dans l'onglet Image
		i = tabWidget.addTab(self.imageSplitter, '')
		txt = _(u"Image")
		tabWidget.setTabToolTip(i, txt)
		if not petitEcran:
			tabWidget.setTabIcon(i, QIcon("Icones/icone_images_128.png"))
		else: tabWidget.setTabText(i, txt)
		
		# onglet Musique-son ==========================
		self.sonSplitter = QSplitter(Qt.Horizontal)
		self.dicoSplit[self.sonSplitter] = "SonSplitter"
		
		# liste de hbox
		treeWidget=QTreeWidget()
		self.sonSplitter.addWidget(treeWidget)
		
		treeWidget.headerItem().setText(0, _(u"Musique-Son"))
		
		itemTree=QTreeWidgetItem(treeWidget)
		itemTree.setText(0,_(u"Transcodage audio (wav)"))
		self.itemDict[itemTree]="1_0_0_MUSIC_SON_ug41yd7"
		itemTree.setIcon(0,QIcon("Icones/icone_sons_128.png"))
		
		# connecteur de la liste
		self.connect(treeWidget,SIGNAL("itemClicked(QTreeWidgetItem *,int)"),self.liste_musique_son)
		
		# ajout de la liste et des widgets associés dans hbox
		self.stacked_onglet_musique_son=QStackedWidget()
		
		# Musique-Son >> Encodage
		
		# page d'accueil
		# widget principal de la page d'accueil
		widget_img_accueil = self.widgetOngletAccueil("Icones/icone_sons_256.png")
		self.stacked_onglet_musique_son.addWidget(widget_img_accueil)
		self.stacked_musique_son_encodage=self.stacked_onglet_musique_son.addWidget(MusiqueSon_Encodage(self))
		
		self.sonSplitter.addWidget(self.stacked_onglet_musique_son)
		
		# ajout du widget contenant la boite dans l'onglet Musique_Son
		i = tabWidget.addTab(self.sonSplitter, '')
		txt = _(u"Musique-Son")
		tabWidget.setTabToolTip(i, txt)
		if not petitEcran:
			tabWidget.setTabIcon(i, QIcon("Icones/icone_sons_128.png"))
		else: tabWidget.setTabText(i, txt)
		
		# onglet Lecture ==============================
		self.lectureSplitter = QSplitter(Qt.Horizontal)
		self.dicoSplit[self.lectureSplitter] = "LectureSplitter"
		
		splitLect=QSplitter(Qt.Vertical)
		
		# liste des entrées de menu de splitLect
		treeWidget=QTreeWidget()
		splitLect.addWidget(treeWidget)
		
		# arborescence des fichiers et dossiers de "Visionner des images"
		self.listViewVisioImg = QListView()
		model = dicoModel['visionner_images']
		self.listViewVisioImg.setModel(model)
		index = model.index(QDir.homePath())
		self.listViewVisioImg.setRootIndex(index)
		self.connect(self.listViewVisioImg, SIGNAL("doubleClicked(const QModelIndex &)"), self.naviguerImages)
		#self.treeViewVisioImg.setCurrentIndex(index)
		#self.treeViewVisioImg.setExpanded(index, True)
		#self.treeViewVisioImg.hideColumn(1)
		#self.treeViewVisioImg.hideColumn(2)
		#self.treeViewVisioImg.hideColumn(3)
		#treeView.expand()
		#treeView.setRootIndex(model.index(QDir.currentPath()))
		#self.treeViewVisioImg.show()
		
		# arborescence des fichiers et dossiers de "Visionner des vidéos"
		self.listViewVisioVideo = QListView()
		model = dicoModel['visionner_videos']
		self.listViewVisioVideo.setModel(model)
		index = model.index(QDir.homePath())
		self.listViewVisioVideo.setRootIndex(index)
		self.connect(self.listViewVisioVideo, SIGNAL("doubleClicked(const QModelIndex &)"), self.naviguerVideos)
		#treeViewVisioVideo.setExpanded(index, True)
		#treeViewVisioVideo.setSelectionMode(QAbstractItemView.MultiSelection)
		#treeViewVisioVideo.hideColumn(1)
		#treeViewVisioVideo.hideColumn(2)
		#treeViewVisioVideo.hideColumn(3)
		#treeViewVisioVideo.show()
		
		self.stackedVisio = QStackedWidget()
		
		self.indexStacked_visioImg = self.stackedVisio.addWidget(self.listViewVisioImg)
		self.indexStacked_visioVideo =self.stackedVisio.addWidget(self.listViewVisioVideo)
		
		splitLect.addWidget(self.stackedVisio)
		self.lectureSplitter.addWidget(splitLect)
		
		
		# remplissage des entrées donnant accès aux cadres
		treeWidget.headerItem().setText(0, _(u"Lecture"))
		
		itemTree=QTreeWidgetItem(treeWidget)
		itemTree.setText(0,_(u"Lecture d'images"))
		self.itemDict[itemTree]="visionner_images"
		itemTree.setIcon(0,QIcon("Icones/database.png"))
		
		itemTree=QTreeWidgetItem(treeWidget)
		itemTree.setText(0,_(u"Lecture de vidéos"))
		self.itemDict[itemTree]="visionner_videos"
		itemTree.setIcon(0,QIcon("Icones/database.png"))
		
		
		# connecteur de la liste
		self.connect(treeWidget,SIGNAL("itemClicked(QTreeWidgetItem *,int)"),self.liste_lecture)
		
		# ajout de la liste et des widgets associés dans hbox
		self.stacked_onglet_lecture=QStackedWidget()
		
		# page d'accueil
		# widget principal de la page d'accueil
		widget_img_accueil = self.widgetOngletAccueil("Icones/icone_visionner_256.png")
		self.stacked_onglet_lecture.addWidget(widget_img_accueil)
		# Lecture >> Visionner des images
		self.lecture_VisionImage = Lecture_VisionImage(self, True)
		self.stacked_lecture_vision_image=self.stacked_onglet_lecture.addWidget(self.lecture_VisionImage)
		# Lecture >> Visionner des vidéos
		self.lecture_VisionVideo = Lecture_VisionVideo(self)
		self.stacked_lecture_vision_video=self.stacked_onglet_lecture.addWidget(self.lecture_VisionVideo)
		
		# connection TreeView->UpdateDir
		self.connect(self.listViewVisioImg,SIGNAL("clicked(QModelIndex)"), self.lecture_VisionImage.updateDir)
		self.connect(self.listViewVisioVideo,SIGNAL("clicked(QModelIndex)"), self.lecture_VisionVideo.updateDir)
		#self.lecture_VisionImage.updateDir(os.path.expanduser('~'))
		
		self.lectureSplitter.addWidget(self.stacked_onglet_lecture)
		
		# ajout du widget contenant la boite dans l'onglet Lecture
		i = tabWidget.addTab(self.lectureSplitter, '')
		txt = _(u"Lecture")
		tabWidget.setTabToolTip(i, txt)
		if not petitEcran:
			tabWidget.setTabIcon(i, QIcon("Icones/icone_visionner_128.png"))
		else: tabWidget.setTabText(i, txt)
		
		
		# onglet Mode Séquentiel ===========================
		
		# En construction
		if len(sys.argv)==2 and sys.argv[1]=="sequentiel":
			# widget de base du dernier onglet
			sequentiel = Sequentiel(self)
			
			# ajout du widget contenant la boite dans l'onglet Séquentiel
			i = tabWidget.addTab(sequentiel, '')
			tabWidget.setTabToolTip(i, _(u"Conversions séquentielles"))
			if not petitEcran:
				tabWidget.setTabIcon(i, QIcon("Icones/icone_sequenciel_128.png"))
			else: tabWidget.setTabText(i, _(u"Sequentiel"))
		
		
		# -----------------
		# Barre des tâches
		# -----------------
		self.statusBar().showMessage(u'Prêt', 5000)
		
		# affichage des onglets au centre de la fenêtre
		self.setCentralWidget(tabWidget)
		
		# A pour effet d'assurer une taille minimale
		# aux QTreeWidget lors de la 1ère ouverture de ekd
		self.animSplitter.setStretchFactor(0, 4)
        	self.animSplitter.setStretchFactor(1, 4)
		self.imageSplitter.setStretchFactor(0, 3)
        	self.imageSplitter.setStretchFactor(1, 4)
		self.sonSplitter.setStretchFactor(0, 1)
        	self.sonSplitter.setStretchFactor(1, 3)
		self.lectureSplitter.setStretchFactor(0, 1)
        	self.lectureSplitter.setStretchFactor(1, 1)
		
		#--------------------------------------------------
		# Paramètres généraux de la fenêtre (suite et fin)
		#--------------------------------------------------
		# Paramètres contenus dans ~/.config/ekd/ekd.conf sous linux
		#settings = QSettings()
		#self.recentRepertory = settings.value("RecentRepertory").toStringList()
		size = settings.value("MainWindow/Size", QVariant(QSize(890, 735))).toSize()
		self.resize(size)
		position = settings.value("MainWindow/Position",QVariant(QPoint(0, 0))).toPoint()
		self.move(position)
		self.restoreState(settings.value("MainWindow/State").toByteArray())
		splitList = [self.animSplitter, self.imageSplitter, self.sonSplitter,self.lectureSplitter ]
		if int(self.config.get("General", 'charger_split')):
			for split, optionConfig in self.dicoSplit.items():
				splitSetting = settings.value(optionConfig).toByteArray()
				split.restoreState(splitSetting)
	
	
	def info_aide(self):
		""" Chargement de la classe de la boîte de dialogue pour afficher
		l'aide en ligne (affichée dans le browser web par défaut du système),
		les infos de développement et la licence """
		aide_info = Aide_Info(self)
		aide_info.show()
	
	
	## --------------------------------------------------------------------------
	#def configInterface(self):
		#""" Configuration de l'interface (notamment la barre des taches) """
		
		## Boite de dialogue
		#self.dialog = QDialog()
		#self.dialog.setMinimumSize(QSize(700, 500))
		## Titre de la fenetre
		#self.dialog.setWindowTitle(_(u'Configuration'))
		
		#vbox_config=QVBoxLayout()
		
		#self.tabwidget=QTabWidget()
		
		##=== 1er onglet ===#
		#self.fram_1=QFrame()
		#vboxFram_1=QVBoxLayout(self.fram_1)
		
		## boite de combo (QA: quoi afficher)
		#self.comboConfigQA=QComboBox()
		#listeComboConfigQA=[(_(u'Barre des taches uniquement (par défaut)'), 'barr_tach_uniq'), (_(u'Menu uniquement'), 'menu_uniq'), (_(u'Menu plus barre des taches'), 'menu_plus_barr_tach')]
		
		## Insertion des url dans la combo box
		#for i in listeComboConfigQA:
                	#self.comboConfigQA.addItem(i[0],QVariant(i[1]))
		#self.connect(self.comboConfigQA, SIGNAL("activated(int)"), self.changerComboQA)
		
		#self.boutConfigBT=QPushButton(_(u"Cliquez ici pour afficher/ne pas afficher"))
		#self.boutConfigBT.setFocusPolicy(Qt.NoFocus)
		#self.connect(self.boutConfigBT, SIGNAL("clicked()"), self.quoiAfficher)
		
		#v_box_fram_1=QVBoxLayout()
		#v_box_fram_1.addWidget(QLabel(_(u"<u><b>Qu'est ce qui doit être affiché ?</b></u>")))
		#v_box_fram_1.addWidget(self.comboConfigQA)
		#v_box_fram_1.addWidget(self.boutConfigBT)
		#v_box_fram_1.setAlignment(Qt.AlignHCenter)
		
		#vboxFram_1.addLayout(v_box_fram_1)
		#vboxFram_1.addSpacing(20)
		#vboxFram_1.addStretch()
		
		#self.index_1=self.tabwidget.addTab(self.fram_1, _(u'Menu/barre des taches'))
		
		#vbox_config.addWidget(self.tabwidget)
		#self.dialog.setLayout(vbox_config)
		#self.dialog.exec_()
	
	def fctMenuConfig(self):
		"L'état des cases à cocher du menu configuration sont générés lors du clic sur le menu"
		self.barreOutilsAction.setChecked(self.toolBar.isVisible())
		actif = int(self.config.get("General", 'boite_de_dialogue_de_fermeture'))
		self.dialogSauvAction.setChecked(actif)
		actif = int(self.config.get("General", 'charger_split'))
		self.splitAction.setChecked(actif)
	
	def barreOutils(self):
		"Affichage/masquage de la barre d'outils"
		self.toolBar.setVisible(not self.toolBar.isVisible())
	
	def mplayerAction(self):
		"Widget mplayer"
		try:
			repEntree = self.config.get('Animation','path').decode("UTF8")
		except ConfigParser.NoOptionError, e:
			repEntree = None
		###### Enlevé le 31/03/09 #################################################################
		'''
		mplayer = Mplayer([], (400, 400*3/4),
			(Mplayer.PRECEDENT_SUIVANT,Mplayer.CURSEUR_A_PART,Mplayer.PARCOURIR),
			cheminParcourir=repEntree, parent=self)
		'''
		###########################################################################################
		###### Rectifié/Rajouté le 31/03/09 #######################################################
		mplayer = Mplayer([], (600, 600*3/4),
			(Mplayer.REVENIR,Mplayer.PRECEDENT_SUIVANT,Mplayer.CURSEUR_A_PART,Mplayer.PARCOURIR),
			cheminParcourir=repEntree, parent=self)
		###########################################################################################
		mplayer.show()
		
	def changerComboQA(self):
		""" Affichage de l'index du combo """
		print self.comboConfigQA.currentIndex()
	
	def quoiAfficher(self):
		""" L'utilisateur fait le choix de ce qui doit être visible
		entre le menu, la barre des taches et les deux en même temps """
		if self.comboConfigQA.currentIndex()==0:
			# Uniquement la barre des taches sera visible
			self.menuBar().hide()
			self.toolBar.show()
		elif self.comboConfigQA.currentIndex()==1:
			# Uniquement le menu sera visible
			self.menuBar().show()
			self.toolBar.hide()
		elif self.comboConfigQA.currentIndex()==2:
			# Les deux seront affichés
			self.menuBar().show()
			self.toolBar.show()
	# --------------------------------------------------------------------------
	
	def dialogSauv(self):
		"Faire apparaître/disparaître la boite de dialogue de sauvegarde en sortie"
		if self.dialogSauvAction.isChecked():
			self.config.set("General", 'boite_de_dialogue_de_fermeture', '1')
		else: self.config.set("General", 'boite_de_dialogue_de_fermeture', '0')
	
	def splitPosition(self):
		"Charger les paramètres de position relatives des menus/cadres (QSplitter)"
		if self.splitAction.isChecked():
			if QMessageBox.critical(self, _(u"Alerte"), _(u"Vous souhaitez activer le chargement des dernières positions relatives des menus verticaux et des cadres (split). Sous certaines configurations, le chargement des positions relatives des menus verticaux/cadres de chaque onglet fait apparaître des onglets vides au démarrage de EKD. Dans ce cas nous vous conseillons de ne plus charger les positions relatives des menus verticaux/cadres des onglets voire de réinitialiser les paramètres de configuration (voir les entrées du menu «Configuration» appropriées).\n\nVoulez-vous quand-même confimer votre choix?"), QMessageBox.Yes, QMessageBox.No)==QMessageBox.Yes:
				self.config.set("General", 'charger_split', '1')
			else: self.splitAction.setChecked(False)
		else: self.config.set("General", 'charger_split', '0')
	
	def purgeConfig(self):
		"Purge des fichiers de configuration"
		if self.purgeConfigAction.isChecked():
			if QMessageBox.warning(self, _(u"Alerte"), _(u"Vous souhaitez remettre les paramètres de configuration à leurs valeurs initiales. Cela purgera vos fichiers de configurations.\nSi vous faites cela pour résoudre un problème d'onglets vides, nous vous conseillons ensuite de redémarrer EKD.\n\nVoulez-vous quand-même confirmer votre choix?"), QMessageBox.Yes, QMessageBox.No)==QMessageBox.Yes:
				self.config.set("General", 'effacer_config', '1')
			else: self.purgeConfigAction.setChecked(False)
		else: self.config.set("General", 'effacer_config', '0')
	
	def closeEvent(self, event):
		"actions à effectuer au moment de quitter"
		
		def sauvChangements():
			# sauver les paramètres de configuration
			self.config.write(open(self.fichierConf,'w'))
			settings = QSettings()
			#recentRepertory = QVariant(self.recentRepertory) \
				#if self.recentRepertory else QVariant()
			#settings.setValue("RecentRepertory", recentRepertory)
			settings.setValue("MainWindow/Size", QVariant(self.size()))
			settings.setValue("MainWindow/Position",QVariant(self.pos()))
			settings.setValue("MainWindow/State",QVariant(self.saveState()))
			for split, optionConfig in self.dicoSplit.items():
				settings.setValue(optionConfig, QVariant(split.saveState()))
		
		if int(self.config.get("General", 'boite_de_dialogue_de_fermeture')):
			dialog = DialogQuitter(self)
			if dialog.exec_():
				sauverConf =  not dialog.sauverConfCase.isChecked()
				self.config.set("General", 'boite_de_dialogue_de_fermeture', str(int(sauverConf)))
				self.config.set("General", 'sauvegarder_parametres', '1')
				sauvChangements()
			else:
				sauverConf =  not dialog.sauverConfCase.isChecked()
				self.config.set("General", 'boite_de_dialogue_de_fermeture', str(int(sauverConf)))
				self.config.set("General", 'sauvegarder_parametres', '0')
		elif int(self.config.get("General", 'sauvegarder_parametres')):
			sauvChangements()
		
		# Purge des fichiers de configuration
		if int(self.config.get("General", 'effacer_config')):
			QFile(QSettings().fileName()).remove()
			QFile(QDir.homePath()+"/.config/ekd/ekd.ini").remove()
		
		event.accept()
	
	
	def creationFichierConf(self):
		"si le fichier de configuration n'existe pas, on le crée"
		try:
			file(self.fichierConf)
		except:
			print "le fichier de configuration n'existe pas -> on le crée"
			fichierOb=open(self.fichierConf,'w')
			fichierOb.close()
	
	
	def completerFichierConf(self):
		"si le fichier de configuration est incomplet on y ajoute des paramètres"
		
		# dictionnaire: dico[section]=((option1,valeur1),(option2,valeur2),...)
		# NE PAS OUBLIER LA VIRGULE À LA FIN QUAND IL N'Y A QU'UN TUPLE!!! ),) ou ),)}
		# les valeurs path n'ont rien à faire dans le dictionnaire (gérés directement dans les cadres)
		dicoConf={
			'Animation':(),
			'Animation - Encodage - General':(
				('macromediaflashvideo',500),
				('codecmpeg1',2),
				('codecmpeg2',2),
				('codecdivx4',2),
				('codecwmv2',2),
				('codecmotionjpeg',2),
				('codecoggtheora',5),
				('codec', 'copie')),
			'Animation - Encodage - Web':(
				('codec', 'youtube_16/9_HQ'),),
			'Animation - Encodage - HD':(
				('codec', 'hd_1920x1080_mov_ac3_16/9'),),
			'Animation - FiltresVideo':(
				('valeur_bruit_luma',23),
				('valeur_bruit_chroma',25),
				('type_bruit_luma','bruituniforme'),
				('type_bruit_chroma','bruituniforme'),
				('luminosite',0),
				('contraste',0),
				('decouper_largeur',800),
				('decouper_hauteur',600),
				('decouper_position_largeur',0),
				('decouper_position_hauteur',0),
				('couleur',0),
				('saturation',0),
				('flou_boite_rayon',1),
				('flou_boite_puissance',1),
				('resolution_redim_largeur',640),
				('resolution_redim_hauteur',480),
				('codec', 'niveaudegris')),
			'Animation - Separer Audio et Video':(
				('type_extraction', 'video&audio'),),
			'Animation - Convertir des Images en Video':(
				('codec','mpeg1video'),
				('nbr_img_sec',25),
				('nbr_img_sec_mpeg1video',25)),
			'Animation - Convertir Une Video en Images':(),
			'Animation - Reglages Supplementaires':(('spin', 22),),
			'Animation - Decouper une Video':(),
			'Animation - Montage Video Seul':(
				('type_ordre_montage', 'sans_ordre_alpha'),),
			'Animation - Montage Video et Audio':(
				('type_ordre_montage', 'sans_ordre_alpha'),),
			'Animation - Conversion Video 16/9 ou 4/3':(
				('type_16_9_ou_4_3', '16_9'),),
			'General':(
				('boite_de_dialogue_de_fermeture', 1),
				('sauvegarder_parametres', 1),
				('charger_split', 0),
				('effacer_config', 0),),
			'Image':(),
			'Image - Filtres Image':(
				('filtre', 'vieux_films'),
				('pointillisme', ''),
				('couleurs_predefinies', ''),
				('evanescence', ''),
				('negatif', ''),
				('encadre_photo', ''),
				('contraste_couleur', ''),
				('sepia', ''),
				('charcoal_traits_noirs', ''),
				('edge', ''),
				('huile', ''),
				('gamma', ''),
				('fonce_clair', ''),
				('liquidite', ''),
				('bas_relief', ''),
				('charcoal_crayon', ''),
				('spread_crayon', ''),
				('radius', ''),
				('sigma', ''),
				('precision_trait', ''),
				('largeur_trait', ''),
				('seuillage_bas', ''),
				('seuillage_haut', ''),
				('intensite_du_trait', ''),
				('reduction_couleur', ''),
				('peinture_huile', ''),
				('couleur_11', ''),
				('couleur_12', ''),
				('couleur_13', ''),
				('couleur_21', ''),
				('couleur_22', ''),
				('couleur_23', ''),
				('couleur_31', ''),
				('couleur_32', ''),
				('couleur_33', ''),
				('taille_mini_forme', ''),
				('taille_maxi_forme', ''),
				('coul_omb_lum_a_la_coul_11', ''),
				('coul_omb_lum_a_la_coul_12', ''),
				('coul_omb_lum_a_la_coul_21', ''),
				('coul_omb_lum_a_la_coul_22', ''),
				('coul_omb_lum_a_la_coul_31', ''),
				('coul_omb_lum_a_la_coul_32', ''),
				('coul_omb_lum_a_la_coul_41', ''),
				('coul_omb_lum_a_la_coul_42', ''),
				('rotation_image', ''),
				),
			"Image - Masque Alpha 3D":(
				('methode', 'methode1'),
				('masque', 'masque_alpha'),
				('qualite', ''),
				('nettete', ''),
				('reglage', ''),
				('forme_fond', ''),
				('teinte_debut', ''),
				('saturation_debut', ''),
				('luminosite', ''),
				('saturation_fin', ''),
				('teinte_fin', ''),
				),
			"Image - Pour le web":(
				('methode', 'gif_anime'),
				('nombre_morceaux_vertical', ''),
				('nombre_morceaux_horizontal', ''),
				('nombre_couleurs', ''),
				('nouvelle_largeur', ''),
				('delai', ''),),
			"Image - Redimensionner":(
				('methode', 'gif_anime'),
				('largeur_ratio', ''),
				('largeur_sans_ratio', ''),
				('longueur_sans_ratio', ''),),
			"Image - Changer Format":(
				('format', '.jpg'),),
			"Image - Planche-Contact":(
				('format', ''),
				('orientation', ''),
				('couleur_fond', ''),
				('passage_image', ''),
				('largeur_marge', ''),
				('nombre_images_largeur', ''),
				('nombre_images_longueur', ''),),
			"Image - Multiplication":(
				('mult_duree_sec', ''),
				('mult_nbre_img_sec', ''),
				('mult_format_ext', ''),
				('mult_action_a_effectuer', ''),),
				}
		
		for section in dicoConf.keys(): # est-ce que toutes les sections existent?
			print section
			if not self.config.has_section(section): # la fct n'existe pas -> création
				self.config.add_section(section)
			for opt_val in dicoConf[section]: # est-ce que toutes les options existent?
				print opt_val, '\n'
				if not self.config.has_option(section,opt_val[0]): # la valeur n'existe pas -> création
					self.config.set(section,opt_val[0],opt_val[1])
		
		self.config.write(open(self.fichierConf,'w'))	# sauver les paramètres de configuration
	
	
	def changeOnglet(self,i):
		"""Effacer les données de la barre des tâches lorsque l'on change d'onglet"""
		if i==1 and self.clicInitialAnim:
			self.stacked_onglet_animation.setCurrentIndex(self.imageAccueilAnim)
			self.clicInitialAnim = 0
		self.statusBar().clearMessage()
	
	
	def createAction(self, text, slot=None, shortcut=None, icon=None,
			tip=None, checkable=False, signal="triggered()"):
		action = QAction(text, self)
		if icon is not None:
			action.setIcon(QIcon(icon))
		if shortcut is not None:
			action.setShortcut(shortcut)
		if tip is not None:
			action.setToolTip(tip)
			action.setStatusTip(tip)
		if slot is not None:
			self.connect(action, SIGNAL(signal), slot)
		if checkable:
			action.setCheckable(True)
		return action
	
	def addActions(self, target, actions):
		"Action du sous menu de réglage de l'option '-vo' de mplayer"
		for action in actions:
			if action is None:
				target.addSeparator()
			else:
				target.addAction(action)
	
	def videoOutput(self, vrai, vo):
		"Enregistre la valeur de l'option '-vo' de mplayer dans un fichier de configuration"
		if vrai:
			settings = QSettings()
			settings.setValue("vo", QVariant(vo))

	def widgetOngletAccueil(self, cheminImg):
		"Widget principal de la page d'accueil d'un onglet"
		widget_img_accueil=QWidget()
		# fond gris
		if PYQT_VERSION_STR >= "4.1.0":
			widget_img_accueil.setStyleSheet("QWidget { background-color: %s }"\
				% QColor(140,140,140).name())
		else:
			widget_img_accueil.setAutoFillBackground(True)
			widget_img_accueil.setPalette(QPalette(QColor(140,140,140)))
		hbox_label=QHBoxLayout(widget_img_accueil)
		objImg = QPixmap(cheminImg) # objet-image
		label = QLabel()
		label.setPixmap(objImg) # on inclut l'image dans le QLabel
		hbox_label.addWidget(label, 0, Qt.AlignHCenter)
		return widget_img_accueil
	
	
	def naviguerImages(self, item):
		"Ouvrir le contenu d'un répertoire (images)"
		self.listViewVisioImg.setRootIndex(item)
		modele = item.model()
		rep=QDir(modele.filePath(item)).absolutePath()
		print rep
		self.statusBar().showMessage(rep)
	
	
	def naviguerVideos(self, item):
		"Ouvrir le contenu d'un répertoire (vidéos)"
		self.listViewVisioVideo.setRootIndex(item)
		modele = item.model()
		rep=QDir(modele.filePath(item)).absolutePath()
		self.statusBar().showMessage(rep)
	
	
	def liste_animation(self, item):
		"""Les éléments de la liste 1 modifient le contenu de la boite de droite de l'onglet animation"""
		# item renvoie la référence de l'objet QTreeWidgetItem.
		
		idItem=self.itemDict[item]
		
		# Effacer les données de la barre des tâches lorsque l'on change d'entrée de l'arborescence
		self.statusBar().clearMessage()
		
		self.clicInitialAnim = 0
		
		if idItem=="1_0_0_ANIM_sjffu16":	# Encodage
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_encodage) # changer la partie droite de l'onglet
		elif idItem=="1_1_0_ANIM_gfg5fdztt":	# Encodage : Général
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_encodage_general)
		elif idItem=="1_2_0_ANIM_df2gwd45sf":	# Encodage : Pour le web
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_encodage_web)
		elif idItem=="1_3_0_ANIM_d58v7ddflk":	# Encodage : Haute Définition
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_encodage_hd)
		elif idItem=="2_0_0_ANIM_vpong87":	# Filtres Vidéos
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_filtresVideos)
		elif idItem=="3_0_0_ANIM_ds55df5":	# Montage video
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_MontagVideo)
		elif idItem=="3_1_0_ANIM_uub115t":	# Montage video : video seul
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_MontagVideoVidSeul)
		elif idItem=="3_2_0_ANIM_r4gflaz":	# Montage video : video + audio
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_MontagVideoVidPlusAudio)
		elif idItem=="3_3_0_ANIM_a25486q":	# Montage video : decouper une video
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_MontagVideoDecoupUneVideo)
		elif idItem=="4_0_0_ANIM_f45dd4s":	# Separer video et audio
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_SeparVideoEtAudio)
		elif idItem=="5_0_0_ANIM_l5gf541":	# Convertir des images en animation
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_ConvertirImgEnAnim)
		elif idItem=="6_0_0_ANIM_hlmnn2v":	# Convertir une animation en images
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_ConvertirUneAnimEnImg)
		elif idItem=="7_0_0_ANIM_azec514":	# Reglages divers
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_ReglagesDivers)
		elif idItem=="8_0_0_ANIM_s16stt5":	# Conversion en 16/9 ou 4/3
			self.stacked_onglet_animation.setCurrentIndex(self.stacked_animation_ConvertirAnimEn_16_9_Ou_4_3)
	
	
	def liste_image(self, item):
		"""Les éléments de la liste 2 modifient le contenu de la boite de droite de l'onglet images"""
		# item renvoie la référence de l'objet QTreeWidgetItem.

		idItem=self.itemDict[item]
		if idItem=="1_0_0_IMAGE_apdjf54":	# Divers
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_divers)
		elif idItem=="1_1_0_IMAGE_wxwx93f":	# Divers : Planche-contact
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_divers_PlContact)
		elif idItem=="1_2_0_IMAGE_k1246k1":	# Divers : Information
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_divers_Information)
		elif idItem=="1_3_0_IMAGE_mm01gf6":	# Divers : Changer format
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_divers_ChangFormat)
		elif idItem=="1_4_0_IMAGE_oixw41g":	# Divers : Redimensionner
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_divers_Redimens)
		elif idItem=="1_5_0_IMAGE_h45u68e" and PYQT_VERSION_STR >= "4.1.0": # Divers : Texte sur images
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_divers_TxtSurImg)
			if PYQT_VERSION_STR == "4.1.0":
				self.statusBar().showMessage(_(u"Le cadre n'est pas pleinement fonctionnel à cause d'un bogue sur la librairie PyQt4.1.0 (paquet python-qt4)!"))
		elif idItem=="1_6_0_IMAGE_ii7d1rr":	# Divers : Compositing
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_divers_Compositing)
		elif idItem=="1_7_0_IMAGE_try2abt":	# Divers : Renommer images
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_divers_RenomImg)
		elif idItem=="1_8_0_IMAGE_x884v03":	# Divers : Pour le web
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_divers_PourLeWeb)
		elif idItem=="1_9_0_IMAGE_f45ros7":	# Divers : Multiplication d'image
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_divers_MultiplicImg)
		elif idItem=="2_0_0_IMAGE_pdske43":	# Transitions
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_transitions)
		elif idItem=="2_1_0_IMAGE_cz4g58f":	# Transitions : Fondu Enchaîné
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_transitions_fondEnch)
		elif idItem=="2_2_0_IMAGE_n86ret5":	# Transitions : Spirale
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_transitions_Spirale)
		elif idItem=="3_0_0_IMAGE_a4a6rey":	# Masque alpha/3D
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_masque_alpha_3d)
		elif idItem=="4_0_0_IMAGE_brt45e4":	# Filtres image
			self.stacked_onglet_image.setCurrentIndex(self.stacked_image_filtres_image)
	
	
	def liste_musique_son(self, item):
		"""Les éléments de la liste 1 modifient le contenu de la boite de droite de l'onglet musique_son"""
		# item renvoie la référence de l'objet QTreeWidgetItem.
		
		idItem=self.itemDict[item]
		
		if idItem=="1_0_0_MUSIC_SON_ug41yd7":	# Musique-son : Encodage
			# changer la partie droite de l'onglet
			self.stacked_onglet_musique_son.setCurrentIndex(self.stacked_musique_son_encodage)
	
	
	def liste_lecture(self, item):
		"""Les éléments de la liste 1 modifient le contenu de la boite de droite de l'onglet lecture"""
		# item renvoie la référence de l'objet QTreeWidgetItem.
		
		idItem=self.itemDict[item]
		
		if idItem=="visionner_videos":	# Lecture : Visionner des vidéos
			# changer la partie droite de l'onglet
			self.stacked_onglet_lecture.setCurrentIndex(self.stacked_lecture_vision_video)
			self.stackedVisio.setCurrentIndex(self.indexStacked_visioVideo)
		elif idItem=="visionner_images": # Lecture : Visionner des images
			self.stacked_onglet_lecture.setCurrentIndex(self.stacked_lecture_vision_image)
			self.stackedVisio.setCurrentIndex(self.indexStacked_visioImg)



if __name__ == "__main__":
	
	import __builtin__
	from functools import partial

	app = QApplication(sys.argv)
	
	# Traduction des boites de dialogue Qt
	locale = unicode(QLocale.system().name()) # ex: fr_FR
	print "\n\n", locale
	
	# Sélection du répertoire de traduction
	localeDir = os.path.join(os.getcwd(), "locale")
	if not os.path.exists(localeDir):
		localeDir = os.path.join(os.path.dirname(sys.argv[0]), "locale")
	
	qtTranslator = QTranslator()
	try: symboleLangue = locale.split('_')[0] # ex: fr
	except ValueError, e:
		print e
		symboleLangue = "inconnu"
	if qtTranslator.load("qt_"+locale, os.path.join(localeDir, 'translations')):
		app.installTranslator(qtTranslator)
	elif qtTranslator.load("qt_"+symboleLangue, os.path.join(localeDir, 'translations')):
		app.installTranslator(qtTranslator)
	else:
		print "Pas de fichier", "qt_"+locale+'.qm', "ou", "qt_"+symboleLangue+'.qm', "détecté"
	
	# Nom du répertoire et du début du fichier de configuration
	app.setOrganizationName("ekd")
	app.setApplicationName("ekd")
	app.setOrganizationDomain("ekd.tuxfamily.org")
	
	# Traduction de l'interface courante (ex. locale/es_ES/LC_MESSAGES/ekd.po pour l'espagnol)
	try:
		traduction = gettext.translation('ekd', localeDir, languages=[locale])
	except IOError, e:
		traduction = gettext.translation('ekd', localeDir, languages=[symboleLangue], fallback=True)
	# Traduction de l'aide (ex. locale/es_ES/LC_MESSAGES/ekdDoc.po pour l'espagnol)
	try:
		traductionDoc = gettext.translation('ekdDoc', localeDir, languages=[locale])
	except IOError:
		traductionDoc = gettext.translation('ekdDoc', localeDir, languages=[symboleLangue], fallback=True)
	
	__builtin__.__dict__['_'] = partial(traduction.ugettext)
	__builtin__.__dict__['tr'] = partial(traductionDoc.ugettext)
	
	# Vérification de la présence (si elles sont bien installées) des 
	# dépendances pour qu'EKD puisse être exécuté normalement (il
	# s'agit de Mplayer, Mencoder, Ffmeg2Theora, Python Imaging Library,
	# ImageMagick, Numpy ... et PyQt4). Comme la fenêtre d'erreur a besoin
	# de PyQt4 pour s'affcher, si PyQt4 n'est pas installé, l'erreur/les
	# applis manquantes sont aussi signalées dans le terminal.
	txt1 = _(u"Les applications suivantes n'ont pas été détectées:")
	txt2 = _(u"EKD ne sera pas pleinement fonctionnel (s'il démarre...)")

	if not verif[0]:
		QMessageBox.critical(None,u"Vérification des dépendances de EKD",txt1 + " " +\
			"\n" + verif[1] + "\n\n" + txt2)

	# -------------------------------------------------------------
	# Import des modules contenus ds des fichiers separes
	# -------------------------------------------------------------
	
	# ANIMATION --------------
	
	from gui_modules_animation.animation_encodage import Animation_Encodage
	# + ---------------------------
	from gui_modules_animation.animation_encodage_general import Animation_Encodage_General
	from gui_modules_animation.animation_encodage_web import AnimationEncodageWeb
	from gui_modules_animation.animation_encodage_hd import AnimationEncodageHD
	# + ---------------------------
	from gui_modules_animation.animation_filtres_video import Animation_FiltresVideos
	from gui_modules_animation.animation_montage_video import Animation_MontagVideo
	# + ---------------------------
	from gui_modules_animation.animation_montage_video_vid_seul import Animation_MontagVideoVidSeul
	from gui_modules_animation.animation_montage_video_vid_plus_audio import Animation_MontagVideoVidPlusAudio
	from gui_modules_animation.animation_montage_video_decoup_une_vid import Animation_MontagVideoDecoupUneVideo
	# -----------------------------
	from gui_modules_animation.animation_separer_video_et_audio import Animation_SeparVideoEtAudio
	from gui_modules_animation.animation_conv_img_en_anim import Animation_ConvertirImgEnAnim
	from gui_modules_animation.animation_conv_anim_en_img import Animation_ConvertirUneAnimEnImg
	from gui_modules_animation.animation_reglag_divers import Animation_ReglagesDivers
	from gui_modules_animation.animation_conv_vid_16_9_ou_4_3 import Animation_ConvertirAnimEn_16_9_Ou_4_3
	
	# IMAGE ------------------
	# divers
	from gui_modules_image.divers.image_divers import Image_Divers
	# + ---------------------------
	from gui_modules_image.divers.image_divers_chang_format import Image_Divers_ChangFormat
	from gui_modules_image.divers.image_divers_compositing import Image_Divers_Compositing
	from gui_modules_image.divers.image_divers_info import Image_Divers_Info
	from gui_modules_image.divers.image_divers_pl_contact import Image_Divers_PlContact
	from gui_modules_image.divers.image_divers_pour_le_web import Image_Divers_PourLeWeb
	from gui_modules_image.divers.image_divers_redimensionner import Image_Divers_Redimensionner
	from gui_modules_image.divers.image_divers_renom_img import Image_Divers_RenomImg
	from gui_modules_image.divers.image_divers_multiplic_img import Image_Divers_MultiplicImg
	# Pas de module texte sur items sous debian etch
	if PYQT_VERSION_STR >= "4.1.0":
		from gui_modules_image.divers.image_divers_txt_sur_img import Image_Divers_TxtSurImg
	# -----------------------------
	# transitions
	from gui_modules_image.transitions.image_transitions import Image_Transitions
	# + ---------------------------
	from gui_modules_image.transitions.image_transitions_fond_ench import Image_Transitions_FondEnch
	from gui_modules_image.transitions.image_transitions_spirale import Image_Transitions_Spirale
	# -----------------------------
	# masque_alpha_3d
	from gui_modules_image.masque_alpha_3d.image_masque_alpha_3d import Image_MasqueAlpha3D
	# -----------------------------
	# filtres_images
	from gui_modules_image.filtres_images.image_filtres_image import Image_FiltresImage
	
	# MUSIQUE-SON ------------
	from gui_modules_music_son.music_son_encodage import MusiqueSon_Encodage
	
	# LECTURE ----------------
	from gui_modules_lecture.lecture_image import Lecture_VisionImage
	from gui_modules_lecture.lecture_video import Lecture_VisionVideo
	
	# MODE-SEQUENTIEL ------------- # En construction
	if len(sys.argv)==2 and sys.argv[1]=="sequentiel":
		from gui_modules_sequentiel.sequentiel import Sequentiel
	# -------------------------------------------------------------
	
	# ----------------------------------------------------------
	# MPlayer
	from moteur_modules_animation.mplayer import Mplayer
	# ----------------------------------------------------------
	
	dicoModel = {}
	model = QDirModel()
	model.setFilter(QDir.Dirs)
	dicoModel['visionner_images'] = model
	filtres_option = QDir.AllDirs | QDir.Files
	filtres = QStringList()
	filtres << "*.avi" << "*.mpg" << "*.mpeg" << "*.mjpeg" << "*.flv" << "*.mp4" << "*.ogg"
	model = QDirModel(filtres, filtres_option, QDir.DirsFirst)
	dicoModel['visionner_videos'] = model
	
	main = Gui_EKD(dicoModel)
	main.show()
	sys.exit(app.exec_())