#!/usr/bin/python
# -*- coding: Utf-8 -*-

import os
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from moteur_modules_animation.mplayer import Mplayer, MetaMPlayer
import ConfigParser # pour relever les erreurs

class Base(object):
	"""#---------------------------------------
	# Module des cadres de l'onglet animation
	#---------------------------------------"""
	def __init__(self, parent):
		# Référence à la classe parente
		self.parent = parent
		# Taille du widget mplayer
		self.tailleMplayer = (240,216)
	
	#----------------
	# Meta-widgets
	#----------------
	
	def widgetSource(self, vboxParent, nomSource=None):
		""" Boîte de groupe : "Fichier vidéo source" """
		if not nomSource: nomSource=_(u"Fichier vidéo source")
		self.parent.ligneEditionSource=QLineEdit()
		self.parent.ligneEditionSource.setReadOnly(True)
		
		self.parent.boutParcourir=QPushButton(_(u'Parcourir...'))
		self.parent.boutParcourir.setIcon(QIcon("Icones/ouvrir.png"))
		self.parent.connect(self.parent.boutParcourir, SIGNAL("clicked()"), self.parent.ouvrirSource)
		
		self.parent.groupSource=QGroupBox(nomSource)
		hbox=QHBoxLayout(self.parent.groupSource)
		hbox.addWidget(self.parent.ligneEditionSource)
		hbox.addWidget(self.parent.boutParcourir)
		
		vboxParent.addWidget(self.parent.groupSource)
		
	
	def widgetReglage(self, vboxParent, nomReglage=None, boite='vbox'):
		""" Boîte de groupe de réglage """
		if not nomReglage: nomReglage=_(u"Réglages")
		self.parent.groupReglage=QGroupBox(nomReglage)
		
		if boite=='vbox':
			self.parent.layoutReglage = QVBoxLayout(self.parent.groupReglage)
		elif boite=='hbox':
			self.parent.layoutReglage = QHBoxLayout(self.parent.groupReglage)
		elif boite=='grid':
			self.parent.layoutReglage = QGridLayout(self.parent.groupReglage)
		
		vboxParent.addWidget(self.parent.groupReglage)
	
	
	def widgetBas(self, vboxParent):
		"""widgets du bas : ligne + boutons Aide et Appliquer"""
		if self.parent.idSection not in ['Animation - Convertir des Images en Video',"Animation - Convertir Une Video en Images"]:
			vboxParent.addStretch()
		
		# boutons
		txt = _(u"Aide")
		boutAide=QPushButton("  %s" %txt)
		boutAide.setIcon(QIcon("Icones/icone_aide_128.png"))
		self.parent.connect(boutAide, SIGNAL("clicked()"), self.parent.afficherAide)
		txt = _(u"Appliquer")
		self.parent.boutApp=QPushButton("  %s" %txt)
		self.parent.boutApp.setIcon(QIcon("Icones/icone_appliquer_128.png"))
		if self.parent.ligneEditionSource.text().isEmpty():
			self.parent.boutApp.setEnabled(False)
		self.parent.connect(self.parent.boutApp, SIGNAL("clicked()"), self.parent.appliquer)
		
		# ligne de séparation juste au dessus des boutons
		ligne = QFrame()
		ligne.setFrameShape(QFrame.HLine)
		ligne.setFrameShadow(QFrame.Sunken)
		vboxParent.addWidget(ligne)
		vboxParent.addSpacing(-5)	# la ligne doit être plus près des boutons
		
		hbox=QHBoxLayout()
		hbox.addWidget(boutAide)
		hbox.addStretch()	# espace entre les 2 boutons
		hbox.addWidget(self.parent.boutApp)
		vboxParent.addLayout(hbox)
	
	
	def widget2Mplayer(self):
		"""Boite de dialogue de comparaison de vidéos"""
		
		###### Enlevé le 31/03/09 #################################################################
		# Dimensions des mplayer
		#laTaille=(350,262)
		###########################################################################################
		
		# Widget-mplayer avant encodage: lecture du fichier source
		chemin = self.parent.ligneEditionSource.text()
		
		###### Enlevé le 31/03/09 #################################################################
		#mplayerAvantConv=Mplayer([chemin], taille=laTaille)
		###########################################################################################
		
		###### Rajouté/rectifié le 31/03/09 #######################################################
		mplayerAvantConv=Mplayer([chemin], (350,262), (Mplayer.PAS_PRECEDENT_SUIVANT,Mplayer.CURSEUR_SUR_UNE_LIGNE,Mplayer.PAS_PARCOURIR))
		###########################################################################################
		
		# Widget-mplayer après encodage: lecture du fichier de sortie

		###### Enlevé le 31/03/09 #################################################################
		#mplayerApresConv=Mplayer(self.parent.lstFichiersSortie, taille=laTaille)
		###########################################################################################
		
		###### Rajouté/rectifié le 31/03/09 #######################################################
		mplayerApresConv=Mplayer(self.parent.lstFichiersSortie, (350,262), (Mplayer.PAS_PRECEDENT_SUIVANT,Mplayer.CURSEUR_SUR_UNE_LIGNE,Mplayer.PAS_PARCOURIR))
		###########################################################################################
		
		print "Affichage de la meta-barre mplayer"
		metaMPlayer = MetaMPlayer(mplayerAvantConv,mplayerApresConv)
		metaMPlayer.exec_()
	
	#---------------------
	# Fonctions communes
	#---------------------
	
	def repSortieProv(self):
		"""Répertoire sur lequel s'ouvrira la boite de dialogue de sauvegarde"""
		rep = os.path.dirname(unicode(self.parent.ligneEditionSource.text()))
		if os.path.exists(rep): return rep
		else: return '~'
	
	
	def recupSources(self, nomEntree=None):
		"""Récupère les fichiers sources vidéo via une boite de dialogue. Utilise et modifie les paramètres de configuration"""
		
		if not self.parent.lstFichiersSource: listePleine = False
		else:
			listePleine = True
			fichier = self.parent.lstFichiersSource[0]
			path = os.path.dirname(fichier)
		
		if listePleine and os.path.exists(path):
			repEntree = path
		else:
			try:
				repEntree = self.parent.config.get('Animation','path').decode("UTF8")
			except ConfigParser.NoOptionError, e:
				repEntree = '~'
				self.parent.config.set('Animation','path', repEntree.encode("UTF8"))
			if not os.path.exists(repEntree):
				repEntree = '~'
				self.parent.config.set('Animation','path', repEntree.encode("UTF8"))
		txt = _(u"Fichiers vidéo")
		if not nomEntree:
			liste=QFileDialog.getOpenFileNames(None, _(u"Ouvrir"), os.path.expanduser(repEntree),
				"%s (*.avi *.mpg *.mpeg *.mjpeg *.flv *.mp4 *.dv *.vob)\n*" %txt) ##
			liste = [unicode(i) for i in liste]
		else: # module séquentiel
			liste = nomEntree
		
		if len(liste)==0: return
		self.parent.config.set('Animation','path',os.path.dirname(liste[0]).encode("UTF8"))
		return liste
	
	
	def recupSourcesAudio(self, nomEntree=None):
		"""Récupère les fichiers sources audio via une boite de dialogue. Utilise et modifie les paramètres de configuration"""
		if not self.parent.lstFichiersSourceAudio: listePleine = False
		else:
			listePleine = True
			fichier = self.parent.lstFichiersSourceAudio[0]
			path = os.path.dirname(fichier)
		
		if listePleine and os.path.exists(path):
			repEntree = path
		else:
			try:
				repEntree = self.parent.config.get('Animation','path_audio').decode("UTF8")
			except ConfigParser.NoOptionError, e:
				repEntree = '~'
				self.parent.config.set('Animation','path_audio', repEntree.encode("UTF8"))
			if not os.path.exists(repEntree):
				repEntree = '~'
				self.parent.config.set('Animation','path_audio', repEntree.encode("UTF8"))
		txt = _(u"Fichiers audio")
		if not nomEntree:
			liste=QFileDialog.getOpenFileNames(None, _(u"Ouvrir"), os.path.expanduser(repEntree),
				"%s (*.ogg *.mp3 *.wav *.ac3 *.wmv *.mp2)\n*" %txt)
			liste = [unicode(i) for i in liste]
		else: # module séquentiel
			liste = nomEntree
		
		if len(liste)==0: return
		self.parent.config.set('Animation','path_audio',os.path.dirname(liste[0]).encode("UTF8"))
		return liste
	
	
	def recupSource(self, nomEntree=None, exclure_type=None, inclure_type=None):
		"""Récupère le fichier source vidéo via une boite de dialogue. Utilise et modifie les paramètres de configuration"""
		
		if self.parent.ligneEditionSource.text().isEmpty(): lignePleine = False
		else:
			lignePleine = True
			fichier = unicode(self.parent.ligneEditionSource.text())
			path = os.path.dirname(fichier)
			
		if lignePleine and os.path.exists(path):
			repEntree = path
		else: 
			try:
				repEntree = self.parent.config.get('Animation','path').decode("UTF8")
			except ConfigParser.NoOptionError, e:
				repEntree = '~'
				self.parent.config.set('Animation','path', repEntree.encode("UTF8"))
			if not QFileInfo(repEntree).exists():
				repEntree = '~'
				self.parent.config.set('Animation','path', repEntree.encode("UTF8"))
		if not nomEntree:
			formats = ['avi', 'mpg', 'mpeg', 'mjpeg', 'flv', 'mp4', 'dv', 'vob'] ##
			if exclure_type:
				for type_ in exclure_type:
					if type_ in formats: formats.remove(type_)
			if inclure_type:
				formats.append(inclure_type)
			formats2 = ["*.%s" %i for i in formats]
			txt = _(u"Fichiers vidéo")
			chemin=unicode(QFileDialog.getOpenFileName(None, _(u"Ouvrir"),os.path.expanduser(repEntree),
				"%s (%s)\n*" %(txt, " ".join(formats2))))
		else: # module séquentiel
			chemin = nomEntree
		
		if not chemin: return
		self.parent.config.set('Animation','path',os.path.dirname(chemin).encode("UTF8"))
		return chemin
	
	
	def recupSourceAudio(self, nomEntree=None):
		"""Récupère le fichier source audio via une boite de dialogue. Utilise et modifie les paramètres de configuration"""
		
		if self.parent.ligneEditionSource.text().isEmpty(): lignePleine = False
		else:
			lignePleine = True
			fichier = unicode(self.parent.ligneEditionSource.text())
			path = os.path.dirname(fichier)
			
		if lignePleine and os.path.exists(path):
			repEntree = path
		else: 
			try:
				repEntree = self.parent.config.get('Animation','path_audio').decode("UTF8")
			except ConfigParser.NoOptionError, e:
				repEntree = '~'
				self.parent.config.set('Animation','path_audio', repEntree.encode("UTF8"))
			if not QFileInfo(repEntree).exists():
				repEntree = '~'
				self.parent.config.set('Animation','path_audio', repEntree.encode("UTF8"))
		if not nomEntree:
			txt = _(u"Fichiers audio")
			chemin=unicode(QFileDialog.getOpenFileName(None, _(u"Ouvrir"),os.path.expanduser(repEntree),
				"%s (*.ogg *.mp3 *.wav *.ac3 *.wmv *.mp2)\n*" %txt))
		else: # module séquentiel
			chemin = nomEntree
		
		if not chemin: return
		self.parent.config.set('Animation','path_audio',os.path.dirname(chemin).encode("UTF8"))
		return chemin
	
	
	def afficherAide(self,msg=None):
		""" Boîte de dialogue de l'aide"""
		if not msg: _(u"Message d'aide")
		message=QMessageBox()
		message.setText(msg)
		message.setWindowTitle(_(u"Aide"))
		message.setIcon(QMessageBox.Information)
		message.exec_()
	
	
	def printSection(self):
		"""Affichage dans le terminal de la section initialisée"""
		print '\n'+'-'*30+'\n| '+self.parent.idSection+'\n'+'-'*30+'\n'