#!/usr/bin/python
# -*- coding: Utf-8 -*-

import os, shutil, glob
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from gui_modules_image.image_base import Base
BaseImg = Base # pour différencier les 2 bases
from gui_modules_animation.animation_base import Base
from moteur_modules_animation.mencoder import WidgetMEncoder
from moteur_modules_animation.mplayer import Mplayer

#from gui_modules_lecture.affichage_image.afficheurImage import VisionneurImagePourEKD ## Retiré le 29/12/08

from gui_modules_lecture.lecture_image import Lecture_VisionImage ## Rajouté le 29/12/08


class Animation_ConvertirUneAnimEnImg(QWidget):
	# ----------------------------------------------------------------------------------------
	# Cadre accueillant les widgets de : Animation >> Séparer le flux vidéo et le flux audio
	# ----------------------------------------------------------------------------------------
	def __init__(self, parent):
		QWidget.__init__(self)
		
		# -------------------------------
		# Parametres généraux du widget
		# -------------------------------
		
		#=== Variable de configuration ===#
		self.config=parent.config
		
		self.base = Base(self) # module de animation
		self.baseImg = BaseImg() # module de image
		################ Ajouté le 29/12/08 ############################################################
		# Fonction appelant la fenêtre principale
		self.mainWindowFrameGeometry = parent.frameGeometry
		################################################################################################
		
		#=== tout sera mis dans une boîte verticale ===#
		vbox=QVBoxLayout(self)
		
		#=== Identifiant de la classe ===#
		self.idSection = "Animation - Convertir Une Video en Images"
		self.base.printSection()
		
		# Création des répertoires temporaires
		self.repTampon = '/tmp/ekd/tampon/temp_anim_en_img/'
		if os.path.isdir(self.repTampon) is False:
        		os.makedirs(self.repTampon)
		
		# Au cas où le répertoire existait déjà et qu'il n'était pas vide -> purge (simple précausion)
		for toutRepCompo in glob.glob(self.repTampon+'*.*'):
			os.remove(toutRepCompo)
			
		################ Rajouté le 29/12/08 ###########################################################
		#=== Drapeaux ===#
		# Une conversion (même partielle) a-t-elle eu lieu après le chargement des images? (1: vrai)
		
		# Est-ce que des images ont été converties et qu'elles n'ont pas encore été montrées?
		# Marche aussi quand la conversion a été arrêté avant la fin de la 1ère image
		self.conversionImg = 0
		################################################################################################
		
		#=== Accès à la barre des tâches ===#
		self.statusBar = parent.statusBar()
		
		# -------------------------------------------------------------------
		# Boîte de groupe : "Fichier vidéo source"
		# -------------------------------------------------------------------
		self.base.widgetSource(vbox)
		
		################ Ajouté le 29/12/08 ############################################################
		# Là où s'afficheront les images
		#self.afficheurImgSource=SelectWidget(geometrie = self.mainWindowFrameGeometry)
		self.afficheurImgDestination=Lecture_VisionImage(parent)

		self.listeImgDestin = []
		################################################################################################
		
		#----------
		# Onglets
		#----------
		self.tab = QTabWidget()
		self.dicoTab = {}
		
		#=== Widgets mplayer ===#
		widget = QWidget()
		vboxMplayer = QVBoxLayout(widget)
		vboxMplayer.addStretch()
		hbox = QHBoxLayout()
		vboxMplayer.addLayout(hbox)
		hbox.addStretch()
		
		###### Enlevé le 31/03/09 #################################################################
		#self.mplayer = Mplayer(taille=(350,252))
		###########################################################################################
		
		###### Rajouté/rectifié le 31/03/09 #######################################################
		self.mplayer=Mplayer((350,252), choixWidget=(Mplayer.PAS_PRECEDENT_SUIVANT,Mplayer.CURSEUR_SUR_UNE_LIGNE,Mplayer.PAS_PARCOURIR))
		###########################################################################################
		
		hbox.addWidget(self.mplayer)
		hbox.addStretch()
		vboxMplayer.addStretch()
		chemin = self.ligneEditionSource.text()
		self.mplayer.setEnabled(False)
		self.dicoTab['video']=self.tab.addTab(widget, _(u'Vidéo source'))
		
		#=== Là où s'afficheront les images ===#
		widget = QWidget()
		vboxMplayer = QVBoxLayout(widget)
		################ Ajouté le 29/12/08 ############################################################
		self.dicoTab['images']=self.tab.addTab(self.afficheurImgDestination, _(u'Images créées'))
		################################################################################################

		'''
		################ Retiré le 29/12/08 ############################################################
		self.afficheurImg=VisionneurImagePourEKD()
		self.curseurImg = QSlider(Qt.Horizontal)
		self.curseurImg.setEnabled(False)
		
		# Drapeau servant à ne pas afficher 2 fois la même image
		self.verrouillerValueChange = 0
		self.connect(self.curseurImg,SIGNAL("sliderReleased()"), self.curseurImgRelache)
		self.connect(self.curseurImg,SIGNAL("sliderMoved(int)"), self.curseurImgBouge)
		self.connect(self.curseurImg,SIGNAL("sliderPressed()"), self.curseurPresse)
		self.connect(self.curseurImg,SIGNAL("valueChanged(int)"), self.curseurChange)
		
		vboxMplayer.addWidget(self.afficheurImg)
		vboxMplayer.addWidget(self.curseurImg)
		self.dicoTab['images']=self.tab.addTab(widget, _(u'Images crées'))
		################################################################################################
		'''
		
		vbox.addWidget(self.tab)
		
		# -------------------------------------------------------------------
		# widgets du bas : ligne + boutons Aide et Appliquer
		# -------------------------------------------------------------------
		self.base.widgetBas(vbox)
		
		# affichage de la boîte principale
		self.setLayout(vbox)
	
	
	################ Ajouté le 29/12/08 #############################################################
	def fctTab(self):
		"Affichage d'une ou plusieurs images converties"
		
		# Cela ne concerne que l'onglet de visualisation des images après leur conversion
		# Affichage si on sauvegarde par le bouton Appliquer et sauver
		print "La conversion vient d'avoir lieu -> affichage des images du lot de destination"
		cheminImages = os.path.dirname(self.listeImgDestin[0])
		liste = []
		for fichier in self.listeImgDestin:
			liste.append(os.path.basename(fichier))
		self.afficheurImgDestination.updateImages(liste, cheminImages)

		self.conversionImg = 0
		
		# Affichage (après conversion) de l'onglet contenant les images
		self.tab.setCurrentIndex(self.dicoTab['images'])
		
		# On libere la memoire
		del cheminImages, liste, fichier
	################################################################################################
	

	'''
	################ Retiré le 29/12/08 ############################################################
	def curseurImgRelache(self):
		"""Changement de l'image affichée lors du déplacement du curseur associée"""
		self.verrouillerValueChange = 0
		i = self.curseurImg.value()
		self.afficheurImg.setImage(self.listeFichierFinal[i])
	
	def curseurImgBouge(self, i):
		"""Montre le nom de l'image qui serait affichée si le curseur associée était relâché"""
		self.statusBar.showMessage(self.listeFichierFinal[i])
	
	def curseurPresse(self):
		self.verrouillerValueChange = 1
	
	def curseurChange(self, i):
		"Permet un changement de l'image avec les flèches gauche et droite \
		et avec un simple clic sur une partie du curseur"
		if not self.verrouillerValueChange:
			self.afficheurImg.setImage(self.listeFichierFinal[i])
			self.statusBar.showMessage(self.listeFichierFinal[i])
	################################################################################################
	'''
	
	
	def ouvrirSource(self, nomEntree=None):
		"""Récupération du chemin de la vidéo sélectionnée et activation de certains widgets"""
		
		# Récupération du chemin de la vidéo
		chemin = self.base.recupSource(nomEntree)
		if not chemin: return
		
		#print "chemin vidéo d'entrée:", chemin, type(chemin)
		
		# Affichage du chemin + nom de fichier dans la ligne d'édition
		self.ligneEditionSource.setText(chemin)
		
		self.boutApp.setEnabled(True)
		
		self.mplayer.setEnabled(True)
		self.mplayer.listeVideos = [chemin]
		
		'''
		################ Retiré le 28/12/08 ##############################
		self.afficheurImg.setImage()
		self.curseurImg.setEnabled(False)
		##################################################################
		'''
		
		self.tab.setCurrentIndex(self.dicoTab['video'])
		
		# On libere la memoire
		del chemin
	
	
	def appliquer(self, nomSortie=None, ouvert=1):
		""" Appelle la boite de dialogue de sélection de fichier à sauver et appel de la fonction de conversion d'une vidéo en images """
		
		#=== Détermination des chemins d'entrée et sortie ===#
		
		if not nomSortie:
			# récupération du chemin de la vidéo de destination (à l'exception de l'extension)
			rep = self.baseImg.getRepSource(self.config)
			chemin=unicode(QFileDialog.getSaveFileName(None, _(u"Sauver"), rep, _(u"Tous les fichiers *.*")))
		else: # module séquentiel
			chemin=nomSortie
		
		if not chemin: return
		
		# Préfixe des images
		prefixeImg=os.path.basename(chemin)
		
		# Chemin du répertoire de sortie des images
		cheminRepDestination = os.path.dirname(chemin) + '/'
		
		# Récupération du chemin de la vidéo source
		cheminVideoSource=unicode(self.ligneEditionSource.text())
		
		commande = "mplayer \""+cheminVideoSource+" -vo jpeg:outdir=\""+self.repTampon+"\":quality=100"
		
		try:
			mencoder = WidgetMEncoder('jpeg', cheminVideoSource, self.repTampon, laisserOuvert=ouvert)
			mencoder.setWindowTitle(_(u"Convertir une animation en images"))
			mencoder.exec_()
		except:
			messageErrAnEnc=QMessageBox(self)
			messageErrAnEnc.setText(_(u"Problème lors de la conversion d'une vidéo en images (mencoder)"))
			messageErrAnEnc.setWindowTitle(_(u"Erreur"))
			messageErrAnEnc.setIcon(QMessageBox.Warning)
			messageErrAnEnc.exec_()
			return
		
		# Renommage et déplacement des fichiers dans le bon répertoire
		# Liste des noms de fichiers (de type 00000001.jpg ... 00000025.jpg ...)
		listeFichiers=os.listdir(self.repTampon)
		self.listeFichierFinal = []
		for nomFichier in listeFichiers:
			shutil.move(self.repTampon+nomFichier, cheminRepDestination+prefixeImg+'_'+nomFichier)
			self.listeFichierFinal.append(cheminRepDestination+prefixeImg+'_'+nomFichier)
			
			################## Ajouté le 29/12/08 ###########################################
			self.listeImgDestin.append(cheminRepDestination+prefixeImg+'_'+nomFichier)
			#################################################################################
		
		self.listeFichierFinal.sort()
		
		self.listeImgDestin.sort()
		
		'''
		################ Retiré le 29/12/08 ###########################################
		self.convEffectuee = 1
		self.curseurImg.setRange(0,len(self.listeFichierFinal)-1)
		self.curseurImg.setValue(0)
		self.curseurImg.setEnabled(True)
		self.tab.setCurrentIndex(self.dicoTab['images'])
		self.afficheurImg.setImage(self.listeFichierFinal[0])
		###############################################################################
		'''

		#################### Rajouté le 29/12/08 ######################################
		# Affichage des images après traitement (appel de la fonction fctTab)
		self.conversionImg = 1
		self.fctTab()

		# ATTENTION IL FAUT AJOUTER CECI NE PAS OUBLIER !!!
		# La liste pour l'affichage des images ds l'interface est
		# vidée pour que les images affichées ne s'amoncellent pas
		# si plusieurs rendus à la suite
		self.listeImgDestin=[]
		###############################################################################

		return self.listeFichierFinal # module séquentiel
		
		# On libere la memoire
		del nomSortie, rep, chemin, prefixeImg, cheminRepDestination, cheminRepDestination, cheminVideoSource, commande, mencoder, listeFichiers, nomFichier
	

	def sequentiel(self, entree, sortie, ouvert=0):
		"""Utile dans le module du même nom. Applique les opérations de la classe. Retourne le vrai nom du fichier de sortie"""
		self.ouvrirSource(entree)
		return self.appliquer(sortie, ouvert)
	
	
	def sequentielReglage(self):
		"""Utile dans le module du même nom. Récupère le widget de réglage associé à l'identifiant donné en 1er argument. Retourne l'instance du widget de réglage"""
		groupReglage =  QGroupBox(_(u"Réglages: convertir une animation en images"))
		hbox = QHBoxLayout(groupReglage)
		hbox.addWidget(QLabel(_(u"<center>Pas de réglages ici</center>")))
		return groupReglage
	
	
	def afficherAide(self):
		""" Boîte de dialogue de l'aide """
		
		## Ajouté le 28/12/08
		self.base.afficherAide(tr(u"<p>Cliquez sur le bouton <b>'Parcourir...'</b>, dans la boîte de dialogue allez chercher votre vidéo dans l'arborescence, sélectionnez-la. Cliquez sur le bouton <b>'Appliquer'</b>, sélectionnez le répertoire de sauvegarde de vos images, entrez le <b>'Nom de Fichier'</b> dans le champ de texte réservé à cet effet ... cliquez sur le bouton <b>'Enregistrer'</b> et attendez le temps de la conversion. A la fin cliquez sur le bouton <b>'Voir les informations d'encodage'</b> et fermez cette dernière fenêtre après avoir vu les informations en question. Vous pouvez visionner votre vidéo (avant la conversion) dans l'onglet <b>'Vidéo source'</b> et le résultat en images dans l'onglet <b>'Images créées'</b>.</p><p>Dans ce dernier onglet vous pouvez faire défiler les images par le bouton <b>Lancer le diaporama</b> (le bouton violet avec une flèche blanche vers la droite). Si vous faites un clic droit de la souris sur une des images résultantes, vous accédez à des paramètres vous permettant différents affichages de la dite image.</p>"))
		
		'''
		messageAide=QMessageBox(self)
		messageAide.setText(_(u"Blablablabla ... blabla anim_conv_video_en_img."))
		messageAide.setWindowTitle(_(u"Aide"))
		messageAide.setIcon(QMessageBox.Information)
		messageAide.exec_()
		'''
		