#!/usr/bin/python
# -*- coding: Utf-8 -*-

import os, Image, shutil, glob, string
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from gui_modules_image.image_base import Base
BaseImg = Base # pour différencier les 2 bases
from gui_modules_animation.animation_base import Base
from moteur_modules_animation.mencoder import WidgetMEncoder
from moteur_modules_animation.mplayer import Mplayer

#from gui_modules_lecture.affichage_image.afficheurImage import VisionneurImagePourEKD ## Retiré le 28/12/08

from gui_modules_image.selectWidget import SelectWidget ## 28/12/08
from gui_modules_lecture.lecture_image import Lecture_VisionImage ## 28/12/08


class Animation_ConvertirImgEnAnim(QWidget):
	"""-----------------------------------------
	# Cadre accueillant les widgets de :
	# Animation >> convertir images en animations
	# -----------------------------------------"""
	def __init__(self, parent):
		QWidget.__init__(self)
		
		# -------------------------------
		# Parametres généraux du widget
		# -------------------------------
		
		#=== Variable de configuration ===#
		self.config=parent.config
		
		# Identifiant de la classe
		self.idSection = 'Animation - Convertir des Images en Video'
		
		self.statusBar = parent.statusBar()
		#self.statusBar = QStatusBar()
		
		self.base = Base(self) # module de animation
		self.baseImg = BaseImg() # module de image
		################ Ajouté le 28/12/08 ############################################################
		# Fonction appelant la fenêtre principale
		self.mainWindowFrameGeometry = parent.frameGeometry
		################################################################################################

		self.base.printSection()
		
		# Définition du chemin temporaire des fichiers
		self.repTempEntree='/tmp/ekd/tampon/conv_img_en_video/'
		
		# création des répertoires temporaires
		if os.path.isdir(self.repTempEntree) is False:
        		os.makedirs(self.repTempEntree)
			
		if os.path.isdir(self.repTempEntree+'redim/') is False:
        		os.makedirs(self.repTempEntree+'redim/')
			
		################ Ajouté le 13/01/09 ############################################################
		# Ce répertoire est crée pour le cas où l'utilsateur charge des images dont une des dimensions
		# (largeur et/ou hauteur) est impaire, en effet FFmpeg veut des images avec des résolutions
		# paires pour faire son travail !
		if os.path.isdir(self.repTempEntree+'img_res_impair/') is False:
        		os.makedirs(self.repTempEntree+'img_res_impair/')
		################################################################################################
			
		# Epuration/elimination des fichiers tampon contenus
		# dans /tmp/ekd/tampon/conv_img_en_video
		for toutRepTempE in glob.glob(self.repTempEntree+'*.*'):
			os.remove(toutRepTempE)
			
		# Scan du répertoire tampon /tmp/ekd/tampon/conv_img_en_video/redim
		listeRepTempRedim=glob.glob(self.repTempEntree+'redim/*.*')
		
		# Epuration/elimination des fichiers tampon contenus
		# dans /tmp/ekd/tampon/conv_img_en_video/redim
		if len(listeRepTempRedim)>0:
			for toutRepTempE_Redim in listeRepTempRedim:
				os.remove(toutRepTempE_Redim)
				
		################ Ajouté le 13/01/09 ############################################################
		# Scan du répertoire tampon /tmp/ekd/tampon/conv_img_en_video/img_res_impair
		listeRepTempImResImp=glob.glob(self.repTempEntree+'img_res_impair/*.*')
		
		# Epuration/elimination des fichiers tampon contenus
		# dans /tmp/ekd/tampon/conv_img_en_video/img_res_impair
		if len(listeRepTempImResImp)>0:
			for toutRepTempE_ImResImp in listeRepTempImResImp:
				os.remove(toutRepTempE_ImResImp)
		################################################################################################
				
		################ Rajouté le 28/12/08 ###########################################################
		#=== Drapeaux ===#
		# Une conversion (même partielle) a-t-elle eu lieu après le chargement des images? (1: vrai)

		# Est-ce que des images sources ont été modifiées? (c'est-à-dire ajoutées ou supprimées)
		self.modifImageSource = 0
		################################################################################################
			
		#=== tout sera mis dans une boîte verticale ===#
		vbox=QVBoxLayout(self)
		
		'''
		################ Retiré le 28/12/08 ############################################################
		# -------------------------------------------------------------------
		# Boîte de groupe : "Fichier vidéo source"
		# -------------------------------------------------------------------
		self.base.widgetSource(vbox, _(u"Fichiers images sources"))
		################################################################################################
		'''
		
		# -------------------------------------------------------------------
		# Boîte de groupe "Réglage de sortie de l'encodage"
		# -------------------------------------------------------------------
		
		#=== Création de la boite de groupe de réglage (contenant la boite self.layoutReglage) ===#
		self.base.widgetReglage(vbox, nomReglage=_(u"Réglages"), boite='grid')
		
		#=== Widget qui seront inclus dans la boite de réglage ===#
		
		#||| titre |||#
		txt = _(u"Nombre d'images/s")
		self.label = QLabel("<u>%s</u> :" %txt) ## self.label
		self.layoutReglage.addWidget(self.label,0,0,1,2,Qt.AlignHCenter) ## self.label
		txt = _(u"Codecs")
		label = QLabel("<u>%s</u> :" %txt)
		self.layoutReglage.addWidget(label,0,3,Qt.AlignHCenter)
		
		#||| Stacked |||#
		
		# Élement par défaut du stacked
		
		# Le codec mpeg1 prenant un nombe limité de valeurs
		# il n'aura pas droit à son spin mais à une boite de combo
		self.comboMPEG1 = QComboBox()
		#listeComboMPEG1 = ['5','10','12','15','24','25','30','50','60']
		listeComboMPEG1 = ['24','25','30']
		for i in listeComboMPEG1:
			self.comboMPEG1.addItem(i)
		self.connect(self.comboMPEG1,SIGNAL("currentIndexChanged(int)"),self.comboMPEG1Change)
		
		self.frameCombo = QFrame()
		boiteFrame = QHBoxLayout()
		boiteFrame.addWidget(self.comboMPEG1)
		self.frameCombo.setLayout(boiteFrame)
		
		# autre élément du stacked
		
		self.spin = QSpinBox()
		self.spin.setRange(1,100) # 25 par défaut
		
		self.curseur = QSlider(Qt.Horizontal)
		self.curseur.setRange(1,100)
		self.curseur.setMaximumSize(175,175)
		
		self.FrameSpinCurseur = QFrame()
		boiteFrame = QHBoxLayout()
		boiteFrame.addWidget(self.spin)
		boiteFrame.addWidget(self.curseur)
		self.FrameSpinCurseur.setLayout(boiteFrame)
		
		# remplissage du stacked
		
		self.stacked = QStackedWidget()
		self.stackedCombo = self.stacked.addWidget(self.frameCombo)
		self.stackedspinCurseur = self.stacked.addWidget(self.FrameSpinCurseur)
		
		self.layoutReglage.addWidget(self.stacked,1,0, Qt.AlignCenter)
		
		#||| boite de combo |||#
		
		self.combo=QComboBox() # le self sert à afficher des informations sur les items à partir de la fonction

		listeCombo=[(_(u'MPEG1 video (.mpg)'), 'mpeg1video'),\
			(_(u'HFYU: Huffman Losless YUV (.avi)'), 'huffyuv'),\
			(_(u'DV (.dv)'), 'dv'),\
			(_(u'QuickTime MOV (.mov)'), 'mov'),\
			(_(u'Motion JPEG (.avi)'), 'mjpeg'),\
			(_(u'VOB: DVD-Video stream MPEG-2 (.vob)'), 'vob'),\
			(_(u'MPEG 4 (.mp4)'), 'mp4'),\
			(_(u'H263 Plus (.avi)'), 'h263p'),\
			(_(u'DivX 4-5 (.avi)'),	'mpeg4'),\
			(_(u'MS-MPEG4v2 (.avi)'), 'msmpeg4v2'),\
			(_(u'Lossless JPEG (.avi)'), 'ljpeg'),\
			(_(u'Macromedia Flash Video (.flv)'), 'flv')]
		
		# Insertion des codecs de compression dans la combo box
		for i in listeCombo:
                	self.combo.addItem(i[0],QVariant(i[1]))
		self.layoutReglage.addWidget(self.combo,1,3)
		
		self.connect(self.spin,SIGNAL("valueChanged(int)"), self.spinChange)
		self.connect(self.curseur,SIGNAL("sliderMoved(int)"), self.curseurBouge)
		self.connect(self.combo,SIGNAL("currentIndexChanged(int)"),self.stackedChange)
		
		# [bidouillage] espacement entre les 2 colonnes
		# Rq: spacing espace les cellules en horizontal et en vertical -> pas joli
		self.layoutReglage.addWidget(QLabel("         "),0,2)
		self.layoutReglage.addWidget(QLabel("         "),1,2)
		self.layoutReglage.setAlignment(Qt.AlignHCenter)
		
		# Chargement des paramètres de configuration
		try:
			typ = self.config.get(self.idSection,'codec')
			indice = 0 # indice de la ligne de self.listeCombo correspondant au type d'ordre
			for i in listeCombo:
				if i[1]!=typ:
					indice += 1
				else:
					break
			self.combo.setCurrentIndex(indice)
		except:
			self.combo.setCurrentIndex(0)
		
		try:
			spin = int(self.config.get(self.idSection,'nbr_img_sec'))
			self.spin.setValue(spin)
		except:
			self.spin.setValue(25)
		
		try:
			spin = self.config.get(self.idSection,'nbr_img_sec_mpeg1video')
			indice = 0 # indice de la ligne de self.listeCombo correspondant au type d'ordre
			for i in listeComboMPEG1:
				if i!=spin:
					indice += 1
				else:
					break
			self.comboMPEG1.setCurrentIndex(indice)
		except:
			# Valeur 25 sélectionnée par défaut
			indice = 0 # indice de la ligne de self.listeCombo correspondant à 25
			for i in listeComboMPEG1:
				if i!='25':
					indice += 1
				else:
					break
			self.comboMPEG1.setCurrentIndex(int(indice))
			
		################ Ajouté le 28/12/08 ############################################################
		# Là où s'afficheront les images
		self.afficheurImgSource=SelectWidget(geometrie = self.mainWindowFrameGeometry)
		################################################################################################
		
		#----------
		# Onglets
		#----------
		self.tab = QTabWidget()
		self.dicoTab = {}
		
		#=== Tabwidget de boîte de chargement des images ===#
		widget = QWidget()
		vboxMplayer = QVBoxLayout(widget)
		################ Ajouté le 28/12/08 ############################################################
		self.dicoTab['images']=self.tab.addTab(self.afficheurImgSource, _(u'Image(s) source(s)'))
		################################################################################################
	
		'''
		################ Retiré le 28/12/08 ############################################################
		#self.afficheurImg=VisionneurImagePourEKD()

		self.curseurImg = QSlider(Qt.Horizontal)
		self.curseurImg.setEnabled(False)
		# Drapeau servant à ne pas afficher 2 fois la même image
		self.verrouillerValueChange = 0
		self.connect(self.curseurImg,SIGNAL("sliderReleased()"), self.curseurImgRelache)
		self.connect(self.curseurImg,SIGNAL("sliderMoved(int)"), self.curseurImgBouge)
		self.connect(self.curseurImg,SIGNAL("sliderPressed()"), self.curseurPresse)
		self.connect(self.curseurImg,SIGNAL("valueChanged(int)"), self.curseurChange)

		vboxMplayer.addWidget(self.afficheurImg)
		#vboxMplayer.addWidget(self.curseurImg)
		#self.dicoTab['images']=self.tab.addTab(widget, _(u'Images sources'))
		################################################################################################
		'''
		
		#=== Widgets mplayer ===#
		widget = QWidget()
		vboxMplayer = QVBoxLayout(widget)
		vboxMplayer.addStretch()
		hbox = QHBoxLayout()
		vboxMplayer.addLayout(hbox)
		hbox.addStretch()
		
		###### Enlevé le 31/03/09 #################################################################
		#self.mplayer = Mplayer(taille=(350,252))
		###########################################################################################
		
		###### Rajouté/rectifié le 31/03/09 #######################################################
		self.mplayer=Mplayer((350,252), choixWidget=(Mplayer.PAS_PRECEDENT_SUIVANT,Mplayer.CURSEUR_SUR_UNE_LIGNE,Mplayer.PAS_PARCOURIR))
		###########################################################################################
		
		hbox.addWidget(self.mplayer)
		hbox.addStretch()
		vboxMplayer.addStretch()
		################ Retiré le 28/12/08 ############################################################
		#chemin = self.ligneEditionSource.text()
		################################################################################################
		self.mplayer.setEnabled(False)
		self.dicoTab['video']=self.tab.addTab(widget, _(u'Vidéo créée'))
		
		vbox.addWidget(self.tab)
		
		'''
		################ Retiré le 28/12/08 ############################################################
		# -------------------------------------------------------------------
		# widgets du bas : ligne + boutons Aide et Appliquer
		# -------------------------------------------------------------------
		self.base.widgetBas(vbox)
		################################################################################################
		'''
		
		################ Ajouté le 28/12/08 ############################################################
		# -------------------------------------------------------------------
		# widgets du bas : ligne + boutons
		# -------------------------------------------------------------------
		
		# boutons
		
		# Aide
		boutAide=QPushButton(_(u" Aide"))
		boutAide.setIcon(QIcon("Icones/icone_aide_128.png"))
		self.connect(boutAide, SIGNAL("clicked()"), self.afficherAide)
		# Appliquer
		self.boutAppliquer=QPushButton(_(u"  Appliquer"))
		self.boutAppliquer.setIcon(QIcon("Icones/icone_appliquer_128.png"))
		# Bouton inactif au départ
		self.boutAppliquer.setEnabled(False)
		self.connect(self.boutAppliquer, SIGNAL("clicked()"), self.appliquer)
		
		# ligne de séparation juste au dessus des boutons
		ligne = QFrame()
		ligne.setFrameShape(QFrame.HLine)
		ligne.setFrameShadow(QFrame.Sunken)
		vbox.addWidget(ligne)
		vbox.addSpacing(-5)	# la ligne doit être plus près des boutons
		
		hbox=QHBoxLayout()
		hbox.addWidget(boutAide)
		hbox.addStretch()	# espace entre les 2 boutons
		hbox.addWidget(self.boutAppliquer)
		vbox.addLayout(hbox)
		################################################################################################
		
		# affichage de la boîte principale
		self.setLayout(vbox)
		
		################ Ajouté le 28/12/08 ############################################################
		#----------------------------------------------------------------------------------------------------
		# Signal de présence d'images dans ler widget de sélection -> modifie le statut des boutons d'action
		#----------------------------------------------------------------------------------------------------
		
		self.connect(self.afficheurImgSource, SIGNAL("pictureChanged(int)"), self.modifBoutonsAction)
		################################################################################################
		
		
	################ Ajouté le 28/12/08 ############################################################
	def modifBoutonsAction(self, i):
		"On active ou désactive les boutons d'action selon s'il y a des images ou pas dans le widget de sélection"
		self.boutAppliquer.setEnabled(i)
		self.modifImageSource = 1
	################################################################################################
	
	
	'''
	################ Retiré le 28/12/08 ############################################################
	def curseurImgRelache(self):
		"""Changement de l'image affichée lors du déplacement du curseur associée"""
		self.verrouillerValueChange = 0
		i = self.curseurImg.value()
		self.afficheurImg.setImage(self.listeChemin[i])
	
	def curseurImgBouge(self, i):
		"""Montre le nom de l'image qui serait affichée si le curseur associée était relâché"""
		self.statusBar.showMessage(self.listeChemin[i])
	
	def curseurPresse(self):
		self.verrouillerValueChange = 1
	
	def curseurChange(self, i):
		"Permet un changement de l'image avec les flèches gauche et droite \
		et avec un simple clic sur une partie du curseur"
		if not self.verrouillerValueChange:
			self.afficheurImg.setImage(self.listeChemin[i])
			self.statusBar.showMessage(self.listeChemin[i])
	################################################################################################
	'''
	
	
	def spinChange(self, i):
		"""modifie le curseur lorsque le curseur bouge"""
		self.curseur.setValue(i)
		self.config.set(self.idSection,'nbr_img_sec',self.spin.value())
	
	
	def curseurBouge(self, i):
		"""Quand on change la position du curseur la valeur du spin est automatiquement modifiée"""
		self.spin.setValue(i)
	
	
	def comboMPEG1Change(self, i):
		idCombo = self.comboMPEG1.currentText()
		self.config.set(self.idSection,'nbr_img_sec_mpeg1video',idCombo)
	
	
	def stackedChange(self,i):
		"""Le widget de sélection de la valeur numérique associée à la boite de combo peut changer suivant le codec"""
		idCombo = str(self.combo.itemData(i).toStringList()[0])
		
		# On cache ou on affiche le spin et le cuseur. Pour le codec DV et
		# VOB le réglage du nombre d'images/secondes n'est pas utilisé.
		if idCombo=='dv': 
			self.label.hide()
			self.spin.hide()
			self.curseur.hide()
		elif idCombo=='vob':
			self.label.hide()
			self.spin.hide()
			self.curseur.hide()
		else:
			self.label.show()
			self.spin.show()
			self.curseur.show()
		
		print "Combo :", idCombo
		if idCombo=='mpeg1video':
			self.stacked.setCurrentIndex(self.stackedCombo)
		else:
			self.stacked.setCurrentIndex(self.stackedspinCurseur)
		if idCombo=='ljpeg':
			self.statusBar.showMessage(_(u"La vidéo résultante ne pourra pas être lue avec tous les logiciels (ex. bon avec mplayer mais pas avec xine)"))
		else:
			self.statusBar.clearMessage()
		self.config.set(self.idSection,'codec', idCombo)
	
	
	'''
	################ Retiré le 28/12/08 ############################################################
	def ouvrirSource(self, nomEntree=None):
		""" Récupération du chemin de la vidéo sélectionnée """
		if not nomEntree:
			txt = _(u"Fichiers vidéos")
			rep = self.baseImg.getRepSource(self.config)
			listeChemin=QFileDialog.getOpenFileNames(None, _(u"Ouvrir"), rep, ("JPEG (*.jpg *.JPG *.jpeg *.JPEG);;PNG (*.png *.PNG);;GIF (*.gif *.GIF);;BMP (*.bmp *.BMP);;SGI (*.sgi *.SGI);;TIF (*.tif *.TIF);;TARGA (*.tga *.TGA);;PNM (*.pnm *.PNM);;PPM (*.ppm *.PPM);; *"))
			self.listeChemin = [unicode(j) for i, j in enumerate(listeChemin)]
			self.baseImg.setRepSource(self.config, self.listeChemin)
		else: # module séquentiel
			self.listeChemin = nomEntree
		
		if not self.listeChemin: return
		
		#self.listeChemAVcanAlph=[str(chemin_avec_can_alph[iAVcan]) for iAVcan in range(chemin_avec_can_alph.count())]
		
		#print "Chemins sélectionnés", self.listeChemin
		
		# extension de la 1ère image (avec étoile devant)
		# Sert uniquement pour l'affichage dans la ligne d'édition ##
		fich, ext=os.path.splitext(self.listeChemin[0])
		self.extAvecEtoile = "*"+ext
		
		# Extension véritable des images
		self.ext=ext ##
		
		# répertoire courant d'entrée
		repCourEntree = os.path.dirname(self.listeChemin[0])
		
		# remplissage de la ligne d'édition
		self.ligneEditionSource.setText(repCourEntree+"/"+self.extAvecEtoile)
		
		# Affichage du chemin + nom de fichier dans la zone
		# de texte du widget QLineEdit (de l'init) .
		#self.ligneEditionSource.setText(listeChemin)
		
		self.curseurImg.setRange(0,len(self.listeChemin)-1)
		self.curseurImg.setValue(0)
		self.afficheurImg.setImage(self.listeChemin[0])
		self.curseurImg.setEnabled(True)
		self.tab.setCurrentIndex(self.dicoTab['images'])
		
		# Quand un fichier est sélectionné, le bouton "Séparer" devient cliquable
		# et la vidéo peut être lue avec mplayer
		self.boutApp.setEnabled(True)
		
		#self.config.set('Animation Encodage','path',chemin)
	################################################################################################
	'''
		
		
	####### Ajouté le 13/01/09 #####################################################################
	def img_resolution_impaire(self):
		""" Fonction servant à redimensionner les images dans des résolutions paires car
		si les images chargées par l'utilisateur (au moins une des dimensions) est impaire
		FFmpeg (pour la conversion des images en vidéo) ne fera rien et renverra un 
		message d'erreur: Frame size must be a multiple of 2 """
		
		# Si l'utilisateur charge des images de taille différente, fait le traitement 
		# ...,  recharge de nouvelles images, il faut que le répertoire img_res_impair
		# soit vidé
		listePresTempImResImp=glob.glob(self.repTempEntree+'img_res_impair/*.*')
		listePresTempImResImp.sort()
		if len(listePresTempImResImp)>0:
			for parcIRI in listePresTempImResImp: os.remove(parcIRI)
		
		# Récupération de la liste des fichiers chargés
		lImg=self.afficheurImgSource.getFiles()

		# Liste vérif si img avec résolution impaire ds le lot d'img
		lResImpair=[]
		# Liste servant si des images avec résolution paire sont
		# présentes ds le lot
		lResPair=[]
		# Redimensionnement
		for parc_lImg in lImg:
			chemin = self.repTempEntree+'img_res_impair/'+os.path.basename(parc_lImg)
			ouvIm = Image.open(parc_lImg)
			w = ouvIm.size[0] # largeur
			h = ouvIm.size[1] # hauteur
			# Si dimension largeur impaire
			if w % 2 == 1 and h % 2 == 0: 
				red = ouvIm.resize((w-1, h)).save(chemin)
				lResImpair.append(parc_lImg)
			# Si dimension hauteur impaire
			if h % 2 == 1 and w % 2 == 0: 
				red = ouvIm.resize((w, h-1)).save(chemin)
				lResImpair.append(parc_lImg)
			# Si les deux dimensions (largeur et hauteur) impaires
			if w % 2 == 1 and h % 2 == 1: 
				red = ouvIm.resize((w-1, h-1)).save(chemin)
				lResImpair.append(parc_lImg)
			# Dans le cas où l'utilisateur charge des images de résolutions
			# différentes et dans ce lot il y a des images avec dimension paires,
			# la liste lResPair est remplie par ces images, les images sont tout 
			# de même traitées ds la fonction stat_dim_img
			if w % 2 == 0 and h % 2 == 0: lResPair.append(parc_lImg)
			
		# Si la liste des images avec résolution impaire n'est pas vide, les images avec
		# résolution paire sont copiées ds le rep. img_res_impair pour être traitées avec
		# tout le lot d'images
		if len(lResImpair)>0:
			# Copie des images collectées dans le rep.tempo img_res_impair
			for parcl in lResPair: p=shutil.copy(parcl, self.repTempEntree+'img_res_impair')
	################################################################################################
		
	
	def stat_dim_img(self):
		"""Calcul statistique des dimensions des images les plus présentes dans le lot"""
		
		####### Ajouté/Changé le 13/01/09 #########################################
		self.img_resolution_impaire()
		
		listeRedim=glob.glob(self.repTempEntree+'img_res_impair/*.*')
		listeRedim.sort()
		# Si aucune image ne comporte une résolution impaire
		if len(listeRedim)==0:
			# ATTENTION IL FAUT AJOUTER CECI NE PAS OUBLIER !!!
			# Récupération de la liste des fichiers chargés
			self.listeChemin=self.afficheurImgSource.getFiles()
		# Si une image comporte une résolution impaire
		elif len(listeRedim)>0: self.listeChemin=listeRedim
		###########################################################################
		
		# Ouverture et mise ds une liste des dimensions des images
		listePrepaRedim=[Image.open(aA).size for aA in self.listeChemin]
		
		# Merci beaucoup à Marc Keller de la liste: python at aful.org de m'avoir
		# aidé pour cette partie (les 4 lignes en dessous)
		dictSeq={}.fromkeys(listePrepaRedim, 0)
		for cle in listePrepaRedim: dictSeq[cle]+=1
		self.lStatDimSeq=sorted(zip(dictSeq.itervalues(), dictSeq.iterkeys()), reverse=1)
		self.dimStatImg=self.lStatDimSeq[0][1]
		
		print "Toutes les dimensions des images (avec le nbre d'images):", self.lStatDimSeq
		print 'Dimension des images la plus presente dans la sequence:', self.dimStatImg
		print "Nombre de tailles d'images différentes dans le lot :", len(self.lStatDimSeq)
		
		if len(self.lStatDimSeq)>1:
			return 0
		else:
			return 1
		
		# On libere la memoire
		del listePrepaRedim, aA, dictSeq, cle
	
	
	def redim_img(self):
		"""Si l'utilisateur charge des images avec des tailles complètement différentes --> les images de la séquence  peuvent être redimensionnées"""
		
		if not self.stat_dim_img():
			reply = QMessageBox.warning(self, 'Message',
			_(u"Vos images ne sont pas toutes de la même taille. Voulez-vous redimensionner les images de sortie à la taille la plus répandue dans la séquence?"), QMessageBox.Yes, QMessageBox.No) ##
			if reply == QMessageBox.No:
				return
				
			# Les images de tailles différentes à la plus répandue sont redimensionnées
			# dans un répertoire temporaire.
			# Les images redimensionnées voient leur chemin modifié dans la liste des
			# chemins des images sources. Les autres chemins ne changent pas.
			index=0
			for chemImg in self.listeChemin:
				obImg=Image.open(chemImg)
				if obImg.size!=self.dimStatImg:
					pass
				sRedim=obImg.resize(self.dimStatImg)
				chemSortie = self.repTempEntree+'redim/'+os.path.basename(chemImg)
				sRedim.save(chemSortie)
				self.listeChemin[index] = chemSortie
				index += 1
				
		# On libere la memoire
		del index, chemImg, obImg, sRedim, chemSortie	
	
	
	def appliquer(self, nomSortie=None, ouvert=1):
		""" appelle la boite de dialogue de sélection de fichier à sauver et appel de la fonction de séparation audio-vidéo """
		
		####### Ajouté/Changé le 13/01/09 #########################################
		# Si l'utilisateur charge des images de taille différente, fait le traitement 
		# ...,  recharge de nouvelles images, il faut que le répertoire de redimen-
		# sionnement soit vidé
		listePresRedim=glob.glob(self.repTempEntree+'redim/*.*')
		listePresRedim.sort()
		if len(listePresRedim)>0:
			for parcR in listePresRedim: os.remove(parcR)
			
		listePresTemp=glob.glob(self.repTempEntree+'*.*')
		listePresTemp.sort()
		if len(listePresTemp)>0:
			for parcT in listePresTemp: os.remove(parcT)
		
		self.img_resolution_impaire()
		
		listeRedim=glob.glob(self.repTempEntree+'img_res_impair/*.*')
		listeRedim.sort()
		# Si aucune image ne comporte une résolution impaire
		if len(listeRedim)==0:
			# ATTENTION IL FAUT AJOUTER CECI NE PAS OUBLIER !!!
			# Récupération de la liste des fichiers chargés
			self.listeChemin=self.afficheurImgSource.getFiles()
		# Si une image comporte une résolution impaire
		elif len(listeRedim)>0: self.listeChemin=listeRedim
		
		# Récupération du chemin + vidéo chargée et de l'extension 
		# (la première image de la liste) 
		fich, self.ext=os.path.splitext(self.listeChemin[0])
		###########################################################################

		# Recup de la taille de la 1ère chargée
		imgTaille=Image.open(self.listeChemin[0])
		
		# Si toutes les images sont de la même taille, alors on applique la procédure normale
		# sinon on passe par la création d'un répertoire tampon et on entre dans la structure
		# conditionnelle « if not taillesImgCorrectes »
		taillesImgCorrectes = 1 # par défaut les images sont considérant comme étant à la bonne taille
		nbrImg = len(self.listeChemin)
		
		for parcChemTempo in self.listeChemin:
			if Image.open(parcChemTempo).size==imgTaille.size:
				pass
			else:
				taillesImgCorrectes = 0
				break
		
		print "taillesImgCorrectes", taillesImgCorrectes
		
		# Si les tailles des images sont différentes
		if not taillesImgCorrectes:
			# création du réperoire tampon
			self.redim_img() ##

		#=== Détermination des chemins d'entrée et sortie ===#
		
		if not nomSortie:
			# récupération du chemin de la vidéo de destination (à l'exception de l'extension)
			rep = self.baseImg.getRepSource(self.config)
			cheminVideoSorti=unicode(QFileDialog.getSaveFileName(None, _(u"Sauver"), rep, _(u"Tous les fichiers *.*")))
		else: # module séquentiel
			cheminVideoSorti=nomSortie
		
		if not cheminVideoSorti: return
		
		#print "Chemin sorti", cheminVideoSorti
		
		imgObj = Image.open(self.listeChemin[0])
		
		#print "Spin :", self.spin.value() , "; Radio_mpeg :", self.radio_mpeg1video.isChecked(), "; Radio_jpeg :", self.radio_motionjpeg.isChecked()
		
		i=self.combo.currentIndex()
		idCombo = str(self.combo.itemData(i).toStringList()[0])
		print "Combo :", idCombo
		
		# On récupère la valeur numérique associée au codec de 2 façon différentes
		if idCombo=='mpeg1video':
			valeurNum = str(self.comboMPEG1.currentText())
		else:
			valeurNum = str(self.spin.value())
		
		# extension du fichier vidéo
		if idCombo == 'mpeg1video':
			ext = '.mpg'
		elif idCombo == 'dv':
			ext = '.dv'
		elif idCombo == 'mov':
			ext = '.mov'
		elif idCombo == 'mp4':
			ext = '.mp4'
		elif idCombo == 'flv':
			ext = '.flv'
		elif idCombo == 'vob':
			ext = '.vob'
		else:
			ext = '.avi'
		
		cheminVideoSorti = cheminVideoSorti+ext
		
		#os.system('mencoder mf://'+RepCour+'/'+extEtoilPoint+' -mf fps='+Imag_Sec+':w='+indice1ImgSize+':h='+indice2ImgSize+' -ovc lavc -lavcopts vcodec='+ValeurChoixAIA+' -o '+RepCour+'/'+'anim_finale'+ExtImgAnIM)
		
		#print "COMMANDE D'ENCODAGE :\n", 'mencoder mf://'+"\""+self.repTempEntree+self.extAvecEtoile+"\""+' -mf fps='+str(valeurNum)+':w='+str(imgObj.size[0])+':h='+str(imgObj.size[1])+' -ovc lavc -lavcopts vcodec='+idCombo+' -o '+"\""+cheminVideoSorti+"\""
		
		# Passage par le répertoire temporaire car si cela n'est pas fait toutes les images
		# contenues dans le répertoire courant (et non les images sélectionnées par l'utilisateur)
		# sont sélectionnées pour la conversion ... ce qui est bien embêtant !.
		listeTemp=[]
		for parcChemTempo in self.listeChemin:
			cop=shutil.copy("".join(parcChemTempo), self.repTempEntree)
			#listeTemp.append(os.path.basename(parcChemTempo))
			listeTemp.append(parcChemTempo)
			# Mise en ordre
			listeTemp.sort()	
			
		# Renommage des images dans le répertoire temporaire	
		for parc in range(len(listeTemp)):
			#os.system('ffmpeg -i '+"\""+listeTemp[parc]+"\""+" -y "+"\""+self.repTempEntree+string.zfill((parc+1), 6)+self.ext+"\"")
			# Les images chargées (après copie dans le rep temporaire) sont renommées comme suit:
			# titre_image_00001.jpg, titre_image_00002.jpg, titre_image_00003.jpg, ... ==>
			# 00000001.jpg, 00000002.jpg, 00000003.jpg, ...
			# Attention sous windows il faudra trouver l'équivalent de la commande cp (pour la copie)
			os.system('cp '+"\""+listeTemp[parc]+"\""+" "+"\""+self.repTempEntree+string.zfill((parc+1), 8)+self.ext+"\"")
		
		# Scan du répertoire tampon (liste)
		repT=glob.glob(self.repTempEntree+'*.*')
		repT.sort()

		# Si les images chargées par l'utilisateur et les images copiées dans le rep
		# temporaire sont identiques (c'est à dire les images avant renommange), elles
		# sont eliminées.
		for parc_repT in repT:
			for parc_lChem in self.listeChemin:
				if os.path.basename(parc_repT)==os.path.basename(parc_lChem):
					os.remove(parc_repT)
		
		#cheminVideoEntre = self.repTempEntree+self.extAvecEtoile
		cheminVideoEntre = self.repTempEntree+'%08d'+self.ext
		
		print 'cheminVideoEntre', cheminVideoEntre
		
		tailleIm = [str(imgObj.size[0]), str(imgObj.size[1])]
		
		# Drapeau de bon déroulement des opérations
		drapReussi = 1
		
		try:
			mencoder = WidgetMEncoder(idCombo, cheminVideoEntre, cheminVideoSorti, valeurNum=valeurNum, laisserOuvert=ouvert, tailleIm=tailleIm)
			mencoder.setWindowTitle(_(u"Conversion des images en vidéo"))
			mencoder.exec_()

		except:
			drapReussi = 0
			messageErrAnEnc=QMessageBox(self)
			messageErrAnEnc.setText(_(u"Un problème est survenu lors de la conversion"))
			#messageErrAnEnc.setText(_(u"Un problème est survenu lors de l'exécution de \"mencoder mf://...\""))
			messageErrAnEnc.setWindowTitle(_(u"Error"))
			messageErrAnEnc.setIcon(QMessageBox.Warning)
			messageErrAnEnc.exec_()

		# Si tout a bien marché, on active mplayer avec le chemin de sortie de la vidéo
		if drapReussi:
			self.mplayer.listeVideos = [cheminVideoSorti]
			self.mplayer.setEnabled(True)
			self.tab.setCurrentIndex(self.dicoTab['video'])
		
		return cheminVideoSorti
		
		# On libere la memoire
		del listePresRedim, parcR, listePresTemp, parcT, fich, self.ext, imgTaille, taillesImgCorrectes, nbrImg, parcChemTempo, nomSortie, rep, cheminVideoSorti, imgObj, i, idCombo, valeurNum, ext, cheminVideoSorti, listeTemp, parcChemTempo, cop, parc,repT, parc_repT, parc_lChem, cheminVideoEntre, tailleIm, mencoder, drapReussi
	
	
	def sequentiel(self, entree, sortie, ouvert=0):
		"""Utile dans le module du même nom. Applique les opérations de la classe. Retourne le vrai nom du fichier de sortie"""
		
		'''
		################ Retiré le 28/12/08 #########################
		self.ouvrirSource(entree)
		################ Retiré le 28/12/08 #########################
		'''
		
		return self.appliquer(sortie, ouvert)
	
	
	def sequentielReglage(self):
		"""Utile dans le module du même nom. Récupère le widget de réglage associé à l'identifiant donné en 1er argument. Retourne l'instance du widget de réglage"""
		self.groupReglage.setTitle(_(u"Réglages: convertir des images en animation"))
		return self.groupReglage
	
	
	def afficherAide(self):
		""" Boîte de dialogue d'aide """

		## Ajouté le 28/12/08
		self.base.afficherAide(tr(u"<p>Dans l'onglet <b>'Images sources'</b> cliquez sur le bouton <b>Ajouter</b>, une boîte de dialogue apparaît, sur la partie gauche sélectionnez le répertoire (au besoin dépliez les sous-répertoires), allez chercher vos image(s). Si vous voulez sélectionner plusieurs images d'un coup, maintenez la touche <b>CTRL</b> (ou <b>SHIFT</b>) du clavier enfoncée (tout en sélectionnant vos images), cliquez sur <b>Ajouter</b>.<p><p>Faites ensuite les réglages du <b>'Nombre d'images/s'</b> (nombre d'images par seconde), puis choisissez le codec dans la liste déroulante <b>'Codecs'</b>.</p><p>Cliquez sur le bouton <b>'Appliquer'</b>, sélectionnez le répertoire de sauvegarde de votre vidéo dans la boîte de dialogue, entrez le <b>'Nom de Fichier'</b> dans le champ de texte réservé à cet effet ... cliquez sur le bouton <b>'Enregistrer'</b> et attendez le temps de la conversion <b><font color='blue'>(attention, la barre de progression reste à 10, mais ne vous inquietez pas le traitement des images a bien lieu)</font></b>. A la fin cliquez sur le bouton <b>'Voir les informations d'encodage'</b> et fermez cette dernière fenêtre après avoir vu les informations en question.</p><p>Vous pouvez visionner votre vidéo (après conversion) dans l'onglet <b>'Vidéo créée'</b>.</p><p>Si vous faites un clic droit de la souris (sur l'image) dans l'onglet <b>'Image(s) source(s)'</b>, vous accédez à des paramètres vous permettant différents affichages des images</p>"))
		
		'''
		messageAide=QMessageBox(self)
		messageAide.setText(_(u"Blablablabla ... blabla anim_conv_img_en_video."))
		messageAide.setWindowTitle(_(u"Aide"))
		messageAide.setIcon(QMessageBox.Information)
		messageAide.exec_()
		'''
		