#!/usr/bin/python
# -*- coding: Utf-8 -*-

import os, glob
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from gui_modules_animation.animation_base import Base
from moteur_modules_animation.mencoder import WidgetMEncoder
from moteur_modules_animation.mplayer import Mplayer

class Animation_ConvertirAnimEn_16_9_Ou_4_3(QWidget):
	""" -----------------------------------------
	# Cadre accueillant les widgets de :
	# Animation >> Montage vidéo >> Vidéo seulement
	# -----------------------------------------"""
	def __init__(self, parent):
		QWidget.__init__(self)
		
		# -------------------------------
		# Parametres généraux du widget
		# -------------------------------
		self.base = Base(self) # module de animation
		#=== tout sera mis dans une boîte verticale ===#
		vbox=QVBoxLayout(self)
		
		#=== Variable de configuration ===#
		self.config=parent.config
		
		# Identifiant de la classe
		self.idSection = "Animation - Conversion Video 16/9 ou 4/3"
		self.base.printSection()

		# Liste de fichiers initiaux (contenu dans le fichier de configuration)
		self.lstFichiersSource = []
		self.lstFichiersSourceProv = [] # idem mais provisoire (sert à récupérer les chemins dans l'ordre de sélection)
		
		self.statusBar = parent.statusBar()
		
		# -------------------------------------------------------------------
		# Boîte de groupe : "Fichier vidéo source"
		# -------------------------------------------------------------------
		self.base.widgetSource(vbox)
		
		# -------------------------------------------------------------------
		# Boîte de groupe "Réglage de sortie de l'encodage"
		# -------------------------------------------------------------------
		
		#=== Création de la boite de groupe de réglage (contenant la boite self.layoutReglage) ===#
		self.base.widgetReglage(vbox, boite='vbox', nomReglage=_(u"Réglage du type de conversion (ne fonctionne qu'avec les fichiers AVI)"))
		
		#=== Widget qui seront inclus dans la boite de réglage ===#
		# boite de combo
		self.combo=QComboBox() # le self sert à afficher des informations sur les items à partir de la fonction
		# listeCombo=[(texte, clé QVariant)...]
		listeCombo=[	(_(u'Convertir la vidéo en 16/9 ème') ,'16_9'),\
				(_(u'Convertir la vidéo en 4/3') ,'4_3'),]
		
		# Insertion des codecs de compression dans la combo box
		for i in listeCombo:
                	self.combo.addItem(i[0],QVariant(i[1]))
		
		self.connect(self.combo, SIGNAL("activated(int)"), self.nouvelleResolution)
		
		self.layoutReglage.addWidget(self.combo, 0, Qt.AlignHCenter)
		
		# ekd_gui.py Configuration (dicoConf ... à partir de la ligne 1074 --> à mettre après ligne 1113)
		# Chargement du paramètre de configuration
		try:
			typ = self.config.get(self.idSection,'type_16_9_ou_4_3')
			indice = 0 # indice de la ligne de self.listeCombo correspondant au type d'ordre
			for i in listeCombo:
				if i[1]!=typ:
					indice += 1
				else:
					break
			self.combo.setCurrentIndex(indice)
		except:
			self.combo.setCurrentIndex(0)
		
		# ----------------------------
		# Boite de groupe de mplayer
		# ----------------------------
		group=QGroupBox("")
		vboxMplayer = QVBoxLayout(group)
		self.mplayer=Mplayer(taille=self.base.tailleMplayer,
			choixWidget=(Mplayer.PRECEDENT_SUIVANT,Mplayer.CURSEUR_A_PART))
		chemin = self.ligneEditionSource.text()
		self.mplayer.setEnabled(False)
		self.mplayer.listeVideos = self.lstFichiersSource
		hbox = QHBoxLayout()
		hbox.addStretch()
		hbox.addWidget(self.mplayer)
		hbox.addStretch()
		vboxMplayer.addLayout(hbox)
		
		self.radioSource = QRadioButton(_(u"vidéo(s) source(s)"))
		self.radioSource.setChecked(True)
		self.radioSource.setEnabled(False)
		self.connect(self.radioSource, SIGNAL("toggled(bool)"), self.fctRadioSource)
		self.radioConvert = QRadioButton(_(u"vidéo convertie"))
		self.radioConvert.setEnabled(False)
		self.connect(self.radioConvert, SIGNAL("toggled(bool)"), self.fctRadioConvert)
		hbox = QHBoxLayout()
		hbox.addWidget(self.radioSource)
		hbox.addWidget(self.radioConvert)
		hbox.setAlignment(Qt.AlignHCenter)
		vboxMplayer.addLayout(hbox)
		
		group.setAlignment(Qt.AlignHCenter)
		vbox.addWidget(group)
		
		# -------------------------------------------------------------------
		# widgets du bas : ligne + boutons Aide et Appliquer
		# -------------------------------------------------------------------
		self.base.widgetBas(vbox)
		
		# affichage de la boîte principale
		self.setLayout(vbox)
	
	
	def nouvelleResolution(self):
		"""Mets une liste de chemins vidéos dans l'ordre alpha-numérique si tel est le choix de l'utilisateur"""
		i=self.combo.currentIndex()
		idCombo = str(self.combo.itemData(i).toStringList()[0])
		print "Combo :", idCombo
		# Si ordre alpha-numérique choisi, alors on ordonne la liste
		if idCombo == '16_9':
			self.idCombo=1.77777
		elif idCombo == '4_3':
			self.idCombo=1.33333
		self.ligneEditionSource.setText("; ".join(self.lstFichiersSource))
		
		self.config.set(self.idSection,'type_16_9_ou_4_3',idCombo)
		
		if self.radioSource.isChecked(): self.mplayer.listeVideos=self.lstFichiersSource
	
	
	def widgetReglage(self, vboxParent, nomReglage, boite):
		""" Boîte de groupe de réglage """
		Base.widgetReglage(self, vboxParent, nomReglage, boite)
		self.nouvelleResolution

	
	def fctRadioSource(self, bool=None):
		""""Communique la vidéo appropriée à mplayer"""
		if bool: self.mplayer.listeVideos = self.lstFichiersSource
	
	
	def fctRadioConvert(self, bool=None):
		""""Communique la vidéo appropriée à mplayer"""
		if bool: self.mplayer.listeVideos = self.lstFichiersSortie
	
	
	def ouvrirSource(self, nomEntree=None):
		""" Récupération des chemins vidéo sélectionnée """
		
		# On n'utilise pas le fonction recupSources du fichier animation_base.py contenu dans
		# le répertoire gui_modules_animation car pour cette fonction uniquement les fichiers
		# AVI (donc extension .avi) sont autorisés
		
		repEntree = '~'
		txt = _(u"Fichiers vidéos (avi)")
		if not nomEntree:
			liste=QFileDialog.getOpenFileNames(None, _(u"Ouvrir"), os.path.expanduser(repEntree),
				"%s (*.avi)\n" %txt)
				
			liste = [unicode(i) for i in liste]
		
		chemin=liste
		if not chemin: return
		
		#chemin = self.base.recupSources(nomEntree)
		#if not chemin: return
		#print "chemin vidéo d'entrée:", chemin, type(chemin)
		
		self.lstFichiersSource = []
		
		for fichier in chemin:
			self.lstFichiersSource.append(fichier)
		
		# Appel de la fonction nouvelleResolution pour application 16/9 ou 4/3
		self.nouvelleResolution()
		print 'self.idCombo', self.idCombo
		
		# Le bouton appliquer devient utilisable
		self.boutApp.setEnabled(True)
		self.boutApp.setToolTip("")

		#'''
		# Ne sert pas pour l'instant --------------------------------------------------------------
		com="mplayer "+"\""+liste[0]+"\""+" -vo null -ao null -frames 0 -identify '$@' 2>/dev/null"
                # Travail avec subprocess 
		import subprocess
                p=subprocess.Popen(com, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, shell=True)
                lignesSortie=p.stdout.readlines()
                p.wait()
		
		l=[]
		for parc_ls in lignesSortie:
			if '\n' in parc_ls:
				l.append(parc_ls.replace('\n', ''))
		for parc_id in l:
			if 'ID_VIDEO_WIDTH' in parc_id:
				videoLargeur=parc_id
				print videoLargeur
			if 'ID_VIDEO_HEIGHT' in parc_id:
				videoHauteur=parc_id
				print videoHauteur
		# ---------------------------------------------------------------------------------------------
		#'''
		
		self.mplayer.setEnabled(True)
		self.mplayer.listeVideos = self.lstFichiersSource
		self.radioSource.setChecked(True)
		self.radioSource.setEnabled(False)
		self.radioConvert.setEnabled(False)
		
		# Affichage du chemin + nom de fichier dans la ligne d'édition
		self.ligneEditionSource.setText(liste[0])
		
		self.statusBar.showMessage(_(u"La vidéo résultante ne pourra pas être lue avec tous les logiciels (ex. bon avec mplayer mais pas avec xine)"))
	
	
	def afficherAide(self):
		""" Boîte de dialogue de l'aide """

		self.base.afficherAide(tr(u"<p>Cliquez sur le bouton <b>'Parcourir...'</b>, dans la boîte de dialogue allez chercher votre fichier vidéo dans l'arborescence, sélectionnez votre vidéo.</p><p><font color='green'></font></p><p>Choisissez ensuite le <b>'Réglage du type de conversion (ne fonctionne qu'avec les fichiers AVI),'</b> (Convertir la vidéo en 16/9 ème ou Convertir la vidéo en 4/3).<p>Cliquez sur le bouton <b>'Appliquer'</b>, sélectionnez le répertoire de sauvegarde, entrez le <b>'Nom de Fichier'</b> dans le champ de texte réservé à cet effet ... cliquez sur le bouton <b>'Enregistrer'</b> et attendez le temps de la conversion. A la fin cliquez sur le bouton <b>'Voir les informations d'encodage'</b> et fermez cette dernière fenêtre après avoir vu les informations en question.</p><p>Vous pouvez visionner votre vidéo (avant la conversion) en sélectionnant <b>'vidéo(s) source(s)'</b>, après la conversion <b>'vidéo convertie'</b>.<p><font color='red'><b>Comme vous le voyez, il n'est possible de convertir que des fichiers AVI (entension .avi), vous pourrez ensuite ré-encoder votre vidéo (en mpeg par exemple) dans 'Encodage'</b></font>.</p>"))
		
		'''
		messageAide=QMessageBox(self)
		messageAide.setText(_(u"Blablablabla ... blabla anim_montage_video_vid_seul."))
		messageAide.setWindowTitle(_(u"Aide"))
		messageAide.setIcon(QMessageBox.Information)
		messageAide.exec_()
		'''
		
		
	def appliquer(self, nomSortie=None, ouvert=1):
		"""Fusion de vidéos"""
		
		#=== Récupération de la liste de fichiers ===#
		if not nomSortie:
			cheminVideoSorti=unicode(QFileDialog.getSaveFileName(None, _(u"Sauver"), os.path.expanduser(os.path.dirname(self.lstFichiersSource[0])), _(u"Tous les fichiers *.*")))
		else: # module séquentiel
			cheminVideoSorti=nomSortie
		
		if not cheminVideoSorti: return
		
		# Extension à l'enregistrement de la vidéo (car uniquement les fichiers AVI sont autorisés)
		ext='.avi'
		
		cheminVideoProv = self.lstFichiersSource[0] # Chemin d'entrée de la vidéo
		cheminVideoSorti = cheminVideoSorti+ext # Chemin de sortie de la vidéo
		
		try:
			mencoder = WidgetMEncoder('conv_en_16_9_ou_4_3', cheminVideoProv, cheminVideoSorti, self.idCombo, laisserOuvert=ouvert)
			mencoder.setWindowTitle(_(u"Conversion de vidéos en 16/9 ou 4/3"))
			mencoder.exec_()
		except:
			messageErrAnEnc=QMessageBox(self)
			messageErrAnEnc.setText(_(u"Problème lors de la conversion (mencoder)"))
			messageErrAnEnc.setWindowTitle(_(u"Erreur"))
			messageErrAnEnc.setIcon(QMessageBox.Warning)
			messageErrAnEnc.exec_()
			##os.remove(cheminVideoProv)
			return
		
		self.lstFichiersSortie = cheminVideoSorti # pour la boite de dialogue de comparaison
		self.radioConvert.setChecked(True)
		self.radioSource.setEnabled(True)
		self.radioConvert.setEnabled(True)
		return cheminVideoSorti # module séquentiel
		
	
	def sequentiel(self, entree, sortie, ouvert=0):
		"""Utile dans le module du même nom. Applique les opérations de la classe. Retourne le vrai nom du fichier de sortie"""
		self.ouvrirSource(entree)
		return self.appliquer(sortie, ouvert)
	
	
	def sequentielReglage(self):
		"""Utile dans le module du même nom. Récupère le widget de réglage associé à l'identifiant donné en 1er argument. Retourne l'instance du widget de réglage"""
		return self.groupReglage
	