#!/usr/bin/python
# -*- coding: Utf-8 -*-

from PyQt4.QtCore import *
from PyQt4.QtGui import *

class Label(QLabel):
	"""Chaîne de caractères ayant un comportement hyper-texte"""
	def __init__(self, parent, texte, idItem):
		QLabel.__init__(self)
		self.parent = parent
		self.idItem = idItem
		self.setText("<font color='blue'><center>%s</center></font>" %texte)
		# le pointeur de la souris change au survol du label
		self.setCursor(Qt.PointingHandCursor)
	
	def mousePressEvent(self, event):
		"""Un clic sur le label entraîne l'ouverture du cadre associé"""
		if self.idItem=="general":	# Encodage : géneral
			#self.parent.treeWidgetAnimation.setCurrentItem(self.parent.itemTree_Encodage_General)
			self.parent.stacked_onglet_animation.setCurrentIndex(self.parent.stacked_animation_encodage_general)
		elif self.idItem=="pour_le_web":	# Encodage : pour le web
			#self.parent.treeWidgetAnimation.setCurrentItem(self.parent.itemTree_Encodage_Web)
			self.parent.stacked_onglet_animation.setCurrentIndex(self.parent.stacked_animation_encodage_web)
		elif self.idItem=="haute_definition":	# Encodage : haute définition
			#self.parent.treeWidgetAnimation.setCurrentItem(self.parent.itemTree_EncodageHD)
			self.parent.stacked_onglet_animation.setCurrentIndex(self.parent.stacked_animation_encodage_hd)


class Animation_Encodage(QWidget):
	# -----------------------------------------
	# Cadre accueillant les widgets de :
	# Animation >> Encodage
	# -----------------------------------------
	def __init__(self, parent):
        	QWidget.__init__(self)
		
		# Boite d'alignement vertical
		vbox=QVBoxLayout(self)
		
		# Titre de la page
		txt = _(u"Encodage:")
		titre_du_cadre=QLabel("<H2><center><u>%s</u></center></H2>" %txt)
		
		# Lien vers les sous-cadres
		labelGeneral = Label(parent, _(u"Encodage: Général"), "general")
		labelPourLeWeb = Label(parent, _(u"Encodage: Pour le web"), "pour_le_web")
		labelHauteDefinition = Label(parent, _(u"Encodage: Haute définition"), "haute_definition")
		
		# Ajout du titre de la page a la boite verticale
		vbox.addWidget(titre_du_cadre)
		vbox.addSpacing(10)
		vbox.addWidget(labelGeneral)
		vbox.addWidget(labelPourLeWeb)
		vbox.addWidget(labelHauteDefinition)
		
		vbox.addStretch()