#!/usr/bin/python
# -*- coding: Utf-8 -*-

import os
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from gui_modules_animation.animation_base_encodageFiltre import Base_EncodageFiltre
from moteur_modules_animation.mencoder import WidgetMEncoder

class AnimationEncodageWeb(Base_EncodageFiltre):
	"Cadre de Animation -> Encodage -> Pour le web. But: encodages spécifiques à youtube, dailymotion..."
	
	def __init__(self, parent):
		
		# Variable de configuration
		self.config = parent.config
		
		# Identifiant de la classe
		self.idSection = "Animation - Encodage - Web"
		
		# Pas d'"empilement" car pas de paramètre d'encodage
		self.stacked = None
		
		#----------------------------------------------------------------------------------
		# Paramètres de la liste de combo: [(identifiant, nom entrée, instance, extension), ...]
		#----------------------------------------------------------------------------------

		self.listeCombo = [
			('youtube_16/9_HQ', _(u'Encodage YouTube 16/9 Haute Qualité'), 0, '.avi'),
			('youtube_16/9_MQ', _(u'Encodage YouTube 16/9 Moyenne Qualité'), 1, '.avi'),
			('youtube_16/9_LQ', _(u'Encodage YouTube 16/9 Basse qualité'), 2, '.avi'),
			('youtube_4/3_HQ', _(u'Encodage YouTube 4/3 Haute Qualité'), 3, '.avi'),
			('youtube_4/3_MQ', _(u'Encodage YouTube 4/3 Moyenne Qualité'), 4, '.avi'),
			('youtube_4/3_LQ', _(u'Encodage YouTube 4/3 Basse qualité'), 5, '.avi'),
			('google_video_16/9_HQ', _(u'Encodage Google vidéo 16/9 Haute qualité'), 6, '.avi'),
			('google_video_16/9_MQ', _(u'Encodage Google vidéo 16/9 Qualité moyenne'), 7, '.avi'),
			('google_video_16/9_LQ', _(u'Encodage Google vidéo 16/9 Basse qualité'), 8, '.avi'),
			('google_video_4/3_HQ', _(u'Encodage Google vidéo 4/3 Haute qualité'), 9, '.avi'),
			('google_video_4/3_MQ', _(u'Encodage Google vidéo 4/3 Qualité moyenne'), 10, '.avi'),
			('google_video_4/3_LQ', _(u'Encodage Google vidéo 4/3 Basse qualité'), 11, '.avi'),
			]

		#---------------------------
		# Dérivation de la classe
		#---------------------------
		Base_EncodageFiltre.__init__(self, parent)
	
	
	def appliquer(self, nomSortie=None, ouvert=1):
		"Appel du moteur du cadre"
		
		if not nomSortie:
			cheminFichierEnregistrerVideo = unicode(QFileDialog.getSaveFileName(None, _(u"Sauver"), os.path.expanduser(self.base.repSortieProv()), _(u"Tous les fichiers *.*")))
		else: # module séquentiel
			cheminFichierEnregistrerVideo = nomSortie
		
		if not cheminFichierEnregistrerVideo:
			return
		
		# quel est l'index du dernier item sélectionné de la boîte de combo?
		i = self.combo.currentIndex()
		print 'i', i
		# identifiant du codec actif
		idCodec = str(self.combo.itemData(i).toString()) # méthode de QVariant
		print 'idCodec', idCodec
		
		# récupération du chemin
		chemin = unicode(self.ligneEditionSource.text())
		
		# appel du moteur -> animation encodage avec un codec particulier
		# l'extension est à ajouter ici à cheminFichierEnregistrerVideo ou plus tard dans mencoder.py!
		mencoder = WidgetMEncoder(idCodec, chemin, cheminFichierEnregistrerVideo+'.avi', laisserOuvert=ouvert)
		mencoder.setWindowTitle(_(u"Encodage vidéo - Pour le web"))
		mencoder.exec_()
		
		self.lstFichiersSortie =  cheminFichierEnregistrerVideo+'.avi' # pour la boite de dialogue de comparaison
		self.radioConvert.setChecked(True)
		self.radioSource.setEnabled(True)
		self.radioConvert.setEnabled(True)
		self.boutCompare.setEnabled(True)
		return cheminFichierEnregistrerVideo # module séquentiel

	def afficherAide(self):
		"Boîte de dialogue de l'aide du cadre"
		self.base.afficherAide(tr(u"<p>Cliquez sur le bouton <b>'Parcourir...'</b>, dans la boîte de dialogue allez chercher votre vidéo dans l'arborescence, sélectionnez-la. Choisissez le codec de sortie dans la boîte déroulante <b>'Réglages'</b></p><p>Cliquez sur le bouton <b>'Appliquer'</b>, sélectionnez le répertoire de sauvegarde de votre vidéo, entrez le <b>'Nom de Fichier'</b> dans le champ de texte réservé à cet effet ... cliquez sur le bouton <b>'Enregistrer'</b> et attendez le temps de la conversion. A la fin cliquez sur le bouton <b>'Voir les informations d'encodage'</b> et fermez cette dernière fenêtre après avoir vu les informations en question.</p><p>Vous pouvez visionner votre vidéo (avant la conversion) en sélectionnant <b>'vidéo(s) source(s)'</b>, après la conversion <b>'vidéo convertie'</b> ou bien encore les deux en même temps, en cliquant sur le bouton <b>'Comparateur de vidéos'</b>."))
