#!/usr/bin/python
# -*- coding: Utf-8 -*-

import os, glob, string, Image, ImageOps
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from gui_modules_lecture.affichage_image.afficheurImage import VisionneurImagePourEKD
from gui_modules_image.image_base import Base, SpinSlider ## 09/11/08

from gui_modules_image.selectWidget import SelectWidget ## 01/12/08
from gui_modules_lecture.lecture_image import Lecture_VisionImage ## 01/12/08
from gui_modules_lecture.affichage_image.afficheurImage import VisionneurEvolue ## 06/12/08

## Attention --> vraiCheminSauv a été remplacé par self.cheminCourantSauv le 02/12/08

class Image_Divers_ChangFormat(QWidget):
	"""# -----------------------------------
	# Cadre accueillant les widgets de :
	# Image >> Divers >> Changer format
	# Gestion de 16 formats de fichiers
	# -----------------------------------"""
	def __init__(self, parent):
        	QWidget.__init__(self)
		
		# -------------------------------
		# Parametres généraux du widget
		# -------------------------------
		#=== tout sera mis dans une boîte verticale ===#
		vbox=QVBoxLayout(self)
		
		#=== Création des répertoires temporaires ===#
		self.repTampon = "/tmp/ekd/tampon/image_divers_changer_format/"
		if os.path.isdir(self.repTampon) is False:
        		os.makedirs(self.repTampon)
		
		# Au cas où le répertoire existait déjà et qu'il n'était pas vide 
		# -> purge (simple précausion)
		for toutRepCompo in glob.glob(self.repTampon+'*.*'):
			os.remove(toutRepCompo)
			
		################ Rajouté le 01/12/08 ###########################################################
		#=== Drapeaux ===#
		# Une conversion (même partielle) a-t-elle eu lieu après le chargement des images? (1: vrai)
		
		# Est-ce que des images ont été converties et qu'elles n'ont pas encore été montrées?
		# Marche aussi quand la conversion a été arrêté avant la fin de la 1ère image
		self.conversionImg = 0
		
		################ Rajouté/changé par Romain le 01/12/08 #########################################
		# Est-ce qu'une prévisualisation a été appelée?
		self.previsualImg = 0
		# Est-ce que des images sources ont été modifiées? (c'est-à-dire ajoutées ou supprimées)
		self.modifImageSource = 0
		################################################################################################
		################################################################################################
		
		# Délai avant conversion
		self.timer = QTimer()
		self.connect(self.timer, SIGNAL('timeout()'), self.sonderTempsActuel)
		
		# Fonctions communes à plusieurs cadres du module Image
		self.base = Base()
		# Paramètres de configuration
		self.config = parent.config
		# Identifiant du cadre
		self.idSection = "Image - Changer Format"
		# Log du terminal
		self.base.printSection(self.idSection)
		################ Ajouté le 06/12/08 ############################################################
		# Fonction appelant la fenêtre principale
		self.mainWindowFrameGeometry = parent.frameGeometry
		################################################################################################
		
		################ Retiré le 01/12/08 ############################################################
		#self.listeChemin = []
		################################################################################################
		################ Ajouté le 01/12/08 ############################################################
		self.listeImgSource = []
		self.listeImgDestin = []
		################################################################################################

		'''
		################ Retiré le 01/12/08 ############################################################
		#-------------------------------------------------
		# Sélection images, type de méthode et de masque
		#-------------------------------------------------
		
		boutCharger=QPushButton(_(u' Ouvrir images'))
		boutCharger.setIcon(QIcon("Icones/ouvrir.png"))
		self.connect(boutCharger, SIGNAL("clicked()"), self.ouvrirSource)
		vbox.addWidget(boutCharger)
		################################################################################################
		'''
		
		#------------------------
		# Onglets et stacked
		#------------------------
		self.tabwidget=QTabWidget()
		
		#=== 1er onglet ===#
		self.framReglage=QFrame()
		vboxReglage=QVBoxLayout(self.framReglage)
		
		'''
		################ Retiré le 01/12/08 ############################################################
		# boite de combo
		self.comboReglage=QComboBox()
		self.listeComboReglage=[(_(u'JPEG (.jpg)'), '.jpg'),\
					(_(u'PNG (.png)'), '.png'),\
					(_(u'GIF (.gif)'), '.gif'),\
					(_(u'BMP (.bmp)'), '.bmp'),\
					(_(u'PPM (.ppm)'), '.ppm'),\
					(_(u'XPM (.xpm)'), '.xpm'),\
					(_(u'TARGA (.tga)'), '.tga'),\
					(_(u'SGI (.sgi)'), '.sgi'),\
					(_(u'PNM (.pnm)'), '.pnm'),\
					(_(u'PSD (.psd)'), '.psd'),\
					(_(u'PCX (.pcx)'), '.pcx'),\
					(_(u'JPEG 2000 (.jp2)'), '.jp2'),\
					(_(u'JNG (.jng)'), '.jng'),\
					(_(u'PS (.ps)'), '.ps'),\
					(_(u'PDF (.pdf)'), '.pdf')]
		# (_(u'TIFF (.tiff)'), '.tiff'),\
		###### Rectifié 08/11/08 ############################################################
		# Format TIFF retiré de la liste car pose problème
		# --> TIFFReadDirectory: Warning, foo: unknown field with tag 347 (0x15b) encountered.
		# --> foo: Sorry, requested compression method is not configured.
		#####################################################################################
		################################################################################################
		'''
		
		################ Ajouté le 03/12/08 ############################################################
		# boite de combo
		self.comboReglage=QComboBox()
		self.listeComboReglage=[(_(u'JPEG (.jpg)'), '.jpg'),\
					(_(u'JPEG (.jpeg)'), '.jpeg'),\
					(_(u'PNG (.png)'), '.png'),\
					(_(u'GIF (.gif)'), '.gif'),\
					(_(u'BMP (.bmp)'), '.bmp'),\
					(_(u'PPM (.ppm)'), '.ppm'),\
					(_(u'TIFF (.tiff)'), '.tiff'),\
					(_(u'TIF (.tif)'), '.tif')]
		################################################################################################
		
		###### Rectifié le 09/11/08 pour la gestion du nombre d'images à traiter ############
		# Se trouve maintenant directement dans l'onglet Réglages
		self.grid = QGridLayout() ##
		self.grid.addWidget(QLabel(_(u"Traitement à partir de l'image (numéro)")), 0, 0) ##
		self.spin1=SpinSlider(1, 100000, 1, '', self) ##
		self.grid.addWidget(self.spin1, 0, 1) ##
		self.connect(self.spin1, SIGNAL("valueChanged(int)"), self.changeValNbreImg_1) ##
		self.grid.addWidget(QLabel(_(u"Nombre de chiffres après le nom de l'image")), 1, 0) ##
		self.spin2=SpinSlider(3, 18, 6, '', self) ##
		self.grid.addWidget(self.spin2, 1, 1) ##
		self.connect(self.spin2, SIGNAL("valueChanged(int)"), self.changeValNbreImg_1) ##
		
		self.grid.setAlignment(Qt.AlignHCenter) ##
		vboxReglage.addLayout(self.grid) ##
		vboxReglage.addStretch() ##
		#####################################################################################
		
		# Insertion des formats dans la combo box
		for i in self.listeComboReglage:
                	self.comboReglage.addItem(i[0],QVariant(i[1]))
		self.connect(self.comboReglage, SIGNAL("currentIndexChanged(int)"), self.changerComboReglage)
		# Affiche l'entrée de la boite de combo inscrite dans un fichier de configuration
		self.base.valeurComboIni(self.comboReglage, self.config, self.idSection, 'format')
		
		###### Retiré 15/03/09 ################################################################
		#hbox = QHBoxLayout()
		#hbox.addWidget(QLabel(_(u'Type de format après traitement')))
		#hbox.addWidget(self.comboReglage)
		#######################################################################################
		
		###### Retiré 15/03/09 ################################################################
		#hbox.setAlignment(Qt.AlignHCenter)
		#######################################################################################
		
		'''
		############################ Retiré le 20/11/08 #######################################
		self.boutApPremImg = QPushButton(_(u" Voir le résultat"))
		self.boutApPremImg.setIcon(QIcon("Icones/icone_visionner_128.png")) ## le 01/11/08
		self.boutApPremImg.setFocusPolicy(Qt.NoFocus)
		self.boutApPremImg.setEnabled(False)
		self.connect(self.boutApPremImg, SIGNAL("clicked()"), self.visu_1ere_img)
		#######################################################################################
		'''
		
		###### Retiré 15/03/09 ################################################################
		#vboxReglage.addLayout(hbox)
		#vboxReglage.addSpacing(10)
		#vboxReglage.addStretch()
		#######################################################################################
		
		############################ Retiré le 20/11//08 ######################################
		#vboxReglage.addWidget(self.boutApPremImg)
		#######################################################################################
		
		################ Ajouté le 15/03/09 ############################################################
		self.grid2 = QGridLayout()
		
		# Label qualité pour la qualité (compression) lors de la sauvegarde en JPEG
		self.labQualite=QLabel(_(u"Qualité"))
		self.labQualite.hide()
		#self.labQualite.setEnabled(False)
		
		self.grid2.addWidget(QLabel(_(u'Type de format après traitement')), 0, 0)
		self.grid2.addWidget(self.comboReglage, 0, 1)
		self.grid2.addWidget(self.labQualite, 2, 0)
		# Réglage de la qualité pour la qualité (compression) lors de la sauvegarde en JPEG
		self.spin3=SpinSlider(1, 100, 75, '', self)
		self.spin3.hide()
		#self.spin3.setEnabled(False)
		
		i = self.comboReglage.currentIndex()
		idCombo=str(self.comboReglage.itemData(i).toStringList()[0])
		if idCombo in ['.jpg', '.jpeg']:
			self.labQualite.show()
			self.spin3.show()
			#self.labQualite.setEnabled(True)
			#self.spin3.setEnabled(True)
		else:
			self.labQualite.hide()
			self.spin3.hide()
			#self.labQualite.setEnabled(False)
			#self.spin3.setEnabled(False)

		self.grid2.addWidget(self.spin3, 2, 1)
		self.connect(self.spin3, SIGNAL("valueChanged(int)"), self.changeQualitePourJPEG)
		
		self.grid2.setAlignment(Qt.AlignHCenter)
		vboxReglage.addLayout(self.grid2)
		vboxReglage.addStretch()
		################################################################################################


		#=== 2ème onglet ===#
		# infos - logs
		self.zoneAffichInfosImg = QTextEdit("")
		if PYQT_VERSION_STR < "4.1.0":
			self.zoneAffichInfosImg.setText = self.zoneAffichInfosImg.setPlainText
		self.zoneAffichInfosImg.setReadOnly(True)
		self.framImg=QFrame()
		vboxReglage=QVBoxLayout(self.framImg)
		vboxReglage.addWidget(self.zoneAffichInfosImg)
		self.framImg.setEnabled(False)
		
		'''
		################ Retiré le 01/12/08 ############################################################
		#=== 3ème onglet ===#
		self.afficheurImg_1=VisionneurImagePourEKD()
		self.afficheurImg_2=VisionneurImagePourEKD()
		################################################################################################
		'''
		
		################ Ajouté le 01/12/08 ############################################################
		# -------------------------------------------------
		# Onglets d'affichage image source et destination
		# -------------------------------------------------

		# Là où s'afficheront les images
		self.afficheurImgSource=SelectWidget(geometrie = self.mainWindowFrameGeometry)
		self.afficheurImgDestination=Lecture_VisionImage(parent)
		################################################################################################
		
		'''
		################ Retiré le 01/12/08 ############################################################
		self.indexTabReglage=self.tabwidget.addTab(self.framReglage, _(u'Réglages'))
		self.indexImagechargee=self.tabwidget.addTab(self.afficheurImg_1, _(u'Images chargées'))
		self.indexImageResultat=self.tabwidget.addTab(self.afficheurImg_2, _(u'Images après traitement'))
		self.indexTabInfo=self.tabwidget.addTab(self.framImg, _(u'Infos'))
		################################################################################################
		'''
		
		################ Ajouté le 01/12/08 ############################################################
		self.indexTabImgSource = self.tabwidget.addTab(self.afficheurImgSource, _(u'Image(s) source'))
		self.indexTabReglage=self.tabwidget.addTab(self.framReglage, _(u'Réglages'))
		self.indexTabImgDestin=self.tabwidget.addTab(self.afficheurImgDestination, _(u'Image(s) après traitement'))
		self.indexTabInfo=self.tabwidget.addTab(self.framImg, _(u'Infos'))
		################################################################################################
		
		vbox.addWidget(self.tabwidget)
		
		#------------------
		# Widgets du bas
		#------------------
		
		# boutons
		boutAide=QPushButton(_(u" Aide"))
		boutAide.setIcon(QIcon("Icones/icone_aide_128.png"))
		boutAide.setFocusPolicy(Qt.NoFocus)
		self.connect(boutAide, SIGNAL("clicked()"), self.afficherAide)
		######### Ajouté/rectifié le 20/11/08 #######################################
		self.boutApPremImg = QPushButton(_(u" Voir le résultat"))
		self.boutApPremImg.setIcon(QIcon("Icones/icone_visionner_128.png"))
		self.boutApPremImg.setFocusPolicy(Qt.NoFocus)
		self.boutApPremImg.setEnabled(False)
		self.connect(self.boutApPremImg, SIGNAL("clicked()"), self.visu_1ere_img)
		#############################################################################
		self.boutApp=QPushButton(_(u" Appliquer"))
		self.boutApp.setIcon(QIcon("Icones/icone_appliquer_128.png"))
		self.boutApp.setFocusPolicy(Qt.NoFocus)
		self.boutApp.setEnabled(False)
		self.connect(self.boutApp, SIGNAL("clicked()"), self.appliquer0)
		
		'''
		################ Retiré le 01/12/08 ############################################################
		# Bouton inactif au départ
		self.boutApPremImg.setEnabled(False)
		self.boutApp.setEnabled(False)
		################################################################################################
		'''
		
		# ligne de séparation juste au dessus des boutons
		ligne = QFrame()
		ligne.setFrameShape(QFrame.HLine)
		ligne.setFrameShadow(QFrame.Sunken)
		vbox.addWidget(ligne)
		vbox.addSpacing(-5)	# la ligne doit être plus près des boutons
		
		hbox=QHBoxLayout()
		hbox.addWidget(boutAide)
		hbox.addStretch()	# espace entre les 2 boutons
		########### Ajouté/rectifié le 20/11/08 #####################################
		hbox.addWidget(self.boutApPremImg)
		hbox.addStretch()
		#############################################################################
		hbox.addWidget(self.boutApp)
		vbox.addLayout(hbox)
		
		self.setLayout(vbox)
		
		#------------------------------------------------
		# Barre de progression dans une fenêtre séparée
		#------------------------------------------------
		
		self.progress=QProgressDialog(_(u"Progression ..."), _(u"Arrêter le processus"), 0, 100)
		self.progress.setWindowTitle(_(u'EnKoDeur-Mixeur. Fenêtre de progression'))
		# Attribution des nouvelles dimensions
		self.progress.setMinimumWidth(500)
		self.progress.setMinimumHeight(100)
		
		################ Ajouté le 01/12/08 ############################################################
		self.connect(self.tabwidget, SIGNAL("currentChanged(int)"), self.fctTab)
		
		#----------------------------------------------------------------------------------------------------
		# Signal de présence d'images dans ler widget de sélection -> modifie le statut des boutons d'action
		#----------------------------------------------------------------------------------------------------
		
		self.connect(self.afficheurImgSource, SIGNAL("pictureChanged(int)"), self.modifBoutonsAction)
		################################################################################################
		
		################ Ajouté le 15/03/09 ############################################################
		#----------------------------------------------------------------------------------------------------
		# Signal pour afficher ou ne pas afficher les widgets de changement de qualité pour les images
		#----------------------------------------------------------------------------------------------------
		
		self.connect(self.comboReglage, SIGNAL("currentIndexChanged(int)"), self.changerQualJPEG)
		################################################################################################

		
	################ Ajouté le 01/12/08 ############################################################
	def modifBoutonsAction(self, i):
		"On active ou désactive les boutons d'action selon s'il y a des images ou pas dans le widget de sélection"
		self.boutApp.setEnabled(i)
		self.boutApPremImg.setEnabled(i)
		self.modifImageSource = 1
	################################################################################################
		
		
	def changerComboReglage(self, i):
		"""Récup/affichage ds le terminal de l'index de self.comboReglage"""
		print self.comboReglage.currentText()
		self.config.set(self.idSection, 'format', self.listeComboReglage[i][1])
		
		
	def changerQualJPEG(self):
		''' Changement de la qualité pour les images jpeg à l'enregistrement '''
		
		################ Ajouté le 15/03/09 #####################################################
		# Si on sélectionne le format JPEG (avec extension .jpg ou .jpeg) dans la liste
		# déroulante, on peut régler la qualité du JPEG pour la sauvegarde
		if self.comboReglage.currentIndex() in [0, 1]:
			self.labQualite.show()
			self.spin3.show()
			#self.labQualite.setEnabled(True)
			#self.spin3.setEnabled(True)
		# Si on sélectionne tous les autres formats, les widgets n'apparaissent pas
		#elif self.comboReglage.currentIndex() in [2, 3, 4, 5, 6, 7]:
		else:
			self.labQualite.hide()
			self.spin3.hide()
			#self.labQualite.setEnabled(False)
			#self.spin3.setEnabled(False)
		#########################################################################################
		
		
	###### Rectifié le 25/10/08 pour la gestion du nombre d'images à traiter ######
	def changeValNbreImg_1(self): ##
		print "Traitement a partir de l'image (numero):", self.spin1.value()
		print "Nombre de chiffres apres le nom de l'image:", self.spin2.value()
	###############################################################################
	
	
	################ Ajouté le 15/03/09 ############################################################
	def changeQualitePourJPEG(self):
		print "Compression JPEG, qualité:", self.spin3.value()
	################################################################################################
	
	
	################ Ajouté le 01/12/08 #############################################################	
	def fctTab(self, i):
		"Affichage d'une ou plusieurs images converties"
		
		# Cela ne concerne que l'onglet de visualisation des images après leur conversion
		if i == self.indexTabImgDestin:
			if self.conversionImg:
				# Affichage si on sauvegarde par le bouton Appliquer et sauver
				print "La conversion vient d'avoir lieu -> affichage des images du lot de destination"
				cheminImages = os.path.dirname(self.listeImgDestin[0])
				liste = []
				for fichier in self.listeImgDestin:
					liste.append(os.path.basename(fichier))
				self.afficheurImgDestination.updateImages(liste, cheminImages)
			elif not self.boutApp.isEnabled() or self.modifImageSource:
				# Si le bouton de conversion n'est pas actif, c'est qu'il n'y a plus d'image source
				# -> on n'a plus de raison de maintenir des images dans l'afficheur de résultat
				# Si les images sources ont été modifiées, on purge aussi l'afficheur de résultat
				self.afficheurImgDestination.updateImages([])
			self.conversionImg = 0
			self.modifImageSource = 0
	
	
	def metaFctTab(self, i):
		"""Changement d'onglet (conçu pour sélectionner les onglets "Images Source" après le chargement de nouvelles images sources ou "Images Après Traitement" après la conversion). But: s'assurer que la fonction associée au QTabWidget (affichage d'images, grisage/dégrisage du curseur...) sera bien appliquée même si on est déjà sur le bon onglet"""
		if self.tabwidget.currentIndex()!=i:
			self.tabwidget.setCurrentIndex(i)
		else: self.fctTab(i)
	################################################################################################	
	
	
	'''
	################ Retiré le 01/12/08 ############################################################
	def ouvrirSource(self):
		txt = _("Fichier images")
		rep = self.base.getRepSource(self.config)
		listeChemin=QFileDialog.getOpenFileNames(None, _(u"Ouvrir"), rep, ("JPEG (*.jpg *.JPG *.jpeg *.JPEG);;PNG (*.png *.PNG);;GIF (*.gif *.GIF);;BMP (*.bmp *.BMP);;SGI (*.sgi *.SGI);;TIF (*.tif *.TIF);;TIFF (*.tiff *.TIFF);;TARGA (*.tga *.TGA);;PNM (*.pnm *.PNM);;PPM (*.ppm *.PPM);;JPEG 2000 (*.jp2 *.JP2);;PSD (*.psd *.PSD);;PCX (*.pcx *.PCX);;XPM (*.xpm *.XPM);;JNG (*.jng *.JNG);; *"))
		
		if not listeChemin: return
		
		#print "Chemin de chargement des images:", listeChemin, type(listeChemin)
		
		self.listeChemin = [unicode(listeChem) for i, listeChem in enumerate(listeChemin)]
		
		self.listeChemin.sort()
		
		self.base.setRepSource(self.config, self.listeChemin)
		
		self.afficheurImg_1.setImage(self.listeChemin[0])
		self.afficheurImg_2.setImage()
		self.zoneAffichInfosImg.setText("")
		self.tabwidget.setCurrentIndex(self.indexImagechargee)
		
		# Bouton actif après chargement des images
		#self.boutApp.setEnabled(True)
		
		####### Rectifié/ajouté le 07/11/08 ########################################
		# Activer le bouton 'Appliquer' seulement si au moins une image est chargée
		if len(self.listeChemin)>0: self.boutApp.setEnabled(True)
		
		# Si l'utilisateur charge au moins un fichier, le bouton 'Aperçu à partir 
		# de la première image' (dans l'onglet Réglages)est activé
		if len(self.listeChemin)>0: self.boutApPremImg.setEnabled(True)
		############################################################################
	################################################################################################
	'''
		
		
	####### Ajouté le 01/12/08 ###########################################################################
	def visu_1ere_img(self):
		"""Fonction pour faire une simulation de rendu (avec les réglages opérés dans l'onglet Réglages)
		et ce à partir du bouton Aperçu à partir de la première image, toujours dans l'onglet Réglages.
		Pour les commentaires, se référer à la fonction chang_format juste en dessous"""
		
		####### Ajouté le 07/01/09 ################################################
		# Récupération du fichier sélectionné par l'utilisateur (si pas de fichier
		# sélectionné par l'utilisateur, la 1ère image de la liste est prise)
		file = self.afficheurImgSource.getFile()
		if not file: return
		self.listeImgSource = [file]
		###########################################################################
		
		i = self.comboReglage.currentIndex()
		ext=self.comboReglage.itemData(i).toString()
		ext=str(ext).lower()
		
		# Formats (extensions) supportées: .bmp, .gif, .jpeg, .jpg, .mng, .pbm, .pgm,
		# .png, .ppm, .svg, .tif, .tiff, .xbm, .xpm
		formats = [".%s" % unicode(format).lower() \
			for format in QImageReader.supportedImageFormats()]
			
		# Chemin+nom d'image pour la sauvegarde
		self.cheminCourantSauv = self.repTampon+'0_image_visu_'+string.zfill(1, 6)+ext
		
		# CONVERSION
		
		################ Rectifié le 15/03/09 (changement complet) ##########################
		# On sélectionne le 'Type de format après traitement' à JPEG (.jpg) ou JPEG (.jpeg)
		# le traitement se fait par Python Imaging Library
		if i in [0, 1]:
			im = Image.open(self.listeImgSource[0]).save(self.cheminCourantSauv, quality=self.spin3.value())
		# Si on sélectionne les autres entrées, le traitement se fait par ImageMagick
		else:
			# Conversion immédiate dans le rep tampon
			os.system("convert "+"\""+self.listeImgSource[0]+"\""+' '+"\""+self.cheminCourantSauv+"\"")
		#####################################################################################
			
		# AFFICHAGE
		
		# Récup de l'extension chargée
		ext_chargee=os.path.splitext(self.listeImgSource[0])[1]
		
		# Si le format (l'extension) chargé et le format sélectionné pour la sortie 
		# dans Réglages sont des formats supportés, l'image avec ce format est 
		# simplement affichéé
		# ----------------------------------------------------------------------
		# Aussi bizarre que cela puisse paraître (et .xpm est un format reconnu) 
		# la conversion en xpm se fait bien mais l'image n'est pas lue dans le 
		# lecteur --> alors conversion en jpeg ... et l'image est lue
		# ----------------------------------------------------------------------
		if ext in formats:
			# Récupération de la liste contenant le chemin+fichier contenus 
			# contenu dans le répertoire temporaire
			listeImgDestinVisuTmp_0=glob.glob(self.repTampon+'*.*')
			listeImgDestinVisuTmp_0.sort()
			# Elimination des fichiers parasites si multiples conversions
			# --> seulement l'extension de sortie sélectionnée est gardée
			for parctemp_0 in listeImgDestinVisuTmp_0:
				if os.path.splitext(parctemp_0)[1]!=ext:
					os.remove(parctemp_0)
					
		# Affichage de l'image temporaire 
		# (/tmp/ekd/tampon/image_filtres_image/image_visu_000001.png)
		# Ouverture d'une boite de dialogue affichant l'aperçu.
		#
		# Affichage par le bouton Voir le résultat
		visio = VisionneurEvolue(self.cheminCourantSauv)
		visio.redimenFenetre(self.mainWindowFrameGeometry, 1., 0.7)
		visio.exec_()
		
		return 0
	######################################################################################################
		
	
	def chang_format(self):
		""" Changer format (gestion de différents formats de fichiers) """
		
		####### Ajouté le 01/12/08 ################################################
		# ATTENTION IL FAUT AJOUTER CECI NE PAS OUBLIER !!!
		self.listeChemin=self.afficheurImgSource.getFiles()
		###########################################################################
		
		# Récup du format sélectionné par l'utilisateur
		i = self.comboReglage.currentIndex()
		ext=self.comboReglage.itemData(i).toString()
		ext=str(ext).lower()
		print "format:", ext
		
		nbreElem=len(self.listeChemin)
		
		# Liste pour affichage des images chargées (ds le tabwidget)
		listeAff_1=[]
		# Liste pour affichage des pages sauvegardées (ds le tabwidget)
		listeAff_2=[]
		
		#################### Retiré le 02/12/08 #######################################
		# La page Image résultat devient visible
		#self.tabwidget.setCurrentIndex(self.indexImageResultat)
		###############################################################################
		
		# Liste des formats supportés pour l'affichage
		formats = [".%s" % unicode(format).lower() \
			for format in QImageReader.supportedImageFormats()]
		
		print "formats:", formats
		
		process = QProcess(self)
		
		# Boucle principale
		for parc in range(nbreElem):
			
			# Chemin de sauvegarde
			# ###########################
			#vraiCheminSauv = self.chemDossierSauv+'_'+string.zfill(parc+1, 6)+ext
			# ###########################
			# Rectifié le 25/10/08 pour la gestion du nombre d'images à traiter ----
			vraiCheminSauv = self.chemDossierSauv+'_'+string.zfill(parc+self.spin1.value(), self.spin2.value())+ext
			# ----------------------------------------------------------------------
			
			################ Rectifié le 15/03/09 (changement complet) ##########################
			# On sélectionne le 'Type de format après traitement' à JPEG (.jpg) ou JPEG (.jpeg)
			# le traitement se fait par Python Imaging Library
			if i in [0, 1]:
				
				im = Image.open(self.listeChemin[parc]).save(vraiCheminSauv, quality=self.spin3.value())
				
				###########################################################################
				# ATTENTION IL FAUT AJOUTER CECI NE PAS OUBLIER !!!
				# Ajout des images par la variable vraiCheminSauv dans la liste
				# self.listeImgDestin. Cette liste sert à récupérer les images pour 
				# l'affichage des images ds l'inteface
				#self.listeImgDestin.append(self.cheminCourantSauv)
				self.listeImgDestin.append(vraiCheminSauv)
				###########################################################################
				
				listeAff_1.append(self.listeChemin[parc])
				listeAff_2.append(vraiCheminSauv)
			
				# ================================================================== #
				# Calcule le pourcentage effectue a chaque passage et ce pour la 
				# barre de progression .
				# ---------------------------------------------
				val_pourc=((parc+1)*100)/nbreElem
			
				# --------------------------------------------
				# Affichage de la progression (avec
				# QProgressDialog) ds une fenêtre séparée
				self.progress.setValue(val_pourc)
				QApplication.processEvents()
				# Bouton Cancel pour arrêter la progression donc le process
				if (self.progress.wasCanceled()): break
				# --------------------------------------------
				
				
			# Si on sélectionne les autres entrées, le traitement se fait par ImageMagick
			else:
			
				# Enregistrement/conversion des formats sélectionnés
				process.start("convert "+"\""+self.listeChemin[parc]+"\" "+"\""+vraiCheminSauv+"\"")
			
				###########################################################################
				# ATTENTION IL FAUT AJOUTER CECI NE PAS OUBLIER !!!
				# Ajout des images par la variable vraiCheminSauv dans la liste
				# self.listeImgDestin. Cette liste sert à récupérer les images pour 
				# l'affichage des images ds l'inteface
				#self.listeImgDestin.append(self.cheminCourantSauv)
				self.listeImgDestin.append(vraiCheminSauv)
				###########################################################################
				
				listeAff_1.append(self.listeChemin[parc])
				listeAff_2.append(vraiCheminSauv)
			
				# ================================================================== #
				# Calcule le pourcentage effectue a chaque passage et ce pour la 
				# barre de progression .
				# ---------------------------------------------
				val_pourc=((parc+1)*100)/nbreElem
			
				# --------------------------------------------
				# Affichage de la progression (avec
				# QProgressDialog) ds une fenêtre séparée
				self.progress.setValue(val_pourc)
				QApplication.processEvents()
				# Bouton Cancel pour arrêter la progression donc le process
				if (self.progress.wasCanceled()): break
				# --------------------------------------------
			
				if not process.waitForStarted(3000):
					QMessageBox.warning(None, _(u"Erreur"), _(u"Bogue au lancement de la commande"))
				process.waitForFinished(-1)
			#####################################################################################
				
				
		# Conditions d'affichage des images dans l'interface
		# Si le format est supporté pour l'affichage ...
		if ext in formats:
				
			#################### Retiré le 02/12/08 #######################################
			#self.afficheurImg_2.setImage(self.cheminCourantSauv)
			###############################################################################
			#################### Rajouté le 02/12/08 ######################################
			# Affichage des images après traitement
			#
			# Changement d'onglet et fonctions associées
			self.conversionImg = 1
			self.metaFctTab(self.indexTabImgDestin)
			###############################################################################

			
		#################### Rajouté le 02/12/08 ######################################
		# ATTENTION IL FAUT AJOUTER CECI NE PAS OUBLIER !!!
		# La liste pour l'affichage des images ds l'interface est
		# vidée pour que les images affichées ne s'amoncellent pas
		# si plusieurs rendus à la suite
		self.listeImgDestin=[]
		###############################################################################
		
		# Affichage des infos sur l'image -------------------------	
		# On implémente les chemins des fichiers dans une variable
		# pour préparer l'affichage des infos
		texte1=_(u" Image(s) chargée(s)")
		texte2=_(u" Image(s) convertie(s)")
		a='#'*36
		
		self.infosImgProv_1=a+'\n#'+texte1+'\n'+a
		self.infosImgProv_2=a+'\n#'+texte2+'\n'+a
		
		# Images chargées
		for parcStatRendu_1 in listeAff_1:
			self.infosImgProv_1=self.infosImgProv_1+'\n'+parcStatRendu_1
			
		# Pages sauvegardées
		for parcStatRendu_2 in listeAff_2:
			self.infosImgProv_2=self.infosImgProv_2+'\n'+parcStatRendu_2
		
		# affichage des infos dans l'onglet
		self.zoneAffichInfosImg.setText(self.infosImgProv_1+'\n\n'+self.infosImgProv_2+'\n\n')
		self.framImg.setEnabled(True)
			
		# remise à 0 de la variable provisoire de log
		self.infosImgProv=''
		# ---------------------------------------------------------

		#################### Retiré le 02/12/08 #######################
		# Epuration/elimination des fichiers tampon
		#for toutRepTemp in glob.glob(self.repTampon+'*.*'):
		#	os.remove(toutRepTemp)
		###############################################################
		
	
	def sonderTempsActuel(self):
		"""x ms après l'apparition de la boite de dialogue, on lance la conversion. But: faire en sorte que la boite de dialogue ait le temps de s'afficher correctement"""
		self.timer.stop()
		self.appliquer()
	
	
	def appliquer(self):
		"""Lancement de la fonction chang_format"""
		self.chang_format()
		
	
	def appliquer0(self):
		"""Préparation de la conversion"""
		
		# Boîte de dialogue pour sauvegarder (nom du nouveau fichier)
		rep = self.base.getRepSource(self.config)
		self.chemDossierSauv=unicode(QFileDialog.getSaveFileName(None, _(u"Sauver"), rep, _(u"Tous les fichiers *.*")))
		
		if not self.chemDossierSauv: return
		
		self.progress.reset()
		self.progress.show()
		self.progress.setValue(0)
		QApplication.processEvents()
		
		# Lancement de la conversion dans 250 ms (seule solution trouvée pour éviter
		# le grisage au début)
		self.timer.start(250)
		
	
	def afficherAide(self):
		"""Boîte de dialogue de l'aide"""
		
		# ATTENTION _ a été mis à la place de tr car le script de mise à jour gettext (mise_a_jour_gettext.py)
		# ne fonctionne pas pour ekdDoc.pot avec les clés --keyword donc les nouvelles lignes vides encore
		# non traduites de la doc se retrouveront dans ekd.pot au lieu de ekdDoc.pot
		messageAide=QMessageBox(self) ## 15/03/09
		messageAide.setText(_(u"<p>Dans l'onglet <b>'Images sources'</b> cliquez sur le bouton <b>Ajouter</b>, une boîte de dialogue apparaît, sur la partie gauche sélectionnez le répertoire (au besoin dépliez les sous-répertoires), allez chercher vos image(s). Si vous voulez sélectionner plusieurs images d'un coup, maintenez la touche <b>CTRL</b> (ou <b>SHIFT</b>) du clavier enfoncée (tout en sélectionnant vos images), cliquez sur <b>Ajouter</b>.</p><p>Dans l'onglet <b>'Réglages'</b> faites les réglages du <b>'Traitement à partir de l'image (numéro)'</b> et du <b>'Nombre de chiffres après le nom de l'image' <font color='red'>(la plupart du temps les valeurs par défaut suffisent)</b></font>, ensuite choisissez votre <b>'Type de format après traitement'</b> et réglez la <b>'Qualité'</b> (disponible uniquement si vous avez sélectionné une image JPEG en sortie). Cliquez sur le bouton <b>'Voir le résultat'</b> (vous voyez à ce moment le résultat de vos réglages sur la première image du lot s'afficher dans une nouvelle fenêtre).</p></p><p>Une fois tout ceci fait, cliquez sur le bouton <b>'Appliquer'</b>, sélectionnez le répertoire de sauvegarde, indiquez votre <b>'Nom de fichier'</b>, cliquez sur le bouton <b>'Enregistrer'</b>.</p><p>Si vous faites un clic droit de la souris (sur l'image) dans l'onglet <b>Image(s) après traitement</b>, vous accédez à des paramètres vous permettant différents affichages de la dite image. De même dans cet onglet vous pouvez lancer la visualisation des images par le bouton <b>Lancer le diaporama</b> (le bouton violet avec une flèche blanche vers la droite).</p><p>L'onglet <b>'Infos'</b> vous permet de voir le filtre utilisé, les image(s) chargée(s) et les image(s) convertie(s).</p>"))
		messageAide.setWindowTitle(_(u"Aide"))
		messageAide.setIcon(QMessageBox.Information)
		messageAide.exec_()
		
		'''
		messageAide=QMessageBox(self) ## 06/12/08
		messageAide.setText(tr(u"<p>Dans l'onglet <b>'Images sources'</b> cliquez sur le bouton <b>Ajouter</b>, une boîte de dialogue apparaît, sur la partie gauche sélectionnez le répertoire (au besoin dépliez les sous-répertoires), allez chercher vos image(s). Si vous voulez sélectionner plusieurs images d'un coup, maintenez la touche <b>CTRL</b> (ou <b>SHIFT</b>) du clavier enfoncée (tout en sélectionnant vos images), cliquez sur <b>Ajouter</b>.</p><p>Dans l'onglet <b>'Réglages 2'</b> faites les réglages du <b>'Traitement à partir de l'image (numéro)'</b> et du <b>'Nombre de chiffres après le nom de l'image' <font color='red'>(la plupart du temps les valeurs par défaut suffisent)</font></b>.</p><p>Dans l'onglet <b>'Réglages 1'</b>, réglez les valeurs qui vous intéressent (vous pouvez voir le nombre maximum d'images affichables en cliquant sur le bouton <b>'Information'</b>). Cliquez sur le bouton <b>'Voir le résultat'</b> (vous voyez à ce moment le résultat de vos réglages sur la première image du lot s'afficher dans une nouvelle fenêtre).</p></p><p>Une fois tout ceci fait, cliquez sur le bouton <b>'Appliquer et sauver'</b>, sélectionnez le répertoire de sauvegarde, indiquez votre <b>'Nom de fichier'</b>, cliquez sur le bouton <b>'Enregistrer'</b>.</p><p>Si vous faites un clic droit de la souris (sur l'image) dans l'onglet <b>Image(s) après traitement</b>, vous accédez à des paramètres vous permettant différents affichages de la dite image. De même dans cet onglet vous pouvez lancer la visualisation des images par le bouton <b>Lancer le diaporama</b> (le bouton violet avec une flèche blanche vers la droite).</p><p>L'onglet <b>'Infos'</b> vous permet de voir le filtre utilisé, les image(s) chargée(s) et les image(s) convertie(s).</p>"))
		messageAide.setWindowTitle(_(u"Aide"))
		messageAide.setIcon(QMessageBox.Information)
		messageAide.exec_()
		'''