#!/usr/bin/python
# -*- coding: Utf-8 -*-

import sys, os, string, shutil, glob ## shutil et glob ajoutés le 23/12/08
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from gui_modules_image.image_base import Base, SpinSlider ## Ajouté le 11/11/08

from gui_modules_image.selectWidget import SelectWidget ## 23/12/08
from gui_modules_lecture.lecture_image import Lecture_VisionImage ## 23/12/08


class Image_Divers_RenomImg(QWidget):
	# -----------------------------------
	# Cadre accueillant les widgets de :
	# Image >> Divers >> Renommer images
	# -----------------------------------
	def __init__(self, parent):
        	QWidget.__init__(self)
		
		# Boite d'alignement vertical
		vbox=QVBoxLayout(self)
		
		################ Rajouté le 23/12/08 ###########################################################
		#=== Création des répertoires temporaires ===#
		self.repTampon = '/tmp/ekd/tampon/image_divers_renommage/'
		if os.path.isdir(self.repTampon) is False:
        		os.makedirs(self.repTampon)
		
		# Au cas où le répertoire existait déjà et qu'il n'était pas vide 
		# -> purge (simple précausion)
		for toutRepCompo in glob.glob(self.repTampon+'*.*'):
			os.remove(toutRepCompo)
		
		#=== Drapeaux ===#
		# Une conversion (même partielle) a-t-elle eu lieu après le chargement des images? (1: vrai)

		# Est-ce que des images sources ont été modifiées? (c'est-à-dire ajoutées ou supprimées)
		self.modifImageSource = 0
		################################################################################################
		
		
		# -------------------------------------------------------------------
		# Titre de la page
		# -------------------------------------------------------------------
		
		#txt1=_(u'Renommer images')
		#titre_du_cadre=QLabel('<H2><CENTER>%s</CENTER></H2>' %txt1, self)
		
		# Ajout du titre de la page a la boite verticale
		#vbox.addWidget(titre_du_cadre, 0)

		#=== Variable de configuration ===#

		# Fonctions communes à plusieurs cadres du module Image
		self.base = Base()
		# Paramètres de configuration
		self.config = parent.config
		# Identifiant du cadre
		idSection = "Image - Renommer"
		# Log du terminal
		self.base.printSection(idSection)
		
		################ Ajouté le 23/12/08 ############################################################
		# Fonction appelant la fenêtre principale
		self.mainWindowFrameGeometry = parent.frameGeometry
		################################################################################################
			
		################ Retiré le 23/12/08 ############################################################
		#self.listeChem = []
		################################################################################################
		
		################ Ajouté le 23/12/08 ############################################################
		self.listeImgSource = []
		################################################################################################

		# -------------------------------------------------------------------
		# Boîte de groupe : "Fichier vidéo source"
		# -------------------------------------------------------------------
		
		'''
		################ Retiré le 23/12/08 ############################################################
		# widgets contenus dans la boite
		self.ligneCheminFichier=QLineEdit()
		self.ligneCheminFichier.setReadOnly(True)
		################################################################################################
		'''
		
		# Si le fichier de configuration contient un paramètre de chemin pour la vidéo
		# et que le chemin spécifié dans le fichier de configuration pour la vidéo est 
		# valide alors on remplit le QLineEdit avec le(s) chemin(s)
		#self.remplirLigneCheminFichier()
		
		# là où s'afficheront les infos
		self.zoneTexte = QTextEdit("")
		if PYQT_VERSION_STR < "4.1.0":
			self.zoneTexte.setText = self.zoneTexte.setPlainText
		self.zoneTexte.setReadOnly(True)
		
		'''
		################ Retiré le 23/12/08 ############################################################
		# Bouton parcourir (pour charger la video)
		boutOuvChargerImages=QPushButton(_(u'Parcourir...'))
		boutOuvChargerImages.setIcon(QIcon("Icones/ouvrir.png"))
		
		self.connect(boutOuvChargerImages, SIGNAL("clicked()"), self.ouvrirImages)
		################################################################################################
		'''
		
		# ###########################
		'''
		# les boîtes de groupes seront placés dans des boîtes horizontales
		group=QGroupBox(_(u"Fichiers images sources"))
		hbox=QHBoxLayout(group)
		hbox.addWidget(self.ligneCheminFichier)
		hbox.addWidget(boutOuvChargerImages)
		vbox.addWidget(group)
		
		self.group=QGroupBox(_(u"Affichage du résultat avant et après renommage des fichiers"))
		vboxZT=QVBoxLayout(self.group)
		vboxZT.addWidget(self.zoneTexte)
		vbox.addWidget(self.group)
		self.group.setEnabled(False)
		'''
		# ###########################
		
		'''
		################ Retiré le 23/12/08 ############################################################
		# les boîtes de groupes seront placés dans des boîtes horizontales
		self.group=QGroupBox(_(u"Fichiers images sources"))
		hbox=QHBoxLayout(self.group)
		hbox.addWidget(self.ligneCheminFichier)
		hbox.addWidget(boutOuvChargerImages)
		vbox.addWidget(self.group)
		################################################################################################
		'''
		
		###### Ajouté le 11/11/08 pour la gestion du nombre d'images à traiter ################
		self.tabwidget=QTabWidget()
		
		#=== 1er onglet ===#
		self.framNbreImg=QFrame()
		vboxReglage=QVBoxLayout(self.framNbreImg)
		
		self.grid = QGridLayout()
		self.grid.addWidget(QLabel(_(u"Traitement à partir de l'image (numéro)")), 0, 0)
		self.spin1=SpinSlider(1, 10000, 1, '', self)
		self.grid.addWidget(self.spin1, 0, 1)
		self.connect(self.spin1, SIGNAL("valueChanged(int)"), self.changeValNbreImg_1)
		self.grid.addWidget(QLabel(_(u"Nombre de chiffres après le nom de l'image")), 1, 0)
		self.spin2=SpinSlider(3, 18, 6, '', self)
		self.grid.addWidget(self.spin2, 1, 1)
		self.connect(self.spin2, SIGNAL("valueChanged(int)"), self.changeValNbreImg_1)
		
		self.grid.setAlignment(Qt.AlignHCenter)
		vboxReglage.addLayout(self.grid)
		vboxReglage.addStretch()
		
		#=== 2ème onglet ===#
		# infos - logs
		self.zoneAffichInfosImg = QTextEdit("")
		if PYQT_VERSION_STR < "4.1.0":
			self.zoneAffichInfosImg.setText = self.zoneAffichInfosImg.setPlainText
		self.zoneAffichInfosImg.setReadOnly(True)
		self.framImg=QFrame()
		vboxReglage=QVBoxLayout(self.framImg)
		vboxReglage.addWidget(self.zoneAffichInfosImg)
		self.framImg.setEnabled(False)
		
		'''
		################ Retiré le 23/12/08 ############################################################
		# Ajout des 2 onglets dans le tabwidget
		self.indexTabNbreImg=self.tabwidget.addTab(self.framNbreImg, _(u"Réglages"))
		self.indexTabInfo=self.tabwidget.addTab(self.framImg, _(u'Infos'))
		################################################################################################
		'''
		
		################ Ajouté le 23/12/08 ############################################################
		# Là où s'afficheront les images
		self.afficheurImgSource=SelectWidget(geometrie = self.mainWindowFrameGeometry)
		################################################################################################
		
		################ Ajouté le 01/12/08 ############################################################
		self.indexTabImgSource = self.tabwidget.addTab(self.afficheurImgSource, _(u'Image(s) source'))
		self.indexTabReglage=self.tabwidget.addTab(self.framNbreImg, _(u'Réglages'))
		self.indexTabInfo=self.tabwidget.addTab(self.framImg, _(u'Infos'))
		################################################################################################
		
		vbox.addWidget(self.tabwidget)
		#######################################################################################
		
		# -------------------------------------------------------------------
		# widgets du bas : ligne + boutons Aide et Appliquer
		# -------------------------------------------------------------------
		
		# boutons
		boutAidetRenomImg=QPushButton(_(u" Aide"))
		boutAidetRenomImg.setIcon(QIcon("Icones/icone_aide_128.png"))
		self.connect(boutAidetRenomImg, SIGNAL("clicked()"), self.afficherAide)
		self.boutApp=QPushButton(_(u" Renommer"))
		self.boutApp.setIcon(QIcon("Icones/icone_appliquer_128.png"))
		
		self.connect(self.boutApp, SIGNAL("clicked()"), self.appliquer)
		
		'''
		################ Retiré le 23/12/08 ############################################################
		# Si pas de chemin spécifié dans la ligne d'édition -> bouton inactif
		if not self.ligneCheminFichier.text(): 
			self.boutApp.setEnabled(False)
		################################################################################################
		'''
		
		# ligne de séparation juste au dessus des boutons
		ligne = QFrame()
		ligne.setFrameShape(QFrame.HLine)
		ligne.setFrameShadow(QFrame.Sunken)
		vbox.addWidget(ligne)
		vbox.addSpacing(-5)	# la ligne doit être plus près des boutons
		
		hbox=QHBoxLayout()
		hbox.addWidget(boutAidetRenomImg)
		hbox.addStretch()	# espace entre les 2 boutons
		hbox.addWidget(self.boutApp)
		################ Ajouté le 23/12/08 ###################################################
		self.boutApp.setEnabled(False)
		#######################################################################################
		vbox.addLayout(hbox)
		
		# affichage de la boîte principale
		self.setLayout(vbox)
		
		################ Ajouté le 23/12/08 ############################################################
		#----------------------------------------------------------------------------------------------------
		# Signal de présence d'images dans ler widget de sélection -> modifie le statut des boutons d'action
		#----------------------------------------------------------------------------------------------------
		
		self.connect(self.afficheurImgSource, SIGNAL("pictureChanged(int)"), self.modifBoutonsAction)
		################################################################################################
		
		
	################ Ajouté le 23/12/08 ############################################################
	def modifBoutonsAction(self, i):
		"On active ou désactive les boutons d'action selon s'il y a des images ou pas dans le widget de sélection"
		self.boutApp.setEnabled(i)
		self.modifImageSource = 1
	################################################################################################
		
		
	###### Ajouté le 11/11/08 pour la gestion du nombre d'images à traiter ################
	def changeValNbreImg_1(self): ##
		print "Traitement a partir de l'image (numero):", self.spin1.value() ##
		print "Nombre de chiffres apres le nom de l'image:", self.spin2.value() ##
	#######################################################################################
	
		
	'''
	################ Retiré le 01/12/08 ############################################################
	def ouvrirImages(self):
		""" Récupération du chemin de la vidéo sélectionnée """
		
		# Chargement des fichiers/images
		#chemin=QFileDialog.getOpenFileNames(None, _(u"Open"), os.path.expanduser('~'),  ("All files (*.*);;JPG (*.jpg);;JPEG (*.jpeg);;PGM (*.pgm);;PNG (*.png);;GIF (*.gif);;BMP (*.bmp);;SGI (*.sgi);;TIF (*.tif)"))
		rep = self.base.getRepSource(self.config)
		chemin=QFileDialog.getOpenFileNames(None, _(u"Ouvrir"), rep,  ("JPEG (*.jpg *.JPG *.jpeg *.JPEG);;PNG (*.png *.PNG);;GIF (*.gif *.GIF);;BMP (*.bmp *.BMP);;SGI (*.sgi *.SGI);;TIF (*.tif *.TIF);;TARGA (*.tga *.TGA);;PNM (*.pnm *.PNM);;PPM (*.ppm *.PPM)"))
		
		# Si pas de fichier sélectionné -> sortir de la fonction
		if not chemin: return
		
		# Convertir les differents fichiers selectionnes
		# en une liste de chaines de caracteres .
        	if not chemin.isEmpty():
			self.listeChem=[unicode(chem) for i, chem in enumerate(chemin)]
		
		self.base.setRepSource(self.config, self.listeChem)
		
		self.a1='###########################\n'
		self.b1=_('Fichiers avant renommage')+':\n'
		self.c1='###########################\n\n'
			
		# L'affichage devient complètement visible
		# ###########################
		#self.group.setEnabled(True)
		# ###########################
		##### Ajouté/rectifié le 11/11/08 ##################################################
		self.framImg.setEnabled(True)
		####################################################################################
		
		# Affichage dans zoneTexte des fichiers avant renommage (uniquement)
		# ###########################
		#self.zoneTexte.setText(self.a1+self.b1+self.c1+"\n".join(self.listeChem))
		#self.zoneTexte.show()
		# ###########################
		##### Ajouté/rectifié le 11/11/08 ##################################################
		self.zoneAffichInfosImg.setText(self.a1+self.b1+self.c1+"\n".join(self.listeChem))
		self.zoneAffichInfosImg.show()
		####################################################################################
		
		# Affichage du chemin + nom de fichier dans la zone
		# de texte du widget QLineEdit (de l'init) .
		if len(self.listeChem)>1:
			self.ligneCheminFichier.setText(self.listeChem[0]+' [...] '+self.listeChem[len(self.listeChem)-1])
		elif len(self.listeChem)==1:
			self.ligneCheminFichier.setText(self.listeChem[0])
		
		# Quand un fichier est sélectionné, le bouton "Renommer" devient
		# cliquable 
		self.boutApp.setEnabled(True)
	################################################################################################
	'''
		
	
	##### Fonction complètement rectifiée le 11/11/08 pour la gestion du nombre d'images à traiter #########
	# Si l'utilisateur charge une seule image l'image sera renommée comme ceci: le_titre.extension
	# Si l'utilisateur charge plusieurs images les images seront renommées comme ceci: le_titre_001.extension,
	# le_titre_002.extension, le_titre_003.extension, ...
	def appliquer(self):
		"""appliquer le renommage des images"""
		
		self.a1='###########################\n'
		self.b1=_('Fichiers avant renommage')+':\n'
		self.c1='###########################\n\n'
		
		####### Ajouté le 23/12/08 ################################################
		# ATTENTION IL FAUT AJOUTER CECI NE PAS OUBLIER !!!
		# Récupération de la liste des fichiers chargés
		self.listeImgSource=self.afficheurImgSource.getFiles()
		self.listeImgSource.sort()
		
		# Nombre d'éléments présents dans la liste
		nbreElem=len(self.listeImgSource)
		
		# Copie par une boucle des images chargées par l'utilisateur dans le rep.
		# tampon --> shutil.copy(...) (on ne va pas utiliser
		# os.rename(source, destination) mais shutil.move(source, destination))
		# car avec os.rename les fichiers source sont détruits, ce qui est une très
		# mauvaise chose. De plus si o utilise os.rename on obtient l'erreur: OSError:
		# [Errno 18] Lien croisé invalide
		#
		for n in range(nbreElem): shutil.copy(self.listeImgSource[n], self.repTampon)
		
		# Récup des images du rep tampon	
		l_imgSource=glob.glob(self.repTampon+'*.*')
		l_imgSource.sort()
		###########################################################################
		
		'''
		################ Retiré le 01/12/08 #######################################
		# Récupération du chemin + vidéo chargée et de l'extension 
		# (la première image de la liste) 
		fich, ext=os.path.splitext(self.listeChem[0])
		###########################################################################
		'''
		
		####### Ajouté/rectifié le 23/12/08 #######################################
		# Récupération du chemin + vidéo chargée et de l'extension 
		# (la première image de la liste) 
		fich, ext=os.path.splitext(self.listeImgSource[0])
		###########################################################################
		
		rep = self.base.getRepSource(self.config)
		# Boîte de dialogue pour sauvegarder (nom du nouveau fichier)
		sauver=unicode(QFileDialog.getSaveFileName(None, _(u"Sauver"), rep, _(u"Images avec cette extension (*%s)" %ext)))
		
		if not sauver: return
		
		listeSauve=[]
		
		'''
		################ Retiré le 23/12/08 #######################################
		if len(self.listeChem)==1:
			os.rename(self.listeChem[0], sauver+ext)
			listeSauve.append(sauver+ext)
			
		elif len(self.listeChem)>1:
		###########################################################################
		'''
			
		#################### Ajouté le 23/12/08 #########################################
		if len(self.listeImgSource)==1:
			
			# Renommage et sauvegarde
			shutil.move(l_imgSource[0], sauver+ext)
			listeSauve.append(sauver+ext)
			#################################################################################
			
		elif len(self.listeImgSource)>1:
		
			# Barre de progression dans une fenêtre séparée . Attention la fenêtre
			# de la barre se ferme dès que la progression est terminée . En cas de
			# process très court, la fenêtre peut n'apparaître que très brièvement
			# (voire pas du tout si le temps est très très court) .
			self.progress=QProgressDialog(_(u"Opération en cours ..."), _(u"Annuler conversion"), 0, 100)
			self.progress.setWindowTitle(_(u'EnKoDeur-Mixeur . Fenêtre de progression'))
			# Attribution des nouvelles dimensions 
			self.progress.setMinimumWidth(500)
			self.progress.setMinimumHeight(100)
			# setGeometry est utilisé ici uniquement pour le placement à la position 0, 0
			# je ne suis pas un adepte de la position 0,0 :-P (Romain)
			#self.progress.setGeometry(QRect(0, 0, 500, 100))
		
			self.progress.show()
		
			################ Retiré le 23/12/08 #######################################
			#nbreElem=len(self.listeChem)
			###########################################################################
			
			for parc in range(nbreElem):
				
				# Renommage et sauvegarde
				
				# ###########################
				#os.rename(self.listeChem[parc], sauver+'_'+string.zfill((parc+1), 6)+ext)
				# ###########################
				
				'''
				################ Retiré le 23/12/08 #############################################
				##### Rectifié le 11/11/08 pour la gestion du nombre d'images à traiter #########
				os.rename(self.listeChem[parc], sauver+'_'+string.zfill((parc+self.spin1.value()), self.spin2.value())+ext)
				#################################################################################
				#################################################################################
				'''
				
				####### Ajouté/rectifié le 23/12/08 #############################################
				#vraiCheminSauv = self.listeImgSource[parc], sauver+'_'+string.zfill((parc+self.spin1.value()), self.spin2.value())+ext

				shutil.move(l_imgSource[parc], sauver+'_'+string.zfill((parc+self.spin1.value()), self.spin2.value())+ext)
				#################################################################################
				
				# Liste pour affichage dans zoneTexte
				# ###########################
				#listeSauve.append(sauver+'_'+string.zfill((parc+1), 6)+ext)
				# ###########################
				##### Rectifié le 11/11/08 pour la gestion du nombre d'images à traiter #########
				listeSauve.append(sauver+'_'+string.zfill((parc+self.spin1.value()), self.spin2.value())+ext)
				#################################################################################
			
				# --------------------------------------------
				# Affichage de la progression (avec
				# QProgressDialog) ds une fenêtre séparée .
				val_pourc=((parc+1)*100)/nbreElem

				# Bouton Cancel pour arrêter la progression donc le process
				if (self.progress.wasCanceled()):
					break

				self.progress.setValue(val_pourc)
		
				QApplication.processEvents()
				# --------------------------------------------
		
		self.a2='###########################\n'
		self.b2=_(u'Fichiers après renommage')+':\n'
		self.c2='###########################\n\n'

		# Affichage dans zoneTexte des fichiers avant et après renommage
		
		'''
		################ Retiré le 23/12/08 ################################################
		##### Ajouté/rectifié le 11/11/08 ##################################################
		self.zoneAffichInfosImg.setText(self.a1+self.b1+self.c1+"\n".join(self.listeChem)+'\n\n'+self.a2+self.b2+self.c2+"\n".join(listeSauve))
		self.zoneAffichInfosImg.show()
		self.framImg.setEnabled(True)
		# La page Infos devient visible à la fin du renommage
		self.tabwidget.setCurrentIndex(self.indexTabInfo)
		####################################################################################
		####################################################################################
		'''
		
		################ Ajouté le 23/12/08 ################################################
		self.zoneAffichInfosImg.setText(self.a1+self.b1+self.c1+"\n".join(self.listeImgSource)+'\n\n'+self.a2+self.b2+self.c2+"\n".join(listeSauve))
		self.framImg.setEnabled(True)
		self.tabwidget.setCurrentIndex(self.indexTabInfo)
		####################################################################################
	########################################################################################################


	def afficherAide(self):
		""" Boîte de dialogue de l'aide du cadre Image > Renommer """
		messageAide=QMessageBox(self) ## 23/12/08
		messageAide.setText(tr(u"<p>Dans l'onglet <b>'Images sources'</b> cliquez sur le bouton <b>Ajouter</b>, une boîte de dialogue apparaît, sur la partie gauche sélectionnez le répertoire (au besoin dépliez les sous-répertoires), allez chercher vos image(s). Si vous voulez sélectionner plusieurs images d'un coup, maintenez la touche <b>CTRL</b> (ou <b>SHIFT</b>) du clavier enfoncée (tout en sélectionnant vos images), cliquez sur <b>Ajouter</b>.<p></p>Dans l'onglet <b>'Réglages'</b> faites les réglages du <b>'Traitement à partir de l'image (numéro)'</b> et du <b>'Nombre de chiffres après le nom de l'image' <font color='red'>(la plupart du temps les valeurs par défaut suffisent)</font></b></p>.<p>Une fois tout ceci fait, cliquez sur le bouton <b>'Renommer'</b>, sélectionnez le répertoire de sauvegarde, indiquez votre <b>'Nom de fichier'</b>, cliquez sur le bouton <b>'Enregistrer'</b>.</p><p>Après le traitement vous pouvez immédiatement voir l'affichage du résultat avant et après renommage des fichiers par l'onglet <b>'Infos'</b>.</p>"))
		messageAide.setWindowTitle(_(u"Aide"))
		messageAide.setIcon(QMessageBox.Information)
		messageAide.exec_()