#!/usr/bin/python
# -*- coding: Utf-8 -*-	

# Script qui sert à copier ...
#
# /usr/share/ekd/locale/en_EN/LC_MESSAGES/ekd.mo et /usr/share/ekd/locale/en_EN/LC_MESSAGES/ekdDoc.mo vers (par
# exemple) /usr/share/ekd/locale/en_AU/LC_MESSAGES/ekd.mo et /usr/share/ekd/locale/en_AU/LC_MESSAGES/ekd.mo 
# (et ce pour tous les répertoires symbole langue dont la langue officielle est l'anglais)
#
# puis ...
#
# /usr/share/ekd/locale/es_ES/LC_MESSAGES/ekd.mo et /usr/share/ekd/locale/es_ES/LC_MESSAGES/ekdDoc.mo vers (par
# exemple) /usr/share/ekd/locale/es_AR/LC_MESSAGES/ekd.mo /usr/share/ekd/locale/es_AR/LC_MESSAGES/ekd.mo 
# (et ce pour tous les répertoires symbole langue dont la langue officielle est l'espagnol).
#
# ATTENTION (!!!): les répertoires (et sous-répertoires):
#
# /usr/share/ekd/locale/en_EN/LC_MESSAGES et /usr/share/ekd/locale/es_ES/LC_MESSAGES
#
# ... ne doivent jamais être éliminés.
#
# Les nationalités et communautés gérées pour l'instant sont:
#
# pour l'anglais (autres que 'en_EN' ==> English):
#
# 'en_AU' => 'English (Australia)', 'en_CA' => 'English (Canada)', 'en_GB' => 'English (United Kingdom)',
# 'en_HK' => 'English (Hong Kong SAR China)', 'en_IE' => 'English (Ireland)', 'en_IN' => 'English (India)',
# 'en_JM' => 'English (Jamaica)', 'en_LR' => 'English (Liberia)', 'en_NZ' => 'English (New Zealand)',
# 'en_PH' => 'English (Philippines)', 'en_SG' => 'English (Singapore)', 'en_TT' => 'English (Trinidad and Tobago)',
# 'en_US' => 'English (United States)', 'en_ZA' => 'English (South Africa)'.
#
# pour l'espagnol (autres que 'es_ES' => Spanish):
#
# 'es_AR' => 'Spanish (Argentina)', 'es_BO' => 'Spanish (Bolivia)', 'es_CA' => 'Spanish (Canada)', 
# 'es_CL' => 'Spanish (Chile)', 'es_CO' => 'Spanish (Colombia)', 'es_CR' => 'Spanish (Costa Rica)', 
# 'es_CU' => 'Spanish (Cuba)', 'es_DO' => 'Spanish (Dominican Republic)', 'es_EC' => 'Spanish (Ecuador)', 
# 'es_GQ' => 'Spanish (Equatorial Guinea)', 'es_GT' => 'Spanish (Guatemala)', 'es_HN' => 'Spanish (Honduras)', 
# 'es_MX' => 'Spanish (Mexico)', 'es_NI' => 'Spanish (Nicaragua)', 'es_PA' => 'Spanish (Panama)', 
# 'es_PE' => 'Spanish (Peru)', 'es_PR' => 'Spanish (Puerto Rico)', 'es_PY' => 'Spanish (Paraguay)', 
# 'es_SV' => 'Spanish (El Salvador)', 'es_US' => 'Spanish (United States)', 'es_UY' => 'Spanish (Uruguay)', 
# 'es_VE' => 'Spanish (Venezuela)'.


import os, glob, shutil

# Chemin exact
pourDeb = '/usr/share/ekd/'

# On liste tous les chemins possibles des nationalités (ou communautés) de langue anglaise et espagnole
ChemSymbLang_EN_ES = [pourDeb+'locale/en_AU/LC_MESSAGES', pourDeb+'locale/en_CA/LC_MESSAGES', pourDeb+'locale/en_GB/LC_MESSAGES', pourDeb+'locale/en_HK/LC_MESSAGES', pourDeb+'locale/en_IE/LC_MESSAGES', pourDeb+'locale/en_IN/LC_MESSAGES', pourDeb+'locale/en_JM/LC_MESSAGES', pourDeb+'locale/en_LR/LC_MESSAGES', pourDeb+'locale/en_NZ/LC_MESSAGES', pourDeb+'locale/en_PH/LC_MESSAGES', pourDeb+'locale/en_SG/LC_MESSAGES', pourDeb+'locale/en_TT/LC_MESSAGES', pourDeb+'locale/en_US/LC_MESSAGES', pourDeb+'locale/en_ZA/LC_MESSAGES', pourDeb+'locale/es_AR/LC_MESSAGES', pourDeb+'locale/es_BO/LC_MESSAGES', pourDeb+'locale/es_CA/LC_MESSAGES', pourDeb+'locale/es_CL/LC_MESSAGES', pourDeb+'locale/es_CO/LC_MESSAGES', pourDeb+'locale/es_CR/LC_MESSAGES', pourDeb+'locale/es_CU/LC_MESSAGES', pourDeb+'locale/es_DO/LC_MESSAGES', pourDeb+'locale/es_EC/LC_MESSAGES', pourDeb+'locale/es_GQ/LC_MESSAGES', pourDeb+'locale/es_GT/LC_MESSAGES', pourDeb+'locale/es_HN/LC_MESSAGES', pourDeb+'locale/es_MX/LC_MESSAGES', pourDeb+'locale/es_NI/LC_MESSAGES', pourDeb+'locale/es_PA/LC_MESSAGES', pourDeb+'locale/es_PE/LC_MESSAGES', pourDeb+'locale/es_PR/LC_MESSAGES', pourDeb+'locale/es_PY/LC_MESSAGES', pourDeb+'locale/es_SV/LC_MESSAGES', pourDeb+'locale/es_US/LC_MESSAGES', pourDeb+'locale/es_UY/LC_MESSAGES', pourDeb+'locale/es_VE/LC_MESSAGES']

# Ensuite on crée les répertoires (si les répertoires intermédiaires 
# n'existent pas, ils sont crées --aussi-- à la volée)
for repNation_EN_ES in ChemSymbLang_EN_ES:
	# Si tous les répertoires existent déjà
	# il ne se passe rien ...
	if os.path.exists(repNation_EN_ES):
		pass
	# Autrement ils sont crées ...
	else: os.makedirs(repNation_EN_ES, 0755)
	
# Liste récupérant les chemins sous la forme: /usr/share/ekd/locale/en_CA (Canada) et en excluant du lot: /usr/share/ekd/locale/en_EN
contenu_locale_EN = [enX for enX in glob.glob(pourDeb+'locale/*') if enX[:-3] == pourDeb+'locale/en' and enX != pourDeb+'locale/en_EN']
# Liste récupérant les chemins sous la forme: /usr/share/ekd/locale/es_CU (Cuba) et en excluant du lot: /usr/share/ekd/locale/es_ES
contenu_locale_ES = [esX for esX in glob.glob(pourDeb+'locale/*') if esX[:-3] == pourDeb+'locale/es' and esX != pourDeb+'locale/es_ES']

# On vérifie si les fichiers ekd.mo et ekdDoc.mo sont déjà présents dans
# les différents répertoires en_..., si c'est le cas ils sont éliminés.
# Ensuite les fichiers .mo sont copiés dans chaque répertoire de langue
# anglaise
for parcEN in contenu_locale_EN:
	parc_EN = parcEN + '/' + 'LC_MESSAGES/'
	if 'ekd.mo' in os.listdir(parc_EN):
		os.remove(parc_EN+'ekd.mo')
	shutil.copy(pourDeb+'locale/en_EN/LC_MESSAGES/ekd.mo', parc_EN)
	if 'ekdDoc.mo' in os.listdir(parc_EN):
		os.remove(pourDeb+parc_EN+'ekdDoc.mo')
	shutil.copy(pourDeb+'locale/en_EN/LC_MESSAGES/ekdDoc.mo', parc_EN)

# Même chose qu'au dessus mais pour la langue espagnole
for parcES in contenu_locale_ES:
	parc_ES = parcES + '/' + 'LC_MESSAGES/'
	if 'ekd.mo' in os.listdir(parc_ES):
		os.remove(parc_ES+'ekd.mo')
	shutil.copy(pourDeb+'locale/es_ES/LC_MESSAGES/ekd.mo', parc_ES)
	if 'ekdDoc.mo' in os.listdir(parc_ES):
		os.remove(pourDeb+parc_ES+'ekdDoc.mo')
	shutil.copy(pourDeb+'locale/es_ES/LC_MESSAGES/ekdDoc.mo', parc_ES)
