#!/usr/bin/python
# -*- coding: Utf-8 -*-

import sys, os
from PyQt4.QtGui import *
from PyQt4.QtCore import *
from moteur_modules_animation.mplayer import getVideoLength
import subprocess


'''
################ Enlevé le 09/01/09 ##################################################
def extraireImage(cheminVideoSource, cheminRepDestination, valeurNum):
	"Extraction d'une image d'une vidéo"
	commande = 'mplayer -ss ' + valeurNum + ' -frames 1 -vo null -ao null ' + "\"" +\
		cheminVideoSource.encode("UTF8") + "\" -vo jpeg:outdir=\"" +\
		cheminRepDestination.encode("UTF8") + "\":quality=100"
	os.system(commande)
######################################################################################
'''
################ Rajouté/hangé le 09/01/09 ###########################################
# La syntaxe Mplayer a été remplacée par la syntaxe FFmpeg car la syntaxe
# Mplayer generait des bugs dans l'extraction des images --> avec certaines 
# vidéos (et de façon alléatoire). Le rendu est un peu plus lent qu'avec
# Mplayer mais plus de bugs.
def extraireImage(cheminVideoSource, cheminRepDestination, valeurNum):
	"Extraction d'une image d'une vidéo"

	commande = 'ffmpeg -i '+ "\"" + cheminVideoSource.encode("UTF8") + "\"" + \
		' -vframes 1 ' + ' -ss ' + valeurNum + ' -f image2 ' + "\"" +\
		cheminRepDestination.encode("UTF8") + '_%8d.jpg' + "\""
	os.system(commande)
######################################################################################


class WidgetMEncoder(QDialog):
	def __init__(self, idCodec, cheminVideoEntre, cheminSorti, valeurNum=0, laisserOuvert=1, tailleIm=None, systeme=None, cheminMEncoder=None, cheminFfmpeg2theora=None, tempsApercu=None, optionSpeciale=None, cheminMPlayer=None, cheminFfmpeg=None): ##
		"""widget mplayer"""
		QDialog.__init__(self)
		
		#=== Paramètres généraux ===#
		
		self.systeme=systeme
		
		'''
		########### JUSTE POUR ESSAI ############################################
		self.systeme=sys.platform
		print 'self.systeme', self.systeme
		if self.systeme=='linux2' or self.systeme=='darwin' or self.systeme==None:
		########### JUSTE POUR ESSAI ############################################
		'''
		
		# système d'exploitation
		if self.systeme=='linux' or self.systeme=='darwin' or self.systeme==None:
			self.cheminMEncoder="mencoder"	# moteur de lecture mplayer
			self.cheminFfmpeg2theora="ffmpeg2theora"
			self.cheminMPlayer="mplayer"
			self.cheminFfmpeg="ffmpeg" ##
		elif self.systeme=='windows':
			self.cheminMEncoder=cheminMEncoder
			self.cheminFfmpeg2theora=cheminFfmpeg2theora
			self.cheminMPlayer=cheminMPlayer
			self.cheminFfmpeg=cheminFfmpeg ##
		
		# chemins vidéos
		self.cheminVideoEntre = cheminVideoEntre
		self.cheminSorti = cheminSorti
		
		# identifiant du codec
		self.idCodec = idCodec
		
		# valeur de la boite de spin pour l'encodage
		self.valeurNum = valeurNum
		
		# dimension des images (liste de 2 éléments)
		self.tailleIm = tailleIm
		
		# laisser ouvert la fenêtre après encodage
		self.laisserOuvert = laisserOuvert
		
		# Conversion minimale du filtre pour avoir un aperçu.
		# Indique le temps où l'aperçu doit être créé
		self.tempsApercu = tempsApercu
		
		# drapeau pour ne pas lancer 2 fois l'encodage
		self.estLancee = False
		
		# Est-ce que le 1er % de progression a été récupéré (utile pour montage vidéo -> découper)?
		self.__recupPourcentDebut = 0
		
		self.log = [] # stocke les infos de mplayer et mencoder
		
		# Pour le son lors de la découpe vidéo pour l'instant
		if optionSpeciale!=None:
			self.optionSpeciale = optionSpeciale
		
		self.resize(500, 100)
		
		#=== Widgets ===#
		
		#################### Ajouté le 30/12/08 ###################################################
		self.labelAttente=QLabel()
		self.labelAttente.setText(_(u"Attendez la fin du calcul s'il vous plaît, soyez patient !"))
		###########################################################################################
		
		self.zoneTexte = QTextEdit("") # là où s'afficheront les infos
		if PYQT_VERSION_STR < "4.1.0":
			self.zoneTexte.setText = self.zoneTexte.setPlainText
		self.zoneTexte.setReadOnly(True)
		self.zoneTexte.hide()
		
		#self.bout_demarrer = QPushButton("encode and save")
		
		self.bout_annuler = QPushButton(_(u"Annuler"))
		
		self.bout_preZoneTexte = QPushButton(_("Voir les informations de l'encodage"))
		self.bout_preZoneTexte.hide()
		
		self.pbar = QProgressBar()
		self.pbar.setMaximum(100)
		
		self.mencoderProcess = QProcess(self)
		self.ffmpeg2theoraProcess = QProcess(self)
		self.mplayerProcess = QProcess(self)
		self.ffmpegProcess = QProcess(self) ##
		
		#=== mise-en-page/plan ===#
		
		vbox = QVBoxLayout()
		#vbox.addStretch()
		#hbox = QHBoxLayout()
		#hbox.addWidget(self.bout_demarrer)
		#################### Ajouté le 30/12/08 ###################################################
		vbox.addWidget(self.labelAttente)
		###########################################################################################
		vbox.addWidget(self.bout_preZoneTexte)
		#vbox.addLayout(hbox)
		vbox.addWidget(self.zoneTexte)
		hbox = QHBoxLayout()
		hbox.addWidget(self.pbar)
		hbox.addWidget(self.bout_annuler)
		vbox.addLayout(hbox)
		self.setLayout(vbox)
		
		#self.adjustSize()
		
		#=== connexion des widgets à des fonctions ===#
		
		#self.demarrerMEncoder() # TEST # sert à calculer la durée d'exécution du script -> comparaison avec avec et sans traitement des lignes de sortie de QProcess
		# 'readyReadStandardOutput()': signal émis lors de la sortie standart de lecture
		self.connect(self.mencoderProcess, SIGNAL('readyReadStandardOutput()'), self.recupSortieMencoder)
		self.connect(self.ffmpeg2theoraProcess, SIGNAL('readyReadStandardOutput()'), self.recupSortieFfmpeg2theora)
		self.connect(self.mplayerProcess, SIGNAL('readyReadStandardOutput()'), self.recupSortieMplayer)
		self.connect(self.ffmpegProcess, SIGNAL('readyReadStandardOutput()'), self.recupSortieFfmpeg) ##
		
		self.connect(self.mencoderProcess, SIGNAL('finished(int)'), self.finEncodage)
		self.connect(self.ffmpeg2theoraProcess, SIGNAL('finished(int)'), self.finEncodage)
		self.connect(self.mplayerProcess, SIGNAL('finished(int)'), self.finEncodage)
		self.connect(self.ffmpegProcess, SIGNAL('finished(int)'), self.finEncodage) ##
		
		self.connect(self.bout_annuler, SIGNAL('clicked()'), self.close)
		self.connect(self.bout_preZoneTexte, SIGNAL('clicked()'), self.afficherLog)
		
		# Si le codec OGG THEORA est sélectionné
		if idCodec=='codecoggtheora':
			self.demarrerEncodeur('Ffmpeg2theora')
		# Tout ce qui est géré par FFmpeg
		elif idCodec in ['codec_dv_ffmpeg', 'codec_mov_ffmpeg', 'codec_hfyu_ffmpeg', 'codec_vob_ffmpeg', 'codec_AMV_ffmpeg', 'codec_3GP_ffmpeg', 'idx', 'mpeg1video','mjpeg','h263p','mpeg4','msmpeg4v2','ljpeg', 'dv', 'huffyuv', 'mov', 'flv', 'mp4', 'vob', 'hd_1920x1080_mov__pcm_s16be__16/9', 'hd_1280x720_mov__pcm_s16be__16/9', 'hd_1440x1080_mov__pcm_s16be__4/3']:
			self.demarrerEncodeur('Ffmpeg')
		# Tout ce qui est géré par Mplayer
		elif idCodec in ['extractionaudio','jpeg', 'encodage_wav']:
			self.demarrerEncodeur('MPlayer Conversion')
		# Autrement ...
		else:
			self.demarrerEncodeur('Mencoder')
	
	
	def demarrerEncodeur(self, encodeur):
		"""démarrage de mencoder avec les arguments choisis"""
		
		if self.estLancee == False: # pas question de démarrer 2 fois l'encodage
			
			print '\n'
			
			'''
			#################### Retiré le 30/12/08 ##################################################
			a = "########################"
			b = "# Informations MPlayer :"
			c = "########################"
			
			infos = '\n'+a+'\n'+b+'\n'+c+'\n'
			print infos
			self.log.append(infos)
			###########################################################################################
			'''
			
			# Détermination du chemin de la vidéo
			if isinstance(self.cheminVideoEntre, tuple): # chemin vidéo et audio
				cheminVid = self.cheminVideoEntre[0]
			else: # chemin vidéo uniquement (le plus probable)
				cheminVid = self.cheminVideoEntre

			# Recupération directement ds Mplayer de la durée de la vidéo sauf pour les cas où
			# les fichiers sources sont des images (DONC ICI SI LE FICHIER CHARGE EST UNE VIDEO)
			# Cette donnée est très importante ...
			if not self.idCodec in ['mpeg1video', 'mjpeg', 'h263p', 'mpeg4', 'msmpeg4v2', 'ljpeg', 'dv', 'huffyuv', 'mov', 'flv', 'mp4', 'vob']:
				
				#################### Ajouté/changé le 30/12/08 ###################################
				a = "########################"
				b = "# Informations MPlayer :"
				c = "########################"
			
				infos = '\n'+a+'\n'+b+'\n'+c+'\n'
				print infos
				self.log.append(infos)
				###################################################################################
				
				self.dureeTotaleVideo, log = getVideoLength(cheminVid)
				
				# On complète le log
				for ligne in log:
					self.log.append(ligne)
					
			#################### Ajouté le 30/12/08 ###################################################
			# ICI SI LES FICHIERS CHARGES SONT DES IMAGES
			else:
				a = "###############################"
				b = "# Informations sur les images :"
				c = "###############################"
			
				infos = '\n'+a+'\n'+b+'\n'+c+'\n'
				print infos
				self.log.append(infos)
				
				import glob
				# Récup des images
				self.recupTempImgAnim=glob.glob("/tmp/ekd/tampon/conv_img_en_video/*.*")
				self.recupTempImgAnim.sort()
				# Affichage du chemin (temp) + le poids de chaque image
				for parcInfIm in self.recupTempImgAnim:
					print '* '+parcInfIm+' --> '+str(float(os.path.getsize(parcInfIm)/1000))+' ko'+'\n'
					self.log.append('* '+parcInfIm+' --> '+str(float(os.path.getsize(parcInfIm)/1000))+' ko'+'\n')
			###########################################################################################

			print '\n'
			
			a = "############################"
			b = "# Informations %s :" %encodeur
			c = "############################"
			
			infos = '\n'+a+'\n'+b+'\n'+c+'\n'
			print infos
			self.log.append(infos)
			
			if encodeur == 'Ffmpeg2theora':
				# mode de canal: on fusionne le canal de sortie normal 
				# (stdout) et celui des erreurs (stderr)
				if PYQT_VERSION_STR >= "4.1.0":
					self.ffmpeg2theoraProcess.setProcessChannelMode(QProcess.MergedChannels)
				
				commande = self.commandeFfmpeg2theora(self.idCodec, self.cheminVideoEntre, self.cheminSorti, self.valeurNum, self.cheminFfmpeg2theora)
				#print commande
				self.log.append(commande+'\n\n')
				self.ffmpeg2theoraProcess.start(commande)
				
				# au cas où ffmpeg2theora ne démarrerait pas au bout
				# de 3 sec (ex. problème de codec)
				if not self.ffmpeg2theoraProcess.waitForStarted(3000):
					QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec ffmpeg2theora"))

			if encodeur == 'Ffmpeg': ##
				if self.idCodec=='codec_dv_ffmpeg': ##
					commande = self.commandeFfmpegEncodageDv(self.cheminVideoEntre, self.cheminSorti, self.cheminFfmpeg) ##
					#print commande ##
					self.log.append(commande+'\n\n') ##
					# mode de canal: on fusionne le canal de sortie normal ##
					# (stdout) et celui des erreurs (stderr) ##
					if PYQT_VERSION_STR >= "4.1.0": ##
						self.ffmpegProcess.setProcessChannelMode(QProcess.MergedChannels) ##
					self.ffmpegProcess.start(commande) ##
				
					# au cas où ffmpeg ne démarrerait pas au bout ##
					# de 3 sec (ex. problème de codec) ##
					if not self.ffmpegProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec ffmpeg")) ##
						
				elif self.idCodec=='codec_mov_ffmpeg': ##
					commande = self.commandeFfmpegEncodageMov(self.cheminVideoEntre, self.cheminSorti, self.cheminFfmpeg) ##
					#print commande ##
					self.log.append(commande+'\n\n') ##
					# mode de canal: on fusionne le canal de sortie normal ##
					# (stdout) et celui des erreurs (stderr) ##
					if PYQT_VERSION_STR >= "4.1.0": ##
						self.ffmpegProcess.setProcessChannelMode(QProcess.MergedChannels) ##
					self.ffmpegProcess.start(commande) ##
				
					# au cas où ffmpeg ne démarrerait pas au bout ##
					# de 3 sec (ex. problème de codec) ##
					if not self.ffmpegProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec ffmpeg")) ##
						
				elif self.idCodec=='codec_hfyu_ffmpeg': ##
					commande = self.commandeFfmpegEncodageHfyu(self.cheminVideoEntre, self.cheminSorti, self.cheminFfmpeg) ##
					#print commande ##
					self.log.append(commande+'\n\n') ##
					# mode de canal: on fusionne le canal de sortie normal ##
					# (stdout) et celui des erreurs (stderr) ##
					if PYQT_VERSION_STR >= "4.1.0": ##
						self.ffmpegProcess.setProcessChannelMode(QProcess.MergedChannels) ##
					self.ffmpegProcess.start(commande) ##
				
					# au cas où ffmpeg ne démarrerait pas au bout ##
					# de 3 sec (ex. problème de codec) ##
					if not self.ffmpegProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec ffmpeg")) ##
						
				elif self.idCodec=='codec_vob_ffmpeg': ## 
					commande = self.commandeFfmpegEncodageVob(self.cheminVideoEntre, self.cheminSorti, self.cheminFfmpeg) ##
					#print commande ##
					self.log.append(commande+'\n\n') ##
					# mode de canal: on fusionne le canal de sortie normal ##
					# (stdout) et celui des erreurs (stderr) ##
					if PYQT_VERSION_STR >= "4.1.0": ##
						self.ffmpegProcess.setProcessChannelMode(QProcess.MergedChannels) ##
					self.ffmpegProcess.start(commande) ##
					
					# au cas où ffmpeg ne démarrerait pas au bout ##
					# de 3 sec (ex. problème de codec) ##
					if not self.ffmpegProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec ffmpeg")) ##
					
				elif self.idCodec=='codec_3GP_ffmpeg': ##
					commande = self.commandeFfmpegEncodage3gp(self.cheminVideoEntre, self.cheminSorti, self.cheminFfmpeg) ##
					#print commande ##
					self.log.append(commande+'\n\n') ##
					# mode de canal: on fusionne le canal de sortie normal ##
					# (stdout) et celui des erreurs (stderr) ##
					if PYQT_VERSION_STR >= "4.1.0": ##
						self.ffmpegProcess.setProcessChannelMode(QProcess.MergedChannels) ##
					self.ffmpegProcess.start(commande) ##
				
					# au cas où ffmpeg ne démarrerait pas au bout ##
					# de 3 sec (ex. problème de codec) ##
					if not self.ffmpegProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec ffmpeg")) ##
						
				elif self.idCodec=='codec_AMV_ffmpeg': ##
					commande = self.commandeFfmpegEncodageAMV(self.cheminVideoEntre, self.cheminSorti, self.cheminFfmpeg) ##
					#print commande
					self.log.append(commande+'\n\n') ##
					# mode de canal: on fusionne le canal de sortie normal 
					# (stdout) et celui des erreurs (stderr)
					if PYQT_VERSION_STR >= "4.1.0": ##
						self.mencoderProcess.setProcessChannelMode(QProcess.MergedChannels) ##
					self.mencoderProcess.start(commande) ##
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mencoderProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec mencoder")) ##
						
                                elif self.idCodec=='idx': # change le nombre d'images/s ##
					commande = self.commandeFfmpegNbrImgSec(self.cheminVideoEntre, self.cheminSorti, self.valeurNum, self.cheminFfmpeg) ##
					#print commande
					self.log.append(commande+'\n\n') ##
					if PYQT_VERSION_STR >= "4.1.0": ##
						self.ffmpegProcess.setProcessChannelMode(QProcess.MergedChannels) ##
					self.ffmpegProcess.start(commande) ##

					# au cas où mplayer ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.ffmpegProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement du changement du nombre d'images par seconde")) ##
						
				elif self.idCodec in ['mpeg1video', 'mjpeg', 'h263p', 'mpeg4', 'msmpeg4v2', 'ljpeg', 'dv', 'huffyuv', 'mov', 'flv', 'mp4', 'vob']:
					commande = self.commandeFfmpegConvertImg(self.idCodec, self.cheminVideoEntre, self.cheminSorti, self.valeurNum, self.tailleIm, self.cheminFfmpeg)
					#print commande
					self.log.append(commande+'\n\n')
					# mode de canal: on fusionne le canal de sortie normal 
					# (stdout) et celui des erreurs (stderr)
					if PYQT_VERSION_STR >= "4.1.0":
						self.ffmpegProcess.setProcessChannelMode(QProcess.MergedChannels)
					self.ffmpegProcess.start(commande)
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.ffmpegProcess.waitForStarted(3000):
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec ffmpeg"))
						
				elif self.idCodec in ['hd_1920x1080_mov__pcm_s16be__16/9', 'hd_1280x720_mov__pcm_s16be__16/9', 'hd_1440x1080_mov__pcm_s16be__4/3']:
					commande = self.commandeFfmpegConvHD(self.idCodec, self.cheminVideoEntre, self.cheminSorti, self.cheminFfmpeg)
					#print commande
					self.log.append(commande+'\n\n')
					# mode de canal: on fusionne le canal de sortie normal 
					# (stdout) et celui des erreurs (stderr)
					if PYQT_VERSION_STR >= "4.1.0":
						self.ffmpegProcess.setProcessChannelMode(QProcess.MergedChannels)
					self.ffmpegProcess.start(commande)
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.ffmpegProcess.waitForStarted(3000):
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec ffmpeg"))
					
			elif encodeur == 'MPlayer Conversion':
				
				if self.idCodec=='extractionaudio':
					commande = self.commandeMplayerSeparation(self.cheminVideoEntre, self.cheminSorti, self.cheminMPlayer)
					#print commande
					self.log.append(commande+'\n\n')
					# mode de canal: on fusionne le canal de sortie normal 
					# (stdout) et celui des erreurs (stderr)
					if PYQT_VERSION_STR >= "4.1.0":
						self.mplayerProcess.setProcessChannelMode(QProcess.MergedChannels)
					self.mplayerProcess.start(commande)
					
					# au cas où mplayer ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mplayerProcess.waitForStarted(3000):
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de l'extraction audio avec mplayer"))
				
				elif self.idCodec=='jpeg': # convertir animation en images
					commande = self.commandeMplayerConvAnimImg(self.cheminVideoEntre, self.cheminSorti, self.cheminMPlayer)
					#print commande
					self.log.append(commande+'\n\n')
					#os.system(commande)
					if PYQT_VERSION_STR >= "4.1.0":
						self.mplayerProcess.setProcessChannelMode(QProcess.MergedChannels)
					self.mplayerProcess.start(commande)
					
					# au cas où mplayer ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mplayerProcess.waitForStarted(3000):
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion animation en images avec mplayer"))
				
				elif self.idCodec=='encodage_wav': # encodage de fichiers audio en wav
					commande = self.commandeMplayerEncodageWav(self.cheminVideoEntre, self.cheminSorti, self.cheminMPlayer)
					#print commande
					self.log.append(commande+'\n\n')
					if PYQT_VERSION_STR >= "4.1.0":
						self.mplayerProcess.setProcessChannelMode(QProcess.MergedChannels)
					self.mplayerProcess.start(commande)
					
					# au cas où mplayer ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mplayerProcess.waitForStarted(3000):
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de l'encodage de fichiers audio en wav"))
			
			else: # MEncoder
				
				if self.idCodec in ['copie', 'avirawsanscompression', 'codecdivx4', 'codecmotionjpeg', 'codecmpeg1', 'codecmpeg2', 'codecwmv2', 'codecxvid', 'macromediaflashvideo', 'codech264mpeg4']:
					
					# mode de canal: on fusionne le canal de sortie normal 
					# (stdout) et celui des erreurs (stderr)
					if PYQT_VERSION_STR >= "4.1.0":
						self.mencoderProcess.setProcessChannelMode(QProcess.MergedChannels)
				
					commande = self.commandeMencoderEncodage(self.idCodec, self.cheminVideoEntre, self.cheminSorti, self.valeurNum, self.cheminMEncoder)
					#print commande
					self.log.append(commande+'\n\n')
					self.mencoderProcess.start(commande)
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mencoderProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec mencoder")) ##
				
				elif self.idCodec in ['niveaudegris', 'placesoustitres', 'luminositecontraste','decoupageassiste', 'decoupagelibre', 'couleursaturationhue', 'miroir', 'flouboitebloxblur', 'changement_resolution'] or self.idCodec[0]== 'bruit':
					
					print "self.idCodec de mencoder", self.idCodec
					
					# mode de canal: on fusionne le canal de sortie normal 
					# (stdout) et celui des erreurs (stderr)
					if PYQT_VERSION_STR >= "4.1.0":
						self.mencoderProcess.setProcessChannelMode(QProcess.MergedChannels)
					commande = self.commandeMencoderFiltresVideo1(self.idCodec, self.cheminVideoEntre, self.cheminSorti, self.valeurNum, self.cheminMEncoder, self.tempsApercu)
					#print commande
					self.log.append(commande+'\n\n')
					self.mencoderProcess.start(commande)
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mencoderProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec mencoder")) ##
				
				elif self.idCodec == "extractionvideo":
					commande = self.commandeMencoderSeparation(self.cheminVideoEntre, self.cheminSorti, self.cheminMEncoder)
					#print commande
					self.log.append(commande+'\n\n')
					# mode de canal: on fusionne le canal de sortie normal 
					# (stdout) et celui des erreurs (stderr)
					if PYQT_VERSION_STR >= "4.1.0":
						self.mencoderProcess.setProcessChannelMode(QProcess.MergedChannels)
					self.mencoderProcess.start(commande)
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mencoderProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec mencoder")) ##

				elif self.idCodec=='fusion_video': # Collage de vidéos
					commande = self.commandeMencoderMontageVideo(self.cheminVideoEntre, self.cheminSorti, self.cheminMEncoder)
					#print commande
					self.log.append(commande+'\n\n')
					if PYQT_VERSION_STR >= "4.1.0":
						self.mencoderProcess.setProcessChannelMode(QProcess.MergedChannels)
					self.mencoderProcess.start(commande)
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mencoderProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec mencoder")) ##
				
				# Collage de vidéos et d'audios (1)
				elif self.idCodec in ['fusion_audio_et_video_1', 'fusion_audio_et_video_2']:
					cheminVideoEntre, cheminAudioEntre = self.cheminVideoEntre # tuple
					commande = self.commandeMencoderMontageVideoetAudio(self.idCodec, cheminVideoEntre, cheminAudioEntre, self.cheminSorti, self.cheminMEncoder)
					#print commande
					self.log.append(commande+'\n\n')
					if PYQT_VERSION_STR >= "4.1.0":
						self.mencoderProcess.setProcessChannelMode(QProcess.MergedChannels)
					self.mencoderProcess.start(commande)
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mencoderProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec mencoder")) ##
				
				elif self.idCodec == "decoupervideo":
					if not self.optionSpeciale:
						optionSpeciale = "-nosound"
					else: optionSpeciale = ""
					commande = self.commandeMencoderMontageDecouperVideo(self.cheminVideoEntre, self.cheminSorti, self.valeurNum, optionSpeciale, self.cheminMEncoder)
					#print commande
					self.log.append(commande+'\n\n')
					if PYQT_VERSION_STR >= "4.1.0":
						self.mencoderProcess.setProcessChannelMode(QProcess.MergedChannels)
					self.mencoderProcess.start(commande)
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mencoderProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec mencoder")) ##
						
				elif self.idCodec=='conv_en_16_9_ou_4_3': # Convertir vidéo en 16/9 ou 4/3
					commande = self.commandeMencoderConv_16_9_ou_4_3(self.cheminVideoEntre, self.cheminSorti, self.valeurNum, self.cheminMEncoder) ##
					#print commande
					self.log.append(commande+'\n\n') ##
					if PYQT_VERSION_STR >= "4.1.0": ##
						self.mencoderProcess.setProcessChannelMode(QProcess.MergedChannels) ##
					self.mencoderProcess.start(commande) ##
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mencoderProcess.waitForStarted(3000): ##
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec mencoder")) ##
						
				elif self.idCodec in ['youtube_16/9_HQ', 'youtube_16/9_MQ', 'youtube_16/9_LQ', 'youtube_4/3_HQ', 'youtube_4/3_MQ', 'youtube_4/3_LQ', 'google_video_16/9_HQ', 'google_video_16/9_MQ', 'google_video_16/9_LQ', 'google_video_4/3_HQ', 'google_video_4/3_MQ', 'google_video_4/3_LQ']:
					commande = self.commandeMencoderConvWeb(self.idCodec, self.cheminVideoEntre, self.cheminSorti, self.cheminMEncoder)
					#print commande
					self.log.append(commande+'\n\n')
					if PYQT_VERSION_STR >= "4.1.0":
						self.mencoderProcess.setProcessChannelMode(QProcess.MergedChannels)
					self.mencoderProcess.start(commande)
					
					# au cas où mencoder ne démarrerait pas au bout 
					# de 3 sec (ex. problème de codec)
					if not self.mencoderProcess.waitForStarted(3000):
						QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec mencoder pour le web"))
						
				'''
				# au cas où mencoder ne démarrerait pas au bout 
				# de 3 sec (ex. problème de codec)
				if not self.mencoderProcess.waitForStarted(3000):
					QMessageBox.critical(self, _(u"Avertissement"), _(u"Bogue au lancement de la conversion avec mencoder"))
				'''
			self.estLancee = True


	def recupSortieMencoder(self):
		"""récupère les lignes d'information émises par QProcess et en tire les conséquences"""
		
		# stocke l'ensemble des bits d'une ligne
		# readline: lit une ligne ascii à partir du système
		tampon=QByteArray(self.mencoderProcess.readLine()) 
		
		# on récupère les lignes de mencoder
		if '\n' in tampon: 
			# informations mencoder
			print tampon 
			self.log.append(tampon)
		
		#print "tampon_mencoder :",tampon
		
		# On vérifie si on a eu des réponses sur la progression de mencoder -> affichage
		# retourne True si l'ensemble de bits démarre avec "..."
		if tampon.startsWith("Pos:"):
			# chaîne de caractères du %
			ch=''
			# quand drapeau=1, on entre dans la parenthèse contenant le %
			drapeau=0
			for i in tampon:
				if i =='(':
					drapeau=1
				elif drapeau==1:
					if i =='%':
						break
					elif i == ' ':
						pass
					else:
						ch=ch+i
			pourCent = int(ch)
			
			if self.idCodec=="decoupervideo":
				if not self.__recupPourcentDebut:
					# on obtient la position (en %) du début de l'extraction
					self.pourcentageDepart_decoupervideo = pourCent
				# Position de la partie de la vidéo en train d'être extraite
				# Le résultat est donné en % par rapport à la durée totale de la vidéo
				# Il ne s'agit donc pas du % de progression de l'encodage
				pourCentCourant = pourCent
				pourCentFinal = (self.pourcentageDepart_decoupervideo*(int(float(self.valeurNum[0]))+int(float(self.valeurNum[1]))))/float(self.valeurNum[0])
				ecart = pourCentCourant - self.pourcentageDepart_decoupervideo
				if ecart < 0:
					ecart = pourCentFinal - self.pourcentageDepart_decoupervideo
				pourCent = int((ecart/float(pourCentFinal - self.pourcentageDepart_decoupervideo))*100)
				self.__recupPourcentDebut = 1
			
			# affichage du % dans la barre de progression de mencoder
			if pourCent >= 100: pourCent = 99
			self.pbar.setValue(pourCent)
	
	
	def recupSortieFfmpeg2theora(self):
		"""récupère les lignes d'information émises par QProcess et en tire les conséquences"""
		
		# stocke l'ensemble des bits d'une ligne
		# readline: lit une ligne ascii à partir du système
		tampon=QByteArray(self.ffmpeg2theoraProcess.readLine())
		
		if '\r' in tampon:
			# En fait le début est comme ceci : \r      0:...
			tampon.replace(QByteArray("\r"), QByteArray(""))
			# Tampon 2 (tampon est transformé en string) et les espaces 
			# disgracieux en début de chaîne sont supprimés . Sert pour
			# le calcul des heures, minutes, secondes
			tampon_2=unicode(QString(tampon)).strip()
			# Calcul des heures, minutes, secondes
			tamponHeures, tamponMinutes, tamponScondes = float(tampon_2[0]), float(tampon_2[2:4]), float(tampon_2[5:9])
			# Temps total écoulé en secondes
			tamponTotalSecondes=(tamponHeures*3600)+(tamponMinutes*60)+tamponScondes
			# Calcul du pourcentage écoulé 
			pourCent=int((tamponTotalSecondes*100)/float(self.dureeTotaleVideo))
			# affichage du % dans la barre de progression
			self.pbar.setValue(pourCent)
			
		# N'affiche que les informations nécessaires (pas le temps passé
		# par le process --> qui est ici évidemment complètement inutile)
		else :
			self.log.append(tampon)
			print tampon
			
			
	def recupSortieFfmpeg(self): ##
		"""récupère les lignes d'information émises par QProcess et en tire les conséquences
                Utlisation de la méthode classique pour l'"encodage wav" et le changement de framerate"""
		
                if self.idCodec in ['codec_dv_ffmpeg', 'codec_mov_ffmpeg', 'codec_hfyu_ffmpeg', 'codec_vob_ffmpeg', 'codec_AMV_ffmpeg', 'codec_3GP_ffmpeg', 'idx', 'mpeg1video', 'mjpeg', 'h263p', 'mpeg4', 'msmpeg4v2', 'ljpeg', 'dv', 'huffyuv', 'mov', 'flv', 'mp4', 'vob', 'hd_1920x1080_mov__pcm_s16be__16/9', 'hd_1280x720_mov__pcm_s16be__16/9', 'hd_1440x1080_mov__pcm_s16be__4/3']:
			
			#################### Ajouté le 30/12/08 ###################################################
			self.pbar.setValue(10)
			###########################################################################################
		
                        # stocke l'ensemble des bits d'une ligne
                        # readline: lit une ligne ascii à partir du système
                        tampon=QByteArray(self.ffmpegProcess.readLine())
                
                        # N'affiche que les parties importantes ...
                        if 'size' in tampon:
                                pass
                        else:
                                print tampon
                                self.log.append(tampon)

                        if '\r' in tampon:
                                tampon_2=str(tampon).split(' ')
                                for vb in tampon_2:
                                        if 'time' in vb:
                                                tempsEcoule=vb[5:8]
                                                # Calcul du pourcentage écoulé
                                                pourCent=int((float(tempsEcoule)*100)/self.dureeTotaleVideo)
                                                # affichage du % dans la barre de progression
                                                self.pbar.setValue(pourCent)

	
	def recupSortieMplayer(self):
		"""récupère les lignes d'information émises par QProcess et en tire les conséquences"""
		
		# stocke l'ensemble des bits d'une ligne
		# readline: lit une ligne ascii à partir du système
		tampon=QByteArray(self.mplayerProcess.readLine())
		
		#print "TAMPON MPLAYER :", tampon
		
		# on récupère le temps de la vidéo
		if '\r' in tampon:
			# En fait le début est comme ceci : \r      0:...
			tampon.replace(QByteArray("\r"), QByteArray(""))
			# tampon est transformé en string
			tampon = unicode(tampon)
			tampon = tampon.split(' ')
			tampon2 = tampon
			for i in tampon:
				if i=='':
					tampon2.remove('')
			tpsCourant = float(tampon2[1])
			
			# Calcul du pourcentage
			pourCent=int(tpsCourant/float(self.dureeTotaleVideo)*100)
			
			# affichage du % dans la barre de progression
			self.pbar.setValue(pourCent)
		
		# N'affiche que les informations nécessaires (pas le temps passé
		# par le process --> qui est ici évidemment complètement inutile)
		else :
			self.log.append(tampon)
			print tampon
	
	
	def finEncodage(self, statutDeSortie):
		"""choses à faire à la fin de l'encodage de la vidéo"""

		if statutDeSortie==1:
			
			print "Crash de l'encodeur!"
			self.log.append("-------------------------\n Crash de l'encodeur!\n---------------------")
			#################### Ajouté le 30/12/08 ###################################################
			self.labelAttente.hide()
			###########################################################################################
			self.pbar.setValue(0)
			self.bout_annuler.setText(_(u"Fermer"))
			self.bout_preZoneTexte.setText(_(u'Problème! Voir les informations'))
			self.bout_preZoneTexte.show()
			return
			
		# fermer la fenêtre à la fin de l'encodage
		elif not self.laisserOuvert:
			self.close()

		print "fini!"
		#################### Ajouté le 30/12/08 ###################################################
		self.labelAttente.hide()
		###########################################################################################
		self.pbar.setValue(100)
		# l'encodage est fini. Il ne peut plus être annulé. La  
		# seule action possible devient ainsi la fermeture
		self.bout_annuler.setText(_(u"Fermer"))
		self.bout_preZoneTexte.show()
	
	
	def afficherLog(self):
		"""afficher les information de la vidéo de départ et de l'encodage"""
		texte =  QByteArray("#######\n# LOG :\n#######\n")
		for ligne in self.log:
			texte = texte + ligne # ligne est de type ByteArray
		
		self.zoneTexte.setText(texte)
		self.zoneTexte.show()
		self.resize(500, 300)
	
	
	def commandeMencoderEncodage(self, idCodec, cheminVideoEntre, cheminVideoSorti, valeurNum, cheminMEncoder):
		"""renvoie la commande d'encodage à exécuter"""
		
		if idCodec=='copie':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -ovc copy -oac pcm -o '+"\""+cheminVideoSorti+"\""
		
		elif idCodec=='avirawsanscompression':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -ovc raw -vf format=i420 -oac pcm -o '+"\""+cheminVideoSorti+"\""
		
		elif idCodec=='codecdivx4':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -ovc lavc -lavcopts vcodec=mpeg4:vqmin='+valeurNum+':vpass=1 -oac pcm -o '+"\""+cheminVideoSorti+"\""
		
		elif idCodec=='codecmotionjpeg':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -ovc lavc -lavcopts vcodec=mjpeg:vqmin='+valeurNum+':vpass=1 -oac pcm -o '+"\""+cheminVideoSorti+"\""
		
		elif idCodec=='codecmpeg1':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -ovc lavc -lavcopts vcodec=mpeg1video:vqmin='+valeurNum+':vpass=1 -oac pcm -o '+"\""+cheminVideoSorti+"\""
		
		elif idCodec=='codecmpeg2':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -ovc lavc -lavcopts vcodec=mpeg2video:vqmin='+valeurNum+':vpass=1 -oac pcm -o '+"\""+cheminVideoSorti+"\""
		
		elif idCodec=='codecwmv2':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -ovc lavc -lavcopts vcodec=wmv2:vqmin='+valeurNum+':vpass=1 -oac pcm -o '+"\""+cheminVideoSorti+"\""
		
		elif idCodec=='codecxvid':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -ovc lavc -ffourcc xvid -oac pcm -o '+"\""+cheminVideoSorti+"\""
			
		elif idCodec=='macromediaflashvideo':
			commande=cheminMEncoder+' -oac pcm -ffourcc FLV1 -ovc lavc -lavcopts vcodec=flv:vbitrate='+valeurNum+' '+"\""+cheminVideoEntre+"\""+' -o '+"\""+cheminVideoSorti+"\""
		
		elif idCodec=='codech264mpeg4':
			# AVANT:
			#commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac copy -of lavf -lavfopts format=mp4:i_certify_that_my_video_stream_does_not_use_b_frames -ovc x264 -o '+"\""+cheminVideoSorti+"\""
			
			# APRES: supression du bug d'encodage si fichier avec canal audio ...
			 
			# commande pour subprocess (prise de renseignements faits par ffmpeg)
			com_h264mpeg4='ffmpeg -i '+"\""+cheminVideoEntre+"\"" ##

                	# Travail avec subprocess 
                	p=subprocess.Popen(com_h264mpeg4, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, shell=True) ##
                	lignesSortiepH264mpeg4=p.stdout.readlines() ##
                	p.wait() ##
		
			# Séparation des parties avec un espace pour une meilleure récupération
                	lH264mpeg4_ffmpeg="".join(lignesSortiepH264mpeg4).split(' ') ##
		
			# Liste remplie par les données ffmpeg
			llH264mpeg4_1=[] ##
			for lignesH264mpeg4_1 in lH264mpeg4_ffmpeg: ##
				llH264mpeg4_1.append(lignesH264mpeg4_1) ##
			# Si pas canal audio ...
			if 'Audio:' not in llH264mpeg4_1: ##
				commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -of lavf -lavfopts format=mp4 -ovc x264 -x264encopts bitrate=1200 -o '+"\""+cheminVideoSorti+"\"" ##
		
			# Repérage des lignes comportant un canal audio
			for lignesH264mpeg4_2 in lH264mpeg4_ffmpeg: ##
				if 'Audio:' in lignesH264mpeg4_2: ##
					commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac faac -faacopts mpeg=4:raw:br=128 -of lavf -lavfopts format=mp4 -ovc x264 -x264encopts bitrate=1200 -o '+"\""+cheminVideoSorti+"\"" ##
		
		return commande
	
	
	def commandeMencoderConvWeb(self, idCodec, cheminVideoEntre, cheminVideoSorti, cheminMEncoder):
	
		# Encodage YouTube 16/9 Haute Qualité
		if idCodec=='youtube_16/9_HQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=256 -ffourcc xvid -ovc lavc -lavcopts vbitrate=3000 -vf scale=512:288 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage YouTube 16/9 Moyenne Qualité
		elif idCodec=='youtube_16/9_MQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=128 -ffourcc xvid -ovc lavc -lavcopts vbitrate=1000 -vf scale=512:288 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage YouTube 16/9 Basse qualité
		elif idCodec=='youtube_16/9_LQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=128 -ffourcc xvid -ovc lavc -lavcopts vbitrate=564 -vf scale=512:288 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage YouTube 4/3 Haute Qualité
		elif idCodec=='youtube_4/3_HQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=256 -ffourcc xvid -ovc lavc -lavcopts vbitrate=3000 -vf scale=482:361 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage YouTube 4/3 Moyenne Qualité
		elif idCodec=='youtube_4/3_MQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=128 -ffourcc xvid -ovc lavc -lavcopts vbitrate=1000 -vf scale=482:361 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage YouTube 4/3 Basse qualité	
		elif idCodec=='youtube_4/3_LQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=128 -ffourcc xvid -ovc lavc -lavcopts vbitrate=564 -vf scale=482:361 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage Google Video 16/9 Haute Qualité
		elif idCodec=='google_video_16/9_HQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=256 -ffourcc xvid -ovc lavc -lavcopts vbitrate=3000 -vf scale=872:520 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage Google Video 16/9 Moyenne Qualité
		elif idCodec=='google_video_16/9_MQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=128 -ffourcc xvid -ovc lavc -lavcopts vbitrate=1000 -vf scale=872:520 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage Google Video 16/9 Basse qualité
		elif idCodec=='google_video_16/9_LQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=128 -ffourcc xvid -ovc lavc -lavcopts vbitrate=564 -vf scale=872:520 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage Google Video 4/3 Haute Qualité
		elif idCodec=='google_video_4/3_HQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=256 -ffourcc xvid -ovc lavc -lavcopts vbitrate=3000 -vf scale=694:520 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage Google Video 4/3 Moyenne Qualité
		elif idCodec=='google_video_4/3_MQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=128 -ffourcc xvid -ovc lavc -lavcopts vbitrate=1000 -vf scale=694:520 -o '+"\""+cheminVideoSorti+"\""
			
		# Encodage Google Video 4/3 Basse qualité	
		elif idCodec=='google_video_4/3_LQ':
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -oac mp3lame -lameopts cbr=128 -ffourcc xvid -ovc lavc -lavcopts vbitrate=564 -vf scale=694:520 -o '+"\""+cheminVideoSorti+"\""
			
		return commande
		
		
	def commandeFfmpegConvHD(self, idCodec, cheminVideoEntre, cheminVideoSorti, cheminFfmpeg):
		""
		if idCodec=='hd_1920x1080_mov__pcm_s16be__16/9':
			commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -vcodec mpeg4 -b 6000k -deinterlace -s 1920x1080 -aspect 16:9 -acodec pcm_s16be -y '+"\""+cheminVideoSorti+"\""
		
		elif idCodec=='hd_1280x720_mov__pcm_s16be__16/9':
			commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -vcodec mpeg4 -b 6000k -deinterlace -s 1280x720 -aspect 16:9 -acodec pcm_s16be -y '+"\""+cheminVideoSorti+"\""
			
		elif idCodec=='hd_1440x1080_mov__pcm_s16be__4/3':
			commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -vcodec mpeg4 -b 6000k -deinterlace -s 1440x1080 -aspect 4:3 -acodec pcm_s16be -y '+"\""+cheminVideoSorti+"\""
			
		return commande
		
	
	def commandeFfmpeg2theora(self, idCodec, cheminVideoEntre, cheminVideoSorti, valeurNum, cheminFfmpeg2theora):
		if idCodec=='codecoggtheora':
			commande=cheminFfmpeg2theora+' '+"\""+cheminVideoEntre+"\""+' -v '+valeurNum+' -o '+"\""+cheminVideoSorti+"\""
		
		return commande
	
	
	def commandeMencoderFiltresVideo1(self, idCodec, cheminVideoEntre, cheminVideoSorti,
				valeurNum, cheminMEncoder, tempsApercu):
		"""renvoie la commande d'encodage à exécuter"""
		
		# valeurNum est toujours un tuple de taille 2 dans cette fonction
		
		if idCodec=='niveaudegris':
			commande = cheminMEncoder+' -ovc lavc -lavcopts gray -oac pcm -o '+"\""+cheminVideoSorti+"\""+' '+"\""+cheminVideoEntre+"\""
		
		elif idCodec=='placesoustitres':
			commande = cheminMEncoder+' -ovc lavc -vf expand=0:-50:0:0 -oac pcm -o '+"\""+cheminVideoSorti+"\""+' '+"\""+cheminVideoEntre+"\""
		
		elif idCodec[0]=='bruit':
			# idLuma ou idChroma = "u" ("bruituniforme")
			# idLuma ou idChroma = "t" ("bruittemporel")
			# idLuma ou idChroma = "a" ("bruittemporelm")
			# idLuma ou idChroma = "h" ("hautequalite")
			# idLuma ou idChroma = "p" ("mixedubruit")
			idLuma, idChroma = idCodec[1], idCodec[2]
			
			commande = cheminMEncoder+' -ovc lavc -vf noise='+idLuma+'['+valeurNum[0]+']:'+idChroma+'['+valeurNum[1]+']'+' -oac pcm -o '+"\""+cheminVideoSorti+"\""+' '+"\""+cheminVideoEntre+"\""
		
		elif idCodec=='luminositecontraste':
			commande = cheminMEncoder+' -ovc lavc -vf eq='+valeurNum[0]+':'+valeurNum[1]+' -oac pcm -o '+"\""+cheminVideoSorti+"\""+' '+"\""+cheminVideoEntre+"\""
		
		elif idCodec=='decoupageassiste' or idCodec=='decoupagelibre':
			commande = cheminMEncoder+' -ovc lavc -vf crop='+valeurNum[0]+':'+valeurNum[1]+':'+valeurNum[2]+':'+valeurNum[3]+' -oac pcm -o '+"\""+cheminVideoSorti+"\""+' '+"\""+cheminVideoEntre+"\""
		
		elif idCodec=='couleursaturationhue':
			commande = cheminMEncoder+' -ovc lavc -vf hue='+valeurNum[0]+':'+valeurNum[1]+' -oac pcm -o '+"\""+cheminVideoSorti+"\""+' '+"\""+cheminVideoEntre+"\""
		
		elif idCodec=='miroir':
			commande = cheminMEncoder+' -ovc lavc -vf mirror -oac pcm -o '+"\""+cheminVideoSorti+"\""+' '+"\""+cheminVideoEntre+"\""
		
		elif idCodec=='flouboitebloxblur':
			commande = cheminMEncoder+' -ovc lavc -vf boxblur='+valeurNum[0]+':'+valeurNum[1]+' -oac pcm -o '+"\""+cheminVideoSorti+"\""+' '+"\""+cheminVideoEntre+"\""
			
		elif idCodec=='changement_resolution':
			
			# Si on décide d'appliquer le filtre sans avoir un aperçu (bouton Aperçu)
			if not tempsApercu:

				reponse = QMessageBox.information(self, 'Message',
				_(u"<p>Vous avez décidé de changer la résolution de cette vidéo, sachez avant tout que la vidéo en question sera (en même temps qu'elle est redimensionnée) encodée en <b><font color='red'>Motion JPEG (extension .avi)</font></b>.</p><p>Vous pouvez (si vous le désirez) <b>vous approcher d'une résolution en 16/9ème</b>, pour ce faire vous devez faire un petit calcul ...</p><p>* pour obtenir la valeur de la hauteur comparativement à la valeur de la largeur, vous devez <b>diviser la valeur de la largeur par 1.777</b>, par exemple si votre vidéo de départ est en 640x480, le calcul à faire sera le suivant:</p><p>640 / 1.777, cela vous donnera (à la virgule près) 360.15756893640969, vous devrez enlever les chiffres après la virgule. Pour conclure, votre vidéo fera à l'arrivée 640x360, vous pourrez donc régler <b>Nouvelle largeur</b> à 640 et <b>Nouvelle hauteur</b> à 360.</p><p><b>Si vous décidez de faire les réglages pour obtenir une vidéo en 16/9ème, répondez non</b> à la question qui vous sera posée (pour ainsi pouvoir refaire les réglages), <b>si vous décidez de changer la résolution tout de suite (et avec les valeurs que vous venez de définir), répondez oui</b>.</p><p><b>Voulez-vous changer la résolution tout de suite ?.</b></p>"), QMessageBox.Yes, QMessageBox.No)
				if reponse == QMessageBox.No:
					return
			
			commande=cheminMEncoder+' '+"\""+cheminVideoEntre+"\""+' -vf scale='+valeurNum[0]+':'+valeurNum[1]+' -ovc lavc -lavcopts vcodec=mjpeg:vqmin=1:vpass=1 -oac pcm -o '+"\""+cheminVideoSorti+"\""
		
		# On veut juste encoder une portion de la vidéo pour avoir un aperçu
		if tempsApercu:
			commande = commande.replace(cheminMEncoder, cheminMEncoder+" -ss "+ tempsApercu +" -frames 2", 1)
		
		return commande
		
	
	def commandeMencoderSeparation(self, cheminVideoEntre, cheminVideoSorti, cheminMEncoder):
		""
		commande = cheminMEncoder+" -ovc lavc -nosound "+"\""+cheminVideoEntre+"\""+" -o "+"\""+cheminVideoSorti+"\""
		
		return commande
	
	
	def commandeMplayerSeparation(self, cheminVideoEntre, cheminAudioSorti, cheminMPlayer):
		""
		commande = cheminMPlayer+" -ao pcm:waveheader:file="+"\""+cheminAudioSorti+"\""+" -vo null -vc null "+"\""+cheminVideoEntre+"\""
		
		return commande
	
	
	def commandeMplayerEncodageWav(self, cheminVideoEntre, cheminAudioSorti, cheminMPlayer):
		""
		commande = cheminMPlayer+' '+"\""+cheminVideoEntre+"\""+' -ao pcm:waveheader:file='+"\""+cheminAudioSorti+'.wav'+"\""
		
		return commande
	

	def commandeFfmpegNbrImgSec(self, cheminVideoSource, cheminVideoSorti, valeurNum, cheminFfmpeg):
                ""
                commande = cheminFfmpeg+' -r '+valeurNum+' -i '+"\""+cheminVideoSource+"\""+' -r '+valeurNum+' -vsync 1 -b 800000 -y '+"\""+cheminVideoSorti+"\""

                return commande
	

	def commandeMencoderConv_16_9_ou_4_3(self, cheminVideoSource, cheminVideoSorti, valeurNum, cheminMEncoder): ##
		""
		commande = cheminMEncoder+' -ovc copy -oac pcm -force-avi-aspect '+str(valeurNum)+' '+"\""+cheminVideoSource+"\""+' -o '+"\""+cheminVideoSorti+"\"" ##
		
		return commande ##
	
	
	def commandeMplayerConvAnimImg(self, cheminVideoSource, cheminRepDestination, cheminMPlayer):
		""
		commande = cheminMPlayer+" \""+cheminVideoSource+"\" -vo jpeg:outdir=\""+cheminRepDestination+"\":quality=100"
		
		return commande
	
	
	def commandeMencoderMontageVideo(self, cheminVideoEntre, cheminVideoSorti, cheminMEncoder):
		commande = cheminMEncoder+" -noidx -oac pcm -ovc copy -o" + " \"" + cheminVideoSorti + "\" " + cheminVideoEntre
		
		return commande
	
	
	def commandeMencoderMontageVideoetAudio(self, idCodec, cheminVideoEntre, cheminAudioEntre, cheminVideoSorti, cheminMEncoder):
		if idCodec=='fusion_audio_et_video_1':
			commande = cheminMEncoder + " -noidx -audiofile " + cheminAudioEntre + " -oac lavc -lavcopts acodec=ac3 -stereo 0 -ovc copy -o " + "\"" + cheminVideoSorti + "\" " + cheminVideoEntre
		elif idCodec=='fusion_audio_et_video_2':
			commande = cheminMEncoder + " -noidx -audiofile " + cheminAudioEntre + " -oac pcm -stereo 0 -ovc copy -o " + "\"" + cheminVideoSorti + "\" " + cheminVideoEntre
		
		return commande
	
	
	def commandeMencoderMontageDecouperVideo(self, cheminVideoEntre, cheminVideoSorti, valeurNum, nosound, cheminMEncoder):
		# La non-prise en compte du son est en option
		commande = cheminMEncoder+' -ss '+valeurNum[0]+' -endpos '+valeurNum[1]+' '+"\""+cheminVideoEntre+"\" -o "+"\""+cheminVideoSorti+"\" -oac pcm -ovc copy "+nosound
		
		return commande
	
	
	def commandeFfmpegEncodageDv(self, cheminVideoEntre, cheminSorti, cheminFfmpeg): ##
		""
		commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -f dv -target pal-dv -y '+"\""+cheminSorti+"\"" ##
		
		return commande ##
	
	
	def commandeFfmpegEncodageMov(self, cheminVideoEntre, cheminSorti, cheminFfmpeg): ##
		""
		commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -f mov -sameq -acodec pcm_s16be -y '+"\""+cheminSorti+"\"" ##
		
		return commande ##
	
	
	def commandeFfmpegEncodageHfyu(self, cheminVideoEntre, cheminSorti, cheminFfmpeg): ##
		""
		# commande pour subprocess
		comHfyu=cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\"" ##

                # Travail avec subprocess 
                p=subprocess.Popen(comHfyu, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, shell=True) ##
                lignesSortiepHfyu=p.stdout.readlines() ##
                p.wait() ##
		
		# Séparation des parties avec un espace pour une meilleure récupération
                lHfyu_ffmpeg="".join(lignesSortiepHfyu).split(' ') ##
		
		# Liste remplie par les données ffmpeg
		llHfyu_1=[] ##
		for lignesHfyu_1 in lHfyu_ffmpeg: ##
			llHfyu_1.append(lignesHfyu_1) ##
		# Si pas canal audio ...
		if 'Audio:' not in llHfyu_1: ##
			commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -vcodec huffyuv -pix_fmt yuv422p -sameq -y '+"\""+cheminSorti+"\"" ##
			return commande ##
		
		# Repérage des lignes comportant un canal audio
		for lignesHfyu_2 in lHfyu_ffmpeg: ##
			if 'Audio:' in lignesHfyu_2: ##
				commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -vcodec huffyuv -pix_fmt yuv422p -sameq -acodec pcm_s16le -y '+"\""+cheminSorti+"\"" ##
				return commande ##
	
	
	def commandeFfmpegEncodageVob(self, cheminVideoEntre, cheminSorti, cheminFfmpeg): ##
		""
		commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -sameq -y '+"\""+cheminSorti+"\"" ##
		
		return commande ##
	
	
	def commandeFfmpegEncodageAMV(self, cheminVideoEntre, cheminSorti, cheminFfmpeg): ##
		""
		commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -s 160x120 -ac 1 -ar 22050 -qmin 3 -qmax 3 -y '+"\""+cheminSorti+"\"" ##
		
		return commande ##
		
		# La commande:
		#ffmpeg -i entree.avi -s 160x120 -ac 1 -ar 22050 -qmin 3 -qmax 3 sortie.avi
	
	
	def commandeFfmpegEncodage3gp(self, cheminVideoEntre, cheminSorti, cheminFfmpeg): ##
		""
		# commande pour subprocess
		com3gp=cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\"" ##

                # Travail avec subprocess 
                p=subprocess.Popen(com3gp, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, shell=True) ##
                lignesSortiep3gp=p.stdout.readlines() ##
                p.wait() ##
		
		# Séparation des parties avec un espace pour une meilleure récupération
                l3gp_ffmpeg="".join(lignesSortiep3gp).split(' ') ##
		
		# Liste remplie par les données ffmpeg
		ll3gp_1=[] ##
		for lignes3gp_1 in l3gp_ffmpeg: ##
			ll3gp_1.append(lignes3gp_1) ##
		# Si pas canal audio ...
		if 'Audio:' not in ll3gp_1: ##
			commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -f 3gp -sameq -s qcif -y '+"\""+cheminSorti+"\"" ##
			return commande ##
		
		# Repérage des lignes comportant un canal audio
		for lignes3gp_2 in l3gp_ffmpeg: ##
			if 'Audio:' in lignes3gp_2: ##
				commande = cheminFfmpeg+' -i '+"\""+cheminVideoEntre+"\""+' -f 3gp -sameq -acodec pcm_s16be -s qcif -y '+"\""+cheminSorti+"\"" ##
				return commande ##


	def commandeFfmpegConvertImg(self, idCombo, cheminVideoEntre, cheminVideoSorti, valeurNum, tailleIm, cheminFfmpeg): 
		'''Conversion d'images en vidéo. Un grand merci à Ptah d'avoir trouvé le moyen de pouvoir encoder
		avec le nombre d'images/sec sans encombre. Voir ici: http://ekd.tuxfamily.org/forum/showthread.php?tid=52'''
		
		if idCombo=='vob': 
			commande = cheminFfmpeg+' -f image2 -i '+"\""+cheminVideoEntre+"\""+' -qscale 1 -y '+"\""+cheminVideoSorti+"\"" 
		
		elif idCombo=='dv':
			commande = cheminFfmpeg+' -f image2 -i '+"\""+cheminVideoEntre+"\""+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -f dv -target pal-dv -y '+"\""+cheminVideoSorti+"\"" ##
			
		elif idCombo=='huffyuv':
			'''
			######## Retiré le 19/04/09 ###############################################################
			commande = cheminFfmpeg+' -f image2 -i '+"\""+cheminVideoEntre+"\""+' -r '+valeurNum+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -vcodec huffyuv -pix_fmt yuv422p -y '+"\""+cheminVideoSorti+"\""
			###########################################################################################
			'''
			####### Changé le 19/04/09 ################################################################
			commande = cheminFfmpeg+' -r '+valeurNum+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -i '+"\""+cheminVideoEntre+"\""+' -vcodec huffyuv -pix_fmt yuv422p -y '+"\""+cheminVideoSorti+"\""
			###########################################################################################
			
		elif idCombo=='mov':
			'''
			######## Retiré le 19/04/09 ###############################################################
			commande = cheminFfmpeg+' -f image2 -i '+"\""+cheminVideoEntre+"\""+' -r '+valeurNum+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -f mov -qscale 1 -y '+"\""+cheminVideoSorti+"\""
			###########################################################################################
			'''
			####### Changé le 19/04/09 ################################################################
			commande = cheminFfmpeg+' -r '+valeurNum+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -i '+"\""+cheminVideoEntre+"\""+' -f mov -qscale 1 -y '+"\""+cheminVideoSorti+"\""
			###########################################################################################
			
		elif idCombo=='flv':
			'''
			######## Retiré le 19/04/09 ###############################################################
			commande = cheminFfmpeg+' -f image2 -i '+"\""+cheminVideoEntre+"\""+' -r '+valeurNum+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -f flv -qscale 1 -y '+"\""+cheminVideoSorti+"\""
			###########################################################################################
			'''
			####### Changé le 19/04/09 ################################################################
			commande = cheminFfmpeg+' -r '+valeurNum+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -i '+"\""+cheminVideoEntre+"\""+' -f flv -qscale 1 -y '+"\""+cheminVideoSorti+"\""
			###########################################################################################
			
		elif idCombo=='mp4':
			'''
			######## Retiré le 19/04/09 ###############################################################
			commande = cheminFfmpeg+' -f image2 -i '+"\""+cheminVideoEntre+"\""+' -r '+valeurNum+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -f mp4 -qscale 1 -y '+"\""+cheminVideoSorti+"\"" 
			###########################################################################################
			'''
			####### Changé le 19/04/09 ################################################################
			commande = cheminFfmpeg+' -r '+valeurNum+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -i '+"\""+cheminVideoEntre+"\""+' -f mp4 -qscale 1 -y '+"\""+cheminVideoSorti+"\""
			###########################################################################################
		
		else:
			'''
			######## Retiré le 19/04/09 ###############################################################
			commande = cheminFfmpeg+' -f image2 -i '+"\""+cheminVideoEntre+"\""+' -r '+valeurNum+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -b 1800 -vcodec '+idCombo+' -qscale 1 -y '+"\""+cheminVideoSorti+"\""
			'''
			####### Changé le 19/04/09 ################################################################
			commande = cheminFfmpeg+' -r '+valeurNum+' -s '+tailleIm[0]+'x'+tailleIm[1]+' -f image2 -i '+"\""+cheminVideoEntre+"\""+' -b 1800 -vcodec '+idCombo+' -qscale 1 -y '+"\""+cheminVideoSorti+"\""
			###########################################################################################
		
		return commande
